<?php
class AdministratorController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Administrator']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;
        
        $getsubusercount = $this->administratorcommon->viewsubuserdbdata($getuserid,$cin);
        //echo '<pre>';print_r($getsubusercount);exit;
        $subusercount = count($getsubusercount);
        $this->view->subusercount = $subusercount;
    }

    public function createsubuserAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;
        
        $this->view->usercompanies = $this->administratorcommon->allotedAdminUserCompanies($getuserid,$cin);
        //echo '<pre>'; print_r($this->view->usercompanies); exit;
        
        // ------------------- Use Compliance Database Start -------------------
        $this->view->gotdepts =  $this->compliancematrixcommon->fetchDepartments();
        //echo '<pre>'; print_r($this->view->gotdepts); exit;
        $this->view->gotlevel =  $this->compliancematrixcommon->fetchLevels();
        //echo '<pre>'; print_r($this->view->gotlevel); exit;
        // ------------------- Use Compliance Database End -------------------        
        
        //$this->view->gotdesig =  $this->companymasterdatacommon->fetchDesignation();
        $this->view->usersections = $this->administratorcommon->allotedAdminUserSections($getuserid,$cin);
        //echo '<pre>'; print_r($this->view->usersections); exit;
    }
    
    public function viewsubuserAction()
    {
        
    }

    public function fetchsubsectionsAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $clickedid    = $this->request->getPost('clickedid', 'trim');
                //echo $clickedid; exit;
                
                $getstatus = $this->administratorcommon->fetchsubsections($getuserid,$cin,$clickedid);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Got Sub Sections', 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Getting Sub Sections');
                    $this->response->setJsonContent($data);
                }
                
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function insertsubuserAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getlength = 10;   
                
                //Note:   $cucompany will be Present only for CORPORATE USERS 
                $cucompany  = $this->request->getPost('cucompany', array('striptags', 'trim'));                
                //echo '<pre>'; print_r($cucompany); exit;
                //$cucompany = implode(',', $cucompany);
                //echo $cucompany; exit;
                
                $firstname  = $this->request->getPost('cufirstname', array('striptags', 'trim'));
                $lastname   = $this->request->getPost('culastname', array('striptags', 'trim'));
                $firstnamecheck =  $this->elements->allownumalphahyphen($firstname);
                $lastnamecheck  =  $this->elements->allownumalphahyphen($lastname);
                $username   = $firstname.' '.$lastname;

                $email      = strtolower($this->request->getPost('cuemail', array('trim')));
                $emailcheck = $this->validationcommon->emailvalidate($email);
                
                $mobile     = $this->request->getPost('cumobile','trim');
                $gender     = $this->request->getPost('cugender','trim');                 
                $cudepartment   = $this->request->getPost('cudepartment','trim');  
                $cudesignation  = $this->request->getPost('cudesignation','trim');
                $culevel    = $this->request->getPost('culevel','trim');
                $curemdays  = $this->request->getPost('curemdays','trim');
                
                $cusection  = $this->request->getPost('cusection','trim');
                //echo '<pre>'; print_r($cusubsection); exit;                
                $cusubsection  = $this->request->getPost('cusection','trim');
                //echo '<pre>'; print_r($cusubsection); exit;                
                             
                $cudepartment = implode(',', $cudepartment);
                $cusubsection = implode(',', $cusubsection);
                //echo $cudepartment; exit;
                
                if(empty($firstname))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Your First Name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($lastname))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Your Last Name');
                    $this->response->setJsonContent($data);
                }
                else if($firstnamecheck==true)
                {
                    $data = array("logged" => false,'message' => 'Your Firstname Contains Special Character');
                    $this->response->setJsonContent($data);
                }
                else if($lastnamecheck==true)
                {
                    $data = array("logged" => false,'message' => 'Your Lastname Contains Special Character');
                    $this->response->setJsonContent($data);
                }
                else if($email==false)
                {
                    $data = array("logged" => false,'message' => 'Your Email is not valid');
                    $this->response->setJsonContent($data);
                }
                else if($emailcheck==false)
                {
                    $data = array("logged" => false,'message' => 'Your Email is not valid','fieldname'=>'emailrrormsg','actualvalue'=>$email);
                    $this->response->setJsonContent($data);
                    $this->response->send();
                }
                else if(empty($gender) || ($gender!=('1' || '2')))
                {
                    $data = array("logged" => false,'message' => 'Not valid Gender');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $passgene = $this->validationcommon->randomcodegen_capsalphanum($getlength);
                    $pwdemail = $passgene;
                    //echo $pwdemail; exit;
                    $saltget      = ($salt = substr(md5(uniqid(rand(), true)), 0, 9));
                    $password      = (sha1($salt . sha1($salt . sha1($passgene)))) ;

                    if($user_group_id==4)   //CorpUsers (Company CIN is Important Here)
                    {
                        $getstatus = $this->administratorcommon->insertsubuserCorp($getuserid,$cin,$user_group_id, $cucompany,  $username, $firstname, $lastname, $email, $mobile, $gender, $cudepartment, $cudesignation, $culevel, $curemdays, $cusection, $cusubsection, $pwdemail, $password, $saltget);
                        //echo '<pre>';print_r($getstatus);exit;
                    }
                    else    //OtherUsers
                    {
                        $getstatus = $this->administratorcommon->insertsubuser($getuserid,$cin,$user_group_id, $username, $firstname, $lastname, $email, $mobile, $gender, $cudepartment, $cudesignation, $culevel, $curemdays, $cusection, $cusubsection, $pwdemail, $password, $saltget);
                        //echo '<pre>';print_r($getstatus);exit;
                    }
                  
                    if($getstatus['logged']==true)
                    {
                        $data = array("logged" => true,'message' => 'SubUser Created Successfully');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'SubUser Not Created');
                        $this->response->setJsonContent($data);
                    }
                }
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    
    public function viewsubuserdbdataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //$clickedid = $this->request->getPost('clickedid');
                //echo $clickedid; exit;

                $getstatus = $this->administratorcommon->viewsubuserdbdata($getuserid,$cin);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }    
    
    public function fetchsubuseraccessAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $wruid = $this->request->getPost('wruid','trim');
                $type = $this->request->getPost('type','trim');
                //echo $wruid; exit;

                $getdata = $this->administratorcommon->fetchsubuseraccess($getuserid,$cin,$wruid,$type);
                
                $appendhtml = '';   
                
                if(!empty($getdata))
                {   
                    if($type=='company')
                    {
                        $appendhtml .='<table class="tblcss"><tr class="trcss"><th class="datacss1">Company</th><th class="datacss2">CIN</th></tr>';                    
                        foreach($getdata as $key => $val)
                        {
                            $appendhtml .='<tr>';
                            $appendhtml .='<td class="datacss1">'.$val['company_name'].'</td>';
                            $appendhtml .='<td class="datacss2">'.$val['company_cin'].'</td>';
                            $appendhtml .='</tr>';
                        }
                        $appendhtml .='</table>';
                        $appendhtml .='<div class="clearelement"></div>';

                        $finaldata = $appendhtml;
                        //echo $finaldata.'<br>; exit;
                    }
                    else if($type=='section')
                    {
                        $appendhtml .='<table class="tblcss"><tr class="trcss"><th class="datacss">Section Access</th></tr>';
                        foreach($getdata as $key => $val)
                        {
                            $appendhtml .='<tr>';
                            $appendhtml .='<td class="datacss">'.$val['category_name'].'</td>';
                            $appendhtml .='</tr>';
                        }
                        $appendhtml .='</table>';
                        $appendhtml .='<div class="clearelement"></div>';

                        $finaldata = $appendhtml;
                        //echo $finaldata.'<br>; exit;
                    }                    
                    
                    $data = array("logged" => true,'message' => 'Got Your data' , 'datahtml'=> $finaldata);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found ..!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function deletesubuserentryAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $getuserid.'*'.$cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $wruid = $this->request->getPost('wruid','trim');
                $master_user_id = $this->request->getPost('master_user_id','trim');
                $master_cin = $this->request->getPost('master_cin','trim');
                //echo $wruid; exit;

                $getstatus = $this->administratorcommon->deletesubuserentry($getuserid,$cin,$wruid,$master_user_id,$master_cin);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'SubUser Deleted Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Deleting SubUser');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    

}
