<?php
class AlldocumentController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['websitetitle']);
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthsadmin['id'];
        //print_r( $this->session->loginauthsadmin);exit;
        parent::initialize();
    }

    public function indexAction()
    {
       $this->view->getgmdoctypetree = $this->alldocumentcommon->fetchgmdoctypestree();
    }

    public function getdocssessionAction(){
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                    $doc_data = $this->request->getPost("docs_id",'trim');
                    //echo '<pre>'; print_r($doc_data); exit;
                    $doc_data_imp =  implode(",",$doc_data);

                     $setsession = $this->session->set
                     ('docid',array('docid' => trim($doc_data_imp) ));

                   $data = array("logged" => true,'message' => 'Found ');
                   $this->response->setJsonContent($data);
                   $this->response->send();

            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getdocAction(){
         $docid = $this->session->docid['docid'];
        //echo '<pre>'; print_r($docid); exit;
         $this->view->getdocdata = $this->boardmeetingdoccommon->getdocdata($docid);
    }

    public function allgetdocdetailsAction(){
          $docid = $this->session->docid['docid'];
        //echo '<pre>'; print_r($docid); exit;
    }

    public function allgetdocdetailstep1sessionAction(){

        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $dateofmeeting = $this->request->getPost('dateof','trim');
               // echo $date; exit;
                $timeofmeeting = $this->request->getPost('timeof','trim');
                //echo $time; exit;
                $setsession = $this->session->set
                     ('dateofmeeting',array('dateofmeeting' => trim($dateofmeeting) ));
                 $setsession = $this->session->set
                     ('timeofmeeting',array('timeofmeeting' => trim($timeofmeeting) ));
                $data = array("logged" => true,'message' => 'Found ');
                    $this->response->setJsonContent($data);
                     $this->response->send();
            }
        }

    }

    public function allgetdocdetailcompAction(){
        $docid = $this->session->docid['docid'];
        $dateofmeeting = $this->session->dateofmeeting['dateofmeeting'];
        $timeofmeeting = $this->session->timeofmeeting['timeofmeeting'];
        $cin = $this->session->memberdoccin;;
        $this->view->getdirdata = $this->alldocumentcommon->getdirdata($cin);
        //echo '<pre>'; print_r($this->view->getdirdata); exit;
            //echo $cin; exit;
    }

    public function allgetdocdetailagendasessionAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $sign_res = $this->request->getPost('sign_res','trim');
                $sign_res_val = $this->request->getPost('sign_res_val','trim');

                $dirname = $this->request->getPost('dir_name_din_details_info','trim');
                $occdir = $this->request->getPost('occupied_director','trim');
                $leavedir = $this->request->getPost('leave_director','trim');
                $leavedirval = $this->request->getPost('leave_director_val','trim');
                $who_will_sign = $this->request->getPost('who_will_sign','trim');
                $who_will_sign_val = $this->request->getPost('who_will_sign_val','trim');


                $setsession = $this->session->set
                     ('dirname',array('dirname' => trim($dirname) ));
                $setsession = $this->session->set
                     ('occdir',array('occdir' => trim($occdir) ));
                $setsession = $this->session->set
                     ('leavedir',array('leavedir' => trim($leavedir) ));
                $setsession = $this->session->set
                     ('signres',array('signres' => trim($sign_res) ));
                $setsession = $this->session->set
                     ('signresval',array('signresval' => trim($sign_res_val) ));
                 $setsession = $this->session->set
                     ('who_will_sign',array('who_will_sign' => trim($who_will_sign) ));
                 $setsession = $this->session->set
                     ('who_will_sign_val',array('who_will_sign_val' => trim($who_will_sign_val) ));


                $data = array("logged" => true,'message' => 'Found');
                    $this->response->setJsonContent($data);
                     $this->response->send();
            }
        }
    }

    public function allgetdocdetailagendaAction(){
         $docid = $this->session->docid['docid'];
        $cin = $this->session->memberdoccin;;
        $this->view->cin = $this->session->memberdoccin;;
        $this->view->docid = $this->session->docid['docid'];
        $this->view->leavedir = $this->session->who_will_sign['who_will_sign'];
        $this->view->leavedirval = $this->session->who_will_sign_val['who_will_sign_val'];
       // echo $cin; exit;
        $this->view->getagenda = $this->boardmeetingdoccommon->getdocdetails($docid,$cin);

    }
    public function allgetdocdetailminutesessionAction()
    {

         $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $agendadata = $this->request->getPost('agenda_data','trim');
                //echo '<pre>'; print_r($agendadata); exit;
                $setsession = $this->session->set
                     ('agendadata',array('agendadata' => trim($agendadata) ));

                $data = array("logged" => true,'message' => 'Found ');
                    $this->response->setJsonContent($data);
                     $this->response->send();
            }
        }


    }

    public function allgetdocdetailminutesAction(){
          $docid = $this->session->docid['docid'];
          $cin = $this->session->memberdoccin;;
            //echo $docid; exit;
        $this->view->getagenda = $this->boardmeetingdoccommon->getdocdetails($docid, $cin);
    }

    public function allgetdocdetailresessionAction(){

         $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $minutesdata = $this->request->getPost('minutes_data','trim');
                //echo '<pre>'; print_r($agendadata); exit;
                $setsession = $this->session->set
                     ('minutesdata',array('minutesdata' => trim($minutesdata) ));

                $data = array("logged" => true,'message' => 'Found ');
                    $this->response->setJsonContent($data);
                     $this->response->send();
            }
        }


    }

    public function allgetdocdetailresAction(){
        $this->session->remove('ses_arr');
        $this->session->remove('form_id');
        $docid1 = $this->session->docid['docid'];
        $docid1 = (explode(',',$docid1));
        $docid = array();
        foreach($docid1 as $key => $val){

                $docid[] = $val - 3;

        }
       // echo $docid; exit;
     // echo implode(',',$docid); exit;

        $cin = $this->session->memberdoccin;;
        $signres = $this->session->signres['signres'];
        $signresval = $this->session->signresval['signresval'];
        //echo $signresval; exit;

        //echo '<pre>'; print_r($docid); exit;
        //$getid = explode(',',$docid);
               foreach ($docid as $item) {
                    echo $item.'<br>';
                    $getre[] = $get.$this->alldocumentcommon->getdocres($item,$cin);
                    $getarryitem = $item;
                }
        $this->view->getarry = $getre;
         $this->view->getarryitem = $getservid;
        //echo '<pre>'; print_r($getre); exit;
               // exit;


    }



     public function getresolutionformAction(){
          $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;;
        $signresval = $this->session->signresval['signresval'];
        $getuser_grp_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $array_push = array();
                $array_bush = array();
                $getoldarrayfrm = array();
                $form_id = $this->request->getPost('form_id');
                //echo '<pre>'; print_r($form_id); exit;
                $array_push = isset($this->session->form_id) ? $this->session->form_id : $array_push ;
                $getoldarrayc= count($array_push);
                //echo $getoldarrayc;exit;
                foreach($form_id as $key => $value)
                {
                    $form_idnw[$value['name']]= $value['value'];
                }

                $valutoy = array('form_id' => $form_idnw );

                //echo '<pre>';print_r($valutoy);exit;
                $getoldarrayfrm = array();
                if($getoldarrayc==0)
                {
                    $this->session->set('form_id',$valutoy);
                    //array_push($array_push,$valutoy);
                }
                else
                {
                    $getoldarrayfrm = $this->session->form_id;
                    //array_shift($getoldarrayfrm);
                    if(count($getoldarrayfrm)>1)
                    {
                        foreach($getoldarrayfrm as $kgy => $goldfrm)
                        {
                            $getoldfrmnw[] = $goldfrm;
                        }
                    }
                    else
                    {
                        $getoldfrmnw[] = $getoldarrayfrm;
                    }

                    array_push($getoldfrmnw,$valutoy);
                    $this->session->remove('form_id');
                    $this->session->set('form_id',$getoldfrmnw);
                }
                //echo '<pre>';print_r($getoldarrayfrm);exit;
               //echo '<pre>';print_r($getoldarrayfrm);exit;

               //echo '<pre>'; print_r($this->session->form_id); exit;


                $service_id = $this->request->getPost('id','trim');

                //echo $service_id;exit;
                $resolutiontype_id = $this->request->getPost('res_type_id','trim');
                //echo $resolutiontype_id; exit;

                //$cin = $this->request->getPost('getcirnnum');

                $getres = $this->getserviceformcommon->getresolutionform($service_id,$resolutiontype_id);
                //echo '<pre>'; print_r($getres); exit;


                if($getuser_grp_id=='3' || $getuser_grp_id=='5')
                {
                    $getcount = $this->getserviceformcommon->getresolutionaccess($service_id,$getuser_grp_id,'config_vcs_resolution');

                    if($getcount==false)
                    {
                        $data = array("logged" => false,'message' => 'This is not a part of Demo please click below to make payment and get full access <div class="btn btn-primary"><a href="billingplans/payonline">Pay now</a></div>');
                        $this->response->setJsonContent($data);
                        $this->response->send();
                        exit;
                    }
                }
                        $getdirectoryname = $this->session->profilecommondir['createdirname'];
                        $dir = $this->pdfdownloadresolutiondir.'/';
                        $upload_dir = $dir.$getdirectoryname;
                        $upload_dir_pdf = $dir.$getdirectoryname;

                        $getcurrentyear = date("Y");
                        $getcurrentmonth = date("M");
                        $getcurrentdate = date("Y-m-d");

                        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                        $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                        $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                        $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}

                        if($service_id)
                        {

                            if($getres)
                            {
                                $data = array("logged" => true,'message' => 'Got Your data','data'=>$getres,'dir'=>$final_dir, 'cin'=>$cin, 'din'=>$signresval);
                                $this->response->setJsonContent($data);
                            }
                            else
                            {
                                $data = array("logged" => false,'message' => 'You have reached maximum number of tries');
                                $this->response->setJsonContent($data);
                            }
                        }
                        else
                        {
                            $data = array("logged" => false,'message' => 'Got Your data');
                            $this->response->setJsonContent($data);
                        }



                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }

     public function getreformelementAction(){
        //echo 'here';
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $cin = $this->request->getPost('cin','trim');
                //echo $cin; exit;
                $getfullstrin = $this->request->getPost('getfullstrin','trim');
                //echo '<pre>'; print_r($getfullstrin); exit;
                //echo $getfullstrin; exit;
                $service_id = $this->request->getPost('getserviceid','trim');
                 //echo $service_id; exit;

               $getdinid = $this->request->getPost('getdinid','trim');
                //echo $getdinid; exit;
                $pdf_content = $this->request->getPost('htmldatda');
                //echo '<pre>'; print_r($pdf_content); exit;

                $newarray = $this->getresolutioncommon->fetchfullstrin($getfullstrin);

                //echo '<pre>'; print_r($newarray); exit;

                $getservalue = $this->alldocumentcommon->fetchservicevalue($service_id);
                //echo '<pre>'; print_r($getservalue); exit;
                $rownxt = $this->getresolutioncommon->fetchcin($cin);
                $row_din = $this->getresolutioncommon->fetchdininfo($getdinid,$cin);
                $row_pdf = $this->getresolutioncommon->pdfcontent($service_id);


                if(sizeof($newarray) == sizeof($getservalue))
                {
                    $commonarraymerge = array_combine($getservalue,$newarray);
                    $companyname = preg_replace("/[^a-zA-Z]+/", "", strtolower($rownxt['company_name'])); ;
                    $servicename = preg_replace("/[^a-zA-Z]+/", "", $row_pdf['servicename']);

                    $getre = $this->customerusercommon->updateresolutionentry($getuserid,$rownxt[0],'config_vcs_resolution',$service_id); //new added

                    if($getre['logged']==true)
                    {$getnidm= $getre['idget'];}else
                    {$getnidm=''; }

                    //$getpdfpath = $this->dompdfgen->getpdf($pdf_content,$servicename,$companyname);
                    $data = array("logged" => true,'message' => 'Got Your data','data'=>$commonarraymerge,
                                  'cin'=>$rownxt[0],
                                  'regaddr'=>$rownxt[1],
                                  'companame'=>$rownxt[2],
                                  'roc_state'=>$rownxt[3],
                                  'din_name'=>$row_din[1],
                                  'din_des'=>$row_din[2],
                                  'din_addr'=>$row_din[3],
                                  'trckid'=>$getnidm
                                 );
                    //echo '<pre>'; print_r($data); exit;
                    $this->response->setJsonContent($data);

                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong!!! Please wait we are upgrading something.');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }

    public function alldocumentgeneratepdfAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $getpdfpath = array();

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $getpdfpathagenda = $this->session->getpdfpathagenda['getpdfpathagenda'];
                //echo '<pre>'; print_r($getpdfpathagenda); exit;
                $pdf_content = $this->request->getPost('htmldata');
                $gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking
                 $service_id = $this->request->getPost('service_id');
                //echo $service_id; exit;

                if(!empty($getuserid))
                {
                /*-------------------- Create Directory For User Tracking ----------------------*/
                $getdirectoryname = $this->session->profilecommondir['createdirname'];
                $dir = $this->pdfdownloadalldocumentdir.'/';
                $upload_dir = $dir.$getdirectoryname;
                $upload_dir_pdf = $dir.$getdirectoryname;
               // echo $getdirectoryname; exit;

                $getcurrentyear = date("Y");
                $getcurrentmonth = date("M");
                $getcurrentdate = date("Y-m-d");

                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}

                $getpdfpath = $this->dompdfgen->getpdf($pdf_content,configalldocument,configalldocument,'configalldocument');
                 //echo '<pre>'; print_r($getpdfpath) ; exit;

                    $this->session->remove('alldocumentsession');
                    $this->session->set('alldocumentsession',array('path' => $getpdfpath));

                    $getpdfpath = trim($this->session->alldocumentsession['path']);
                    $getpdfpathmnarray = array();

                    array_push($getpdfpathmnarray,$getpdfpath);
                    //echo '<pre>';print_r($getpdfpathmnarray);exit;

                    //echo '<pre>'; print_r($setsession) ; exit;

                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData

                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpath, 'serv_id'=>$service_id, 'agendapdfpath'=>$getpdfpathagenda);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }
    
    public function alldocumentgenerateagendapdfAction(){
        
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $getpdfpath = array();

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

               // $getpdfpathagenda = $this->session->getpdfpathagenda['getpdfpathagenda'];
                //echo '<pre>'; print_r($getpdfpathagenda); exit;
                $pdf_content = $this->request->getPost('htmldata');
                //$gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking
                 $service_id = $this->session->docid['docid'];
                  //echo '<pre>'; print_r($service_id); exit;
                //$service_id = implode(',',$service_id);
                //echo $service_id; exit;

                if(!empty($getuserid))
                {
                /*-------------------- Create Directory For User Tracking ----------------------*/
               // $getdirectoryname = $this->session->profilecommondir['createdirname'];
                //$dir = $this->pdfdownloadalldocumentdir.'/';
               // $upload_dir = $dir.$getdirectoryname;
               // $upload_dir_pdf = $dir.$getdirectoryname;
               // echo $getdirectoryname; exit;

               // $getcurrentyear = date("Y");
                //$getcurrentmonth = date("M");
               // $getcurrentdate = date("Y-m-d");

               /* if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}*/

                $getpdfpath = $this->dompdfgen->getpdf($pdf_content,configalldocument,configalldocument,'configalldocument');
                 //echo '<pre>'; print_r($getpdfpath) ; exit;

                    $this->session->remove('alldocumentsession');
                    $this->session->set('alldocumentsession',array('path' => $getpdfpath));

                    $getpdfpath = trim($this->session->alldocumentsession['path']);
                    $getpdfpathmnarray = array();

                    array_push($getpdfpathmnarray,$getpdfpath);
                    //echo '<pre>';print_r($getpdfpathmnarray);exit;

                    //echo '<pre>'; print_r($setsession) ; exit;

                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                        //$this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData

                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpath, 'serv_id'=>$service_id, 'agendapdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }

    public function finishsessionAction(){
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];

        //$minutessession = $this->session->minutesdata['minutesdata'];
        //echo '<pre>'; print_r($minutessession); exit;
       // $agendasession = $this->session->agendadata['agendadata'];

        $getres = $this->request->getPost('mnget');
        $this->session->set('alldocumentsession',array('path' => $getres));
      // echo '<pre>'; print_r($getres); exit;
       //$getdirectoryname = $this->session->profilecommondir['createdirname'];
    }

    public function finishAction(){
        $this->view->disable();
        //$connection = $this->db;
        //$getres = $this->session->alldocumentsession['path'];
        $getres = $this->request->getPost('mnget');
        //echo '<pre>';print_r($getres);exit;
        $zip = new ZipArchive();
        $time= time();
        /*$dompdf = new DOMPDF();*/
        $getrandomcode = $this->validationcommon->randomcodegen_capsalphanum(10);
        if(!empty($getrandomcode))
        {$getrandomcode = $getrandomcode;}
        else
        {$getrandomcode = 'codeedforencryption';}
        $getidsession = $this->session->getId();
        //echo $getidsession;exit;
        /*-------------------- Create Directory For User Tracking ----------------------*/

        $getdirectoryname = $this->session->profilecommondir['createdirname'];
        $dir = $this->pdfdownloadalldocumentdir.'/';
        $upload_dir = $dir.$getdirectoryname;
        $upload_dir_pdf = $dir.$getdirectoryname;
        // echo $getdirectoryname; exit;

        $getcurrentyear = date("Y");
        $getcurrentmonth = date("M");
        $getcurrentdate = date("Y-m-d");

        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
        $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
        $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
        $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
        if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}

        $getdirzip = $upload_dir.'/zip';
        if(!is_dir($getdirzip)){mkdir($getdirzip, 0777);chmod($getdirzip, 0777);}

        /*-------------------- Create Directory For User Tracking End here ----------------------*/

        $filename = 'ConsultlaneVCS-'.$getidsession.'-'.$time.'-'.$getrandomcode;

       // $zip = new ZipArchive();
        $zip_name = $getdirzip.'/'.$filename.".zip"; // Zip name
       //echo $zip_name; exit;
        $filenameog = $filename.".zip";
        $zip->open($zip_name,  ZipArchive::CREATE);
        foreach ($getres as $file) {
          $path = $file;
          if(file_exists($path)){
             //echo 'New-file-'.$path.'<br>';
            $zip->addFromString(basename($path),  file_get_contents($path));
              $dataget = true;
          }
          else{
             // echo "file does not exist";
              $dataget = false;
          }
        }
    
         $zip->close();
        //return $zip_name;exit;

        /*header("Cache-Control: public");
        header("Content-Description: File Transfer");
        header("Content-Disposition: attachment; filename=$filenameog");        
        header("Content-Length:".filesize($filenameog));
        header("Content-Type: application/zip");
        header("Content-Transfer-Encoding: binary");*/

        //read the file from disk
        //readfile($zip_name);
       // return $this->xmlurl.$zip_name;
        
        if(isset($zip_name)){
            //echo 'here'; exit;
            $data = array("logged" => true,'message' => 'You can Download ZIP pdf of all document','pdfpath'=>$zip_name,'getfile'=>$dataget);
            $this->response->setJsonContent($data);
            
        }
        else{
            $data = array("logged" => false,'message' => 'You cannot Download pdf of All document');
            $this->response->setJsonContent($data);
        }
        $this->response->send();
       // $connection->close();

       
       // echo '<pre>';print_r($getres); exit;

    }
    public function generateagendapdfAction(){
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $pdf_content = $this->request->getPost('htmldata');
                //echo $pdf_content; exit;
                $gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking CustomerData
                //echo $gettrackidfor; exit;

                if(!empty($pdf_content))
                {
                    $getpdfpathagenda = $this->dompdfgen->getpdf($pdf_content,'','','configagenda');
                   //echo '<pre>'; print_r($getpdfpathagenda); exit;
                    if(!empty($getpdfpathagenda) || $getpdfpathagenda)
                    {

                     $setsession = $this->session->set
                     ('getpdfpathagenda',array('getpdfpathagenda' => trim($getpdfpathagenda) ));
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData

                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpathagenda);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpathagenda);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function generateagendaAction(){

        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $getid = $this->request->getPost('getid');
                $getidsep = implode(',', $getid);
                //echo '<pre>'; print_r($getid); exit;

                if(!empty($getidsep))
                {

                    $getagendadata = $this->alldocumentcommon->getagendadata($getidsep);
                   //echo '<pre>'; print_r($getagendadata); exit;
                    if(!empty($getpdfpathagenda) || $getpdfpathagenda)
                    {

                     $setsession = $this->session->set
                     ('getpdfpathagenda',array('getpdfpathagenda' => trim($getpdfpathagenda) ));
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData

                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpathagenda);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpathagenda);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }

    public function generateagendasessionAction()
    {        
      $connection = $this->db;
    $this->view->disable();
      $sesarray = $this->session->form_id ;
      //echo '<pre>'; print_r($sesarray); exit;   
      $docid = $this->session->docid['docid'];
      //echo '<pre>'; print_r($docid); exit;        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                if(!empty($docid))
                {
                     //echo '<pre>'; print_r($docid); exit; 
                     $getagenda = $this->alldocumentcommon->getagendadatadetails($docid);    
                    //echo '<pre>'; print_r($getagenda); exit; 
                    foreach($getagenda as $key=>$value){
                        $key_val[] = $value['res_html_id'];                        
                    }
                    //echo '<pre>'; print_r($key_val); exit; 
                    foreach($key_val as $keyn => $valuen){
                        //echo $valuen.'<br>';
                        $g[$valuen] = $this->myfunarrayneedle($valuen, $sesarray, 'form_id');      
                    }                   
                   //echo '<pre>'; print_r($g);exit; 
                    
                     foreach($getagenda as $key=>$value){
                        $key_val_res[] = $value['agenda_res_val'];                        
                    }
                    //echo '<pre>'; print_r($key_val_res);exit;
                    $j=0;
                    foreach($g as $keyf => $valuef){
                        $key_val_res_agenda[$key_val_res[$j]] = $valuef;    
                        $j++;
                    }
                    //echo '<pre>'; print_r($key_val_res_agenda);exit;
                    $get_doc_type_id = 4;
                    $getagendatree = $this->boardmeetingdoccommon->getdocform($get_doc_type_id);
                    //echo '<pre>'; print_r($getagendatree); exit;
                         if(!empty($getagendatree))
                        {
                        //echo 'here'; exit;
                        $data = array("logged" => true,'message' => 'Got Your data','data'=>$getagendatree, 'data_arr'=>$key_val_res_agenda);
                        $this->response->setJsonContent($data);
                        }
                        else
                        {
                            $data = array("logged" => false,'message' => 'Cant Got Your data');
                            $this->response->setJsonContent($data);
                        }

                        $this->response->send();
                        $connection->close();                   
                    
                    
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong please contact');
                    $this->response->setJsonContent($data);
                    
                }
                
            }
            else
            {
                 exit('No direct script access allowed');
                    $connection->close();
            }
            
            
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
             
     }
    public function myfunarrayneedle($id, $array, $field)
    {
        //echo '<pre>'; print_r(count($array)); exit;
        if(count($array)==1)
        {
            $val = $array[$field][$id];
            return $val;
        }
        else
        {
           foreach($array as $keymn => $valuesmn) { 
               if (array_key_exists($id,$valuesmn[$field]))
                  {
                    $val = $valuesmn[$field][$id];
                    return $val;
                  }           
               //echo $val.'<br>';
           }  
        }
       
        return null;
        //exit;       
    }
    public function directordataAction(){
        
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {              
                $occupied_director_val = $this->session->who_will_sign_val['who_will_sign_val'];
               // echo $occupied_director_val; exit;
            
                if(!empty($getuserid))
                {
                    $getdirinfo = $this->alldocumentcommon->getdiradddes($occupied_director_val);
                    
                   // echo '<pre>'; print_r($getdirinfo); exit;
                   

                    if(!empty($getdirinfo) )
                    {                        
                        $data = array("logged" => true, 'message' => 'Found', 'data'=>$getdirinfo);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'BC Nhi mila');
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    public function generateminutessessionAction(){
        
         $connection = $this->db;
        $this->view->disable();
        $sesarray = $this->session->form_id ;
        //echo '<pre>'; print_r($sesarray); exit;   
        $docid = $this->session->docid['docid'];
         //echo '<pre>'; print_r($docid); exit; 
        
        $dirname = $this->session->dirname['dirname'];
        //echo '<pre>'; print_r($dirname); exit;
        $occdir = $this->session->occdir['occdir'];
        //echo '<pre>'; print_r($occdir); exit;
        $leavedir = $this->session->leavedir['leavedir'];
       // echo '<pre>'; print_r($leavedir); exit;
            
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                if(!empty($docid))
                {
                     //echo '<pre>'; print_r($docid); exit; 
                     $getagenda = $this->alldocumentcommon->getminutesdatadetails($docid);    
                    //echo '<pre>'; print_r($getagenda); exit; 
                    foreach($getagenda as $key=>$value){
                        $key_val[] = $value['res_html_id'];                        
                    }
                    //echo '<pre>'; print_r($key_val); exit; 
                    foreach($key_val as $keyn => $valuen){
                        //echo $valuen.'<br>';
                        $g[$valuen] = $this->myfunarrayneedle($valuen, $sesarray, 'form_id');      
                    }                   
                   //echo '<pre>'; print_r($g);exit; 
                    
                     foreach($getagenda as $key=>$value){
                        $key_val_res[] = $value['minutes_res_val'];                        
                    }
                   // echo '<pre>'; print_r($key_val_res);exit;
                    $j=0;
                    foreach($g as $keyf => $valuef){
                        $key_val_res_agenda[$key_val_res[$j]] = $valuef;    
                        $j++;
                    }
                    //echo '<pre>'; print_r($key_val_res_agenda);exit;
                    $get_doc_type_id = 1;
                    $getagendatree = $this->boardmeetingdoccommon->getdocform($get_doc_type_id);
                    //echo '<pre>'; print_r($getagendatree); exit;
                         if(!empty($getagendatree))
                        {
                        //echo 'here'; exit;
                        $data = array("logged" => true,'message' => 'Got Your data','data'=>$getagendatree, 'data_arr'=>$key_val_res_agenda, 'present'=>$dirname, 'occdir'=>$occdir, 'leavedir'=>$leavedir);
                        $this->response->setJsonContent($data);
                        }
                        else
                        {
                            $data = array("logged" => false,'message' => 'Cant Got Your data');
                            $this->response->setJsonContent($data);
                        }

                        $this->response->send();
                        $connection->close();                   
                    
                    
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong please contact');
                    $this->response->setJsonContent($data);
                    
                }
                
            }
            else
            {
                 exit('No direct script access allowed');
                    $connection->close();
            }
            
            
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    public function alldocumentgenerateminutespdfAction(){
        //echo 'i m here'; exit;
         $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $getpdfpath = array();

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {              
                $pdf_content = $this->request->getPost('htmldata'); 
                //echo $pdf_content; exit;
                
                 $service_id = $this->session->docid['docid'];  
               // echo $service_id; exit;
                if(!empty($getuserid))
                {           

                $getpdfpath = $this->dompdfgen->getpdf($pdf_content,configalldocument,configalldocument,'configalldocument');
                 //echo '<pre>'; print_r($getpdfpath) ; exit;

                    $this->session->remove('alldocumentsession');
                    $this->session->set('alldocumentsession',array('path' => $getpdfpath));

                    $getpdfpath = trim($this->session->alldocumentsession['path']);
                    $getpdfpathmnarray = array();

                    array_push($getpdfpathmnarray,$getpdfpath);
                    //echo '<pre>';print_r($getpdfpathmnarray);exit;

                    //echo '<pre>'; print_r($setsession) ; exit;

                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                      
                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpath, 'serv_id'=>$service_id, 'agendapdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }

}
