<?php
class CaseresearchController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Case Research']);

        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {

    }

    public function tribunalAction()
    {

    }

    public function searchjudgementsAction()
    {

    }

    public function highcourtAction(){
         $court_id = $this->request->get('id');

        if(isset($court_id)){

             $this->view->searchjudgements = $this->caseresearchcommon->getcourtdetails($court_id);
            echo '<pre>'; print_r($this->view->searchjudgements); exit;
        }
        else{
              exit('No direct script access allowed -to this area');
             $connection->close();
        }
    }

    public function getcourtdetailsAction(){

         $this->view->disable();
        $getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $court_id = $this->request->getPost('court_id');


                //echo $last_param; exit;

                if($court_id){

                    $getcourtdetails = $this->caseresearchcommon->getcourtdetails($court_id);

                   //echo '<pre>'; print_r($getcourtdetails); exit;

                    if($getcourtdetails){
                         $data = array("logged" => true,'message' => 'Found','data'=>$getcourtdetails);
                         $this->response->setJsonContent($data);
                    }
                    else{
                         $data = array("logged" => true,'message' => 'Not Found');
                         $this->response->setJsonContent($data);
                    }
                }
                else{
                      $data = array("logged" => true,'message' => 'Entry Cannot Exist');
                      $this->response->setJsonContent($data);
                }




                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }

    public function getcourtdataAction(){

         $this->view->disable();
        $getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $clientname = $this->request->getPost('clientname');

                $judgename = $this->request->getPost('judgename');

                $start_dateofcase = $this->request->getPost('start_dateofcase');

                $end_dateofcase = $this->request->getPost('end_dateofcase');

                $start_dateofjudgement = $this->request->getPost('start_dateofjudgement');

                $end_dateofjudgement = $this->request->getPost('end_dateofjudgement');

                $last_param = $this->request->getPost('last_param');
                //echo $last_param; exit;

                if($last_param){

                    $getdata = $this->caseresearchcommon->getcourtdata($clientname, $judgename, $start_dateofcase,$end_dateofcase,$start_dateofjudgement,$end_dateofjudgement,$last_param);

                   // echo '<pre>'; print_r($getdata); exit;

                    if($getdata){
                         $data = array("logged" => true,'message' => 'Found','data'=>$getdata);
                         $this->response->setJsonContent($data);
                    }
                    else{
                         $data = array("logged" => true,'message' => 'Not Found');
                         $this->response->setJsonContent($data);
                    }
                }
                else{
                      $data = array("logged" => true,'message' => 'Entry Cannot Exist');
                      $this->response->setJsonContent($data);
                }




                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    public function getallresult($keywordget,$limitget,$hc,$sup,$trib,$s_skip)
    {       //echo $keywordget;exit;
                $getuserid = $this->session->loginauths['id'];
                // English Configuration
                $my_server = "http://".getenv("SERVER_NAME").":".getenv("SERVER_PORT").$this->url->getBaseUri().'/mainadminhtml'; // Your Server (generally no changes needed)
                $my_root = getenv("DOCUMENT_ROOT").$this->url->getBaseUri().'/mainadminhtml'; // Your document root (generally no changes needed)

                $s_dirs = array($sup,$hc,$trib); // Which directories should be searched ("/dir1","/dir2","/dir1/subdir2","/Verzeichniss2/Unterverzeichniss2")? --> $s_dirs = array(""); searches the entire server
                $s_skip = array(".","supreme_court_html"); // Which files/dirs do you like to skip?
                $s_files = "html|htm|HTM|HTML|php3|php4|php|txt"; // Which files types should be searched? Example: "html$|htm$|php4$"
                $min_chars = "3"; // Min. chars that must be entered to perform the search
                $max_chars = "30"; // Max. chars that can be submited to perform the search
                $default_val = "Search phrase"; // Default value in searchfield
                $limit_hits = array("5","10","25","50","100"); // How many hits should be displayed, to suppress the select-menu simply use one value in the array --> array("100")
                $message_1 = "Invalid Search term!"; // Invalid searchterm
                $message_2 = "Please enter at least '$min_chars', highest '$max_chars' characters."; // Invalid searchterm long ($min_chars/$max_chars)
                $message_3= "Your searchresult for:"; // Headline searchresults
                $message_4 = "Sorry, no hits."; // No hits
                $message_5 = "results"; // Hits
                $message_6 = "Match case"; // Match case
                $no_title = "No Title"; // This should be displayed if no title or empty title is found in file
                $limit_extracts_extracts = ""; // How many extratcts per file do you like to display. Default: "" --> every extract, alternative: 'integer' e.g. "3"
                $byte_size = "51200"; // How many bytes per file should be searched? Reduce to increase speed
                $limit_extracts = "";

                $actionget = 'SEARCH';
                $keywordget = $keywordget;
                //$limitget = 20;

                $HTTP_GET_VARS = array('action'=>$actionget,'keyword'=>$keywordget,'limit'=>$limitget);
                //echo '<pre>'; print_r($HTTP_GET_VARS);exit;

                $search_headline = $this->caseresearchcommon->search_headline($HTTP_GET_VARS, $message_3);

                $search_error =  $this->caseresearchcommon->search_error($HTTP_GET_VARS, $min_chars, $max_chars, $message_1, $message_2, $limit_hits);

                $search_dir =  $this->caseresearchcommon->search_dir($my_server, $my_root, $s_dirs, $s_files, $s_skip, $message_1, $message_2, $no_title, $limit_extracts, $byte_size, $HTTP_GET_VARS);

                //$search_no_hits =  $this->caseresearchcommon->search_no_hits($HTTP_GET_VARS, $count_hits, $message_4);
                if($search_dir)
                {
                    $g= $search_dir;
                }
                else if($search_error)
                {
                    $g= $search_headline;
                }

                else{$g='';}

                $data = array("logged" => true,
                              'headline'=>$search_headline,
                              'message' => $g);
                return $data;

    }

    public function getallresultnxtAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $page = $this->request->getPost('page','trim');
                $cur_page = $page;
                $page -= 1;
                $per_page = 10;
                
                $start = $page * $per_page;
                //echo $start;exit;
                $judgename = $this->request->getPost('judgename','trim');
                $respondant = $this->request->getPost('respondant','trim');
                $petitioner = $this->request->getPost('petitioner','trim');
                $casenumber = $this->request->getPost('casenumber','trim');
                $checkboxtogglecourt = $this->request->getPost('checkboxtogglecourt','trim');
                $countcourt = count($checkboxtogglecourt);
                $varhighcourt='';$varsupcourt='';$vartrbcourt='';$pathoffilehc='';$pathoffilesup='';$pathoffiletrib='';
                
                if($countcourt!='0')
                {
                    if(in_array('1',$checkboxtogglecourt))
                    {$varhighcourt= 'highcourt';$pathoffilehc='/htmlsearch/high_court_html/';}
                    if(in_array('2',$checkboxtogglecourt))
                    {$varsupcourt= 'supcourt';$pathoffilesup='/htmlsearch/supreme_court_html/';}
                    if(in_array('3',$checkboxtogglecourt))
                    {$vartrbcourt= 'tribunal';$pathoffiletrib='/htmlsearch/trib_court_html/';}
                }
                
                //echo '<pre>';print_r($varhighcourt);exit; 
                
                $searcharray = array('judges'=> $judgename,
                                     'respondent'=> $respondant,
                                     'petitioner'=> $petitioner,'case_number'=> $casenumber);
                $get = $this->caseresearchcommon->getallresultnxt($searcharray,$start, $per_page);
                $count = $get['count'];
                /*$s_skip = array();
if(count($s_skip)=='0')
{
    $getallresult = $this->getallresult($judgename,$per_page,$pathoffilehc,$pathoffilesup,$pathoffiletrib,$s_skip);
    $s_skip = $getallresult['message']['getval'];  
}
else
{
    $getallresult = $this->getallresult($judgename,$per_page,$pathoffilehc,$pathoffilesup,$pathoffiletrib,$s_skip);
}

                
$chfil = $getallresult['message']['chedinfile'];    
                
                foreach($chfil as $valch)
                {
                    $fname[] = $valch['filename'];
                }
                //echo '<pre>';print_r($fname);
                //exit;
                
echo '<pre>';print_r($chfil);exit;   */  
                
$no_of_paginations = ceil($count / $per_page)  ;              
/* ---------------Calculating the starting and endign values for the loop----------------------------------- */
if ($cur_page >= 7) {
    $start_loop = $cur_page - 3;
    if ($no_of_paginations > $cur_page + 3)
        $end_loop = $cur_page + 3;
    else if ($cur_page <= $no_of_paginations && $cur_page > $no_of_paginations - 6) {
        $start_loop = $no_of_paginations - 6;
        $end_loop = $no_of_paginations;
    } else {
        $end_loop = $no_of_paginations;
    }
} else {
    $start_loop = 1;
    if ($no_of_paginations > 7)
        $end_loop = 7;
    else
        $end_loop = $no_of_paginations;
}
/* ----------------------------------------------------------------------------------------------------------- */
                $getpg = $this->elements->paginationhtml($cur_page,$start_loop,$end_loop,$no_of_paginations);  
                
                if($get['data']!='notfound')
                {
                   $data = array("logged" => true,
                              'data'=>$get['data'],
                              'message' => 'Got results',
                              'judgename'=>$judgename,
                              'respondant'=>$respondant,
                              'petitioner'=>$petitioner,
                              'casenumber'=>$casenumber,
                              'count'=>$count,
                              'pagination'=>$getpg     
                              );
                   $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,
                              'data'=>$get['data'],
                              'judgename'=>$judgename,
                              'respondant'=>$respondant,
                              'petitioner'=>$petitioner,
                              'casenumber'=>$casenumber,
                              'message' => 'No results found');
                   $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
        }
    }
    


}
