<?php
class CompanymasterdataController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Company Master Data']);

        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $date=date('Y-m-d');
        //echo $date; exit;

        $getuserid = $this->session->loginauthspuserfront['id'];
        
        $this->view->gotdesig =  $this->companymasterdatacommon->fetchDesignation();
        //echo '<pre>'; print_r($this->view->gotdesig); exit;
    }

    
    public function fetchcompanydataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getstatus = $this->companymasterdatacommon->fetchcompanydata($getuserid,$cin);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertcompanymasterdataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $comprepdesig   = $this->request->getPost('comprepdesig');
                $repname        = $this->request->getPost('repname', array('striptags', 'trim'));
                $repname        = strtoupper($repname);
                $repdin         = $this->request->getPost('repdin');
                $repappdate     = $this->request->getPost('repappdate');
                $repemail       = $this->request->getPost('repemail');
                $repmobile      = $this->request->getPost('repmobile');
                $reppan         = $this->request->getPost('reppan');
                $repaddress     = $this->request->getPost('repaddress');
                //$gcin = $this->session->memberdoccin;
                //echo $cin; exit;

                //$repnamecheck =  $this->elements->allownumalphahyphen($repname);                
                if(empty($repname))
                {
                    $data = array("logged" => false,'message' => 'Please Insert Name');
                    $this->response->setJsonContent($data);
                }
                /*else if($repnamecheck==true)
                {
                    $data = array("logged" => false,'message' => 'Please Insert Name in Correct Format');
                    $this->response->setJsonContent($data);
                }*/
                else
                {
                    $getstatus = $this->companymasterdatacommon->insertcompanymasterdata($getuserid,$cin,$comprepdesig,$repname,$repdin,$repappdate,$repemail,$repmobile,$reppan,$repaddress);
                    //print_r($getstatus); exit;

                    if($getstatus)
                    {
                        $data = array("logged" => true,'message' => 'Company Representative Added Successfully' , 'data'=> $getstatus);
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => "Company Representative Not Added!!!");
                        $this->response->setJsonContent($data);
                    }
                }                

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function fetchcmdiddetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $cmdid = $this->request->getPost('cmdid');
                $identifier = $this->request->getPost('identifier');
                //echo $cmdid.'*'.$identifier; exit;
                
                if($identifier=='wdd')
                {
                    $identifier='web_director_details';
                }
                else if($identifier=='wdd_cmd')
                {
                    $identifier='web_director_details_cmd';
                }

                $getstatus = $this->companymasterdatacommon->fetchcmdiddetails($getuserid,$cin,$cmdid,$identifier);
                //echo '<pre>'; print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Details Found' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Details Found !!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function updatecmdiddataAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $cmdid         = $this->request->getPost('cmdid', array('striptags', 'trim'));
                $identifier    = $this->request->getPost('identifier', array('striptags', 'trim'));                
                $repname       = $this->request->getPost('repname', array('striptags', 'trim'));
                $repname       = strtoupper($repname); 
                $repdin        = $this->request->getPost('repdin', array('striptags', 'trim'));
                $repaddress    = $this->request->getPost('repaddress', array('striptags', 'trim'));
                $repemail      = $this->request->getPost('repemail', array('striptags', 'trim'));
                $repmobile     = $this->request->getPost('repmobile', array('striptags', 'trim'));
                $reppan        = $this->request->getPost('reppan', array('striptags', 'trim'));
                //echo $repname; exit;

                if($identifier=='wdd')
                {
                    $identifier='web_director_details';
                }
                else if($identifier=='wdd_cmd')
                {
                    $identifier='web_director_details_cmd';
                }
                
                $getstatus = $this->companymasterdatacommon->updatecmdiddata($getuserid,$cin,$cmdid,$identifier,$repname,$repdin,$repaddress,$repemail,$repmobile,$reppan);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Record Updated Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Updating Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function deletewddcmdidentryAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $cmdid        = $this->request->getPost('cmdid', array('striptags', 'trim'));
                $identifier   = $this->request->getPost('identifier', array('striptags', 'trim'));
                //echo $cmdid.'*'.$identifier;   exit;
                
                if($identifier=='wdd')
                {
                    $identifier='web_director_details';
                }
                else if($identifier=='wdd_cmd')
                {
                    $identifier='web_director_details_cmd';
                }

                $getstatus = $this->companymasterdatacommon->deletewddcmdidentry($getuserid,$cin,$cmdid,$identifier);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Record Deleted Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Deleting Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function insertcmdviaexcelAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        //echo '<pre>';print_r($this->session->loginauthspuserfront);exit;
        $devicedetect = $this->devicedetect;
        $timeago = time();
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //$deptmntid = $this->request->getPost('deptmntname', 'trim');
                //echo $deptmntid; exit;
                
                $userfile_name = $_FILES['cmdexcelfile']['name'];
                //echo $userfile_name;exit;
                $userfile_tmp = $_FILES['cmdexcelfile']['tmp_name'];
                $userfile_size = $_FILES['cmdexcelfile']['size'];
                $userfile_type = $_FILES['cmdexcelfile']['type'];
                $filename = basename($_FILES['cmdexcelfile']['name']);
                //echo $filename;exit;
                
                $file_ext = $this->validationcommon->getfileext($filename);
                $upload_path = $this->cmduploadfiledir."/";	
                //echo $upload_path; exit;
                $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid.'_cin-'.$cin;               
                //echo $large_imp_name."*".$file_ext;exit;
                $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
                $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);
                //echo $uploadedornot; exit; 

                $getresponse = $this->phpimportexpogen->insertcmdviaexcel($getuserid,$cin,$large_impfile_location);
                //echo $getresponse; exit;

                if($getresponse)
                {
                    $data = array("logged" => true,'message' => 'File Upload Successful !!','data'=>$getresponse);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Problem in Uploading File !!');
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();            
            }
            else
            {
                exit('No direct script access allowed isAjax');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    
}
