<?php
class CompliancematrixextController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Compliance Responsibility Matrix']);

        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $date=date('Y-m-d');
        //echo $date; exit;

        $getuserid = $this->session->loginauthspuserfront['id'];
        //$this->view->emdata = $this->importantduedatescommon->fetch_EMdetails($getuserid);
    }


    /* ########################### Calendar Section4 START ########################### */
    public function fetchcalendardetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $user_group_id;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //$clickedid = $this->request->getPost('clickedid');
                //echo $clickedid; exit;
                
                if($user_group_id!=7)
                {                    
                    $getstatus = $this->compliancematrixcommon->dbeventsfetching($getuserid,$cin);
                    //print_r($getstatus); exit;
                }
                else if($user_group_id==7)  //For Sub Users
                {
                    $getstatus = $this->compliancematrixextcommon->fetchsubuserevents($getuserid,$cin,$user_group_id);
                    //print_r($getstatus); exit;
                }

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function fetcheventsiddataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $eventsid = $this->request->getPost('eventsid');
                //echo $eventsid; exit;

                $getstatus = $this->compliancematrixextcommon->fetcheventsiddata($getuserid,$eventsid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function updateeventsidstatusAction()
    {
        //echo "<pre>";print_r($this->request->getPost());exit;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        $timeago = time();

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $status = $this->request->getPost('status');
                $eventsid = $this->request->getPost('eventsid');
                $path = $this->compliancematrixfileuploaddir."/";
                $filepath = ''; $uploadedornot=false;
                
                if ($status == 0) {
                    //echo "in here";exit;
                    $userfile_name = $_FILES['statuscomplt']['name'];
                    //echo $userfile_name;exit;
                    $userfile_tmp = $_FILES['statuscomplt']['tmp_name'];
                    $userfile_size = $_FILES['statuscomplt']['size'];
                    $userfile_type = $_FILES['statuscomplt']['type'];
                    $filename = basename($_FILES['statuscomplt']['name']);
                    $file_ext = $this->validationcommon->getfileext($filename);
                    $large_imp_name = $firstname.'_'.$lastname.'_'.$eventsid;
                    $filepath = $path.$large_imp_name.".".$file_ext;
                    //echo $filepath;exit;
                    $uploadedornot = move_uploaded_file($userfile_tmp, $filepath);
                }

                //echo $uploadedornot;exit;
                $getstatus = $this->compliancematrixextcommon->updateeventsidstatus($getuserid,$cin,$status,$filepath,$eventsid);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    if($uploadedornot)  //For Sending Email to users on EventDone rushi
                    {
                        $shootemail = $this->compliancematrixextcommon->eventCompletedSendEmail($getuserid,$cin,$eventsid);
                        //print_r($shootemail);exit;
                    }
                        
                    $data = array("logged" => true,'message' => 'Record updated Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Updating Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    /* ########################### Calendar Section4 END ########################### */


    public function fetchcaliddataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $calendarid = $this->request->getPost('calendarid');
                //echo $calendarid; exit;

                $getstatus = $this->compliancematrixextcommon->fetchcaliddata($getuserid,$calendarid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    /* ########################### PlanYourEvents Section2 START ########################### */
    public function fetchcusersofeventAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $wnruid = $this->request->getPost('wnruid','trim');
                $deptid = $this->request->getPost('deptid','trim');
                //echo $wnruid; exit;

                $geuer = $this->compliancematrixextcommon->createuserform($getuserid,$cin,$wnruid);
                $getuid = explode(',',$geuer['matrixid']);
                $getuidday = explode(',',$geuer['days']);
                //echo '<pre>';print_r($getuid);exit;
                
                foreach($getuid as $key => $userid)
                {
                    $nwarray[]= array('userid'=>$userid,'days'=>$getuidday[$key]);
                }
                //echo '<pre>';print_r($nwarray);exit;
                
                $appendhtml = '';
                $getcoun = count($nwarray);
                if($getcoun!=0)
                {
                    foreach($nwarray as $key => $val)
                    {
                        $getinfomn = $this->compliancematrixextcommon->getuserinfo($val['userid'],$deptid,$getuserid,$cin);
                        //echo '<pre>';print_r(array_shift($getinfomn));exit;                        
                        $getinfomn = array_shift($getinfomn);
                        
                        $appendhtml .='<div class="rmuser-'.$val['userid'].'" emid="'.$val['userid'].'">';
                        
                        $appendhtml .='<section class="col col-md-7 paddingleft">';
                        $appendhtml .='<label class="control-label mainuserinfo">';
                        $appendhtml .='<div class="empname">'.$getinfomn['em_name'].'</div>';
                        $appendhtml .='<div class="empnamedec floatleft">'.$getinfomn['em_designation'].'</div>';
                        $appendhtml .='<div class="empnamelevel floatleft">'.$getinfomn['level'].'</div>';
                        $appendhtml .='<div class="clearelement"></div>';
                        $appendhtml .='</label>';
                        $appendhtml .='</section>';
                        
                        $appendhtml .='<section  class="col col-md-4">';
                        $appendhtml .='<label  class="input">';
                        $appendhtml .='<input type="hidden" name="useridget[]" value="'.$val['userid'].'">';
                        $appendhtml .='<input type="text" class="" name="dayofuser[]" onkeypress="return numbersonly(this, event);" maxlength="3" value="'.$val['days'].'">';
                         $appendhtml .='<b class="tooltip tooltip-top-right">Days of Notification</b>';
                        $appendhtml .='</label></section>';
                        
                        $appendhtml .='<section  class="col col-md-1">';
                        $appendhtml .='<i class="fa fa-trash-o faicon removeuser" title="Remove User" emid="'.$val['userid'].'"></i>';
                        $appendhtml .='</section>';
                        
                        $appendhtml .='</div>';
                        $appendhtml .='<div class="clearelement"></div>';
                    }
                    
                    $appendhtmlnw = $appendhtml.'<div class="clearelement"></div>';
                    //echo $appendhtmlnw.'<br>'.'<pre>';print_r($nwarray); exit;

                    $data = array("logged" => true,'message' => 'Got Your data' , 'datahtml'=> $appendhtmlnw);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function updateuserrecordAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        $timeago = time();

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getsrlzdata  = $this->request->getPost();
                //echo '<pre>'; print_r($getsrlzdata); exit;

                $getstatus = $this->compliancematrixextcommon->savecompliancedata($getsrlzdata,$getuserid,$cin);
                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Record updated Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in updated Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
                //echo '<pre>';print_r($getsrlzdata);exit;
            }
            else
            {
                exit('No direct script access allowed');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    /* ########################### PlanYourEvents Section2 END ########################### */
    

    public function updateemailidAction()
    {
        $getuser = $this->compliancematrixcommon->getalluserduedate();
        $datagecur = date('Y-m-d');
        foreach($getuser as $key => $value)
        {
            //echo '<pre>';print_r($value);exit;
            foreach($value as $kem => $notval)
                    {
                        //echo '<pre>';print_r($notval['notify_days']);exit;
                        $getuinfo = $this->compliancematrixextcommon->getuserinfoext($notval['userid'],$notval['dept_id']);
                        $getuinfo = array_shift($getuinfo);
                        $geteventinfo = $this->compliancematrixextcommon->getemaileventdate($notval['eventid']);
                        //echo '<pre>';print_r($geteventinfo);exit;
                        $geteventinfo = array_shift($geteventinfo);

                        //$date2=date_create($geteventinfo['trigger_date']);
                        $ntifyday=$notval['notify_days'];
                       // echo 'triggerdate- '.$geteventinfo['trigger_date']." ".$ntifyday.'<br>';
                        $diff = date('Y-m-d', strtotime('-'.$ntifyday.' day', strtotime($geteventinfo['trigger_date'])));
                        //echo $datagecur." ---------- " .$diff."------ ".$geteventinfo['trigger_date']."------".'<br>';
                        if($datagecur==$diff)
                        {
                            $Mail = $this->emailer;
                            $getactualemail    = trim(strtolower($getuinfo['em_email']));
                            $evtid = $notval['eventid'];
                            $getdetl = $this->compliancematrixextcommon->getemaileventdate($evtid);
                            $getdetl = array_shift($getdetl);
                            //echo '<pre>';print_r($getdetl);exit;

                            $dateget = date("l jS F Y", strtotime($datagecur));
                            $j = $Mail->emailshootchange($getuinfo['em_name'],
                                                        $getactualemail,
                                                        $getdetl['lodreventname'],
                                                        $getdetl['department_name'],
                                                        $getdetl['compliancename'],
                                                        $dateget);

                            echo $getuinfo['em_name'].' ---###--- Event email Shoot to this Person'.'<br>';

                        }
                        else{
                            echo $getuinfo['em_name'].' ---noeventsetfor'.'<br>';
                        }
                        //echo $diff->format("%R%a days");
                    }
        }
        exit;
        //


        echo '<pre>';print_r($getuser);exit;
    }


    public function fetchcuvactsdbdataAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //$clickedid = $this->request->getPost('clickedid');
                //echo $clickedid; exit;

                $getstatus = $this->compliancematrixextcommon->fetchcuvactsdbdata();
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getpiechartAction()
    {
       $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                
                $getstatus = $this->compliancematrixextcommon->fetchpiechart($getuserid,$cin);
                $gn = count($getstatus);
                
                if($gn > 0)
                {
                    $data = array("logged" => true,'message' => 'Pie chart Data got it','gftda'=>$getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Pie chart Not availabel');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();

                
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    public function getpiechartstatusAction()
    {
       $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        //echo $cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                if($user_group_id!=7)
                {
                    $getstatus = $this->compliancematrixextcommon->fetchpiechartstatus($getuserid,$cin,$user_group_id);
                }
                else
                {
                    $getstatus = $this->compliancematrixextcommon->piechartstatusSubuser($getuserid,$cin,$user_group_id);
                }
                
                $gn = count($getstatus);
                //echo $gn; exit;
                
                if($gn > 0)
                {
                    $data = array("logged" => true,'message' => 'Pie chart Data got it','gftda'=>$getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Pie chart Not availabel');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();

                
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

}
