<?php /*if ( ! defined('APP_PATH')) exit('No direct script access allowed');*/
use \Phalcon\Paginator\Adapter\QueryBuilder as PaginacionBuilder;
use \Phalcon\Http\Request;
use \Phalcon\Filter;
class ImageuploadController extends ControllerBase
{
    public function initialize()
    {
        $this->tag->setTitle('Welcome');
		$this->elements->checkuserloggedin();
		$getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
       
        
        
    }
    public function imguploadAction()
    {
		$this->view->disable();
		$connection = $this->db;
		$getuser_session_uniqueid = $this->session->getId();
		$getuser_userid = $this->session->loginauthspuserfront['id'];
        $type ='config_service';
        if($type=='config_service')
        {$getdirlarge = $this->catservimgdir;$getdirthumb = $this->catservthumbimgdir;}
        else if($type=='config_aggrement')
        {$getdirlarge = $this->cataggrementimgdir;$getdirthumb = $this->cataggrementthumbimgdir;}
        else
        {$getdirlarge = $this->catservimgdir;$getdirthumb = $this->catservthumbimgdir;}
        
		#########################################################################################################
		# CONSTANTS																								#
		# You can alter the options below																		#
		#########################################################################################################
		$randomtimekey  = time();
		$upload_dir = $getdirlarge; 		
		/*//The directory for the images to be saved in*/
		$uploadthumb_dir = $getdirthumb; 		
		/*// The directory for the images to be saved in*/
		$upload_path = $upload_dir."/";				
		/*// The path to where the image will be saved*/
		$upload_path_thumb = $uploadthumb_dir."/";				
		/*// The path to where the image will be saved*/
		$cfilename_lg = 'Phoenix-peth-Rajuharry-WE-lg-'.$getuser_session_uniqueid."-lets-willenlight-".$type; 
		$cfilename_thumb = 'Phoenix-peth-WE-Rajuharry-resized-thumb-'.$getuser_session_uniqueid."-lets-willenlight-".$type; 
		$large_image_prefix = $cfilename_lg."-"; 			// The prefix name to large image
		$thumb_image_prefix = $cfilename_thumb."-";			// The prefix name to the thumb image
		$large_image_name = $large_image_prefix.$randomtimekey;     
		// New name of the large image (append the timestamp to the filename)
		$thumb_image_name = $thumb_image_prefix.$randomtimekey;     
		// New name of the thumbnail image (append the timestamp to the filename)
		$max_file = "3"; 							// Maximum file size in MB
		$max_width = "510";							// Max width allowed for the large image
		$thumb_width = "200";						// Width of thumbnail image
		$thumb_height = "200";						// Height of thumbnail image
		// Only one of these image types should be allowed for upload
		$allowed_image_types = array('image/pjpeg'=>"jpg",'image/jpeg'=>"jpg",'image/jpg'=>"jpg",'image/png'=>"png",'image/x-png'=>"png",'image/gif'=>"gif");
		$allowed_image_ext = array_unique($allowed_image_types); // do not change this
		$image_ext = "";	// initialise variable, do not change this.
		foreach ($allowed_image_ext as $mime_type => $ext) {
			$image_ext.= strtoupper($ext)." ";
		}
		
		
        if($this->request->isPost() == true) 
        {
            //si es una petición ajax
            if($this->request->isAjax() == true) 
            {
						//print_r ($this->request->getPost("profilepicupload"));exit;
					if (!empty($this->request->getPost("profilepicupload"))|| $this->request->getPost("profilepicupload")) {
						 
							//Get the file information
							$userfile_name = $_FILES['profilepic']['name'];
							//echo $userfile_name;exit;
							$userfile_tmp = $_FILES['profilepic']['tmp_name'];
							$userfile_size = $_FILES['profilepic']['size'];
							$userfile_type = $_FILES['profilepic']['type'];
							$filename = basename($_FILES['profilepic']['name']);
							$file_ext = $this->validationcommon->getfileext($filename);
							//echo $large_image_name;exit;
							//Image Locations
							$large_image_location = $upload_path.$large_image_name.".".$file_ext;
							$thumb_image_location = $upload_path_thumb.$thumb_image_name.".".$file_ext;
							
							//Create the upload directory with the right permissions if it doesn't exist
							if(!is_dir($upload_dir)){
								mkdir($upload_dir, 0777);
								chmod($upload_dir, 0777);
							}
							if(!is_dir($uploadthumb_dir)){
								mkdir($uploadthumb_dir, 0777);
								chmod($uploadthumb_dir, 0777);
							}
							
							//Check to see if any images with the same name already exist
							//echo 	$large_image_location ;exit;	
							$getpreviouslargefile = $this->session->previousfile['large_image_location'];
							$getpreviousthumbfile = $this->session->previousfile['thumb_image_location'];
							//echo $getpreviouslargefile; exit;
							if(!empty($getpreviouslargefile))
							{
								if (file_exists($getpreviouslargefile)) {
									unlink($getpreviouslargefile);
								}
							}
							if(!empty($getpreviousthumbfile))
							{
								if (file_exists($getpreviousthumbfile)) {
									unlink($getpreviousthumbfile);
								}
							}
							
							
							/*strtolower(substr($filename, strrpos($filename, '.') + 1));*/
							//echo $file_ext;exit;
							//Only process if the file is a JPG, PNG or GIF and below the allowed limit
							if((!empty($_FILES["profilepic"])) && ($_FILES['profilepic']['error'] == 0)) {
								
								foreach ($allowed_image_types as $mime_type => $ext) {
									//loop through the specified image types and if they match the extension then break out
									//everything is ok so go and check file size
									if($file_ext==$ext && $userfile_type==$mime_type){
										$error = "";
										break;
									}else{
										$error = "Only <strong>".$image_ext."</strong> images accepted for upload<br />";
										$data = array("logged" => false,'message' => $error,'fieldname'=>'fnameerrormsg');
										$this->response->setJsonContent($data);
									}
								}
								//check if the file size is above the allowed limit
								if ($userfile_size > ($max_file*1048576)) {
									$error.= "Images must be under ".$max_file."MB in size";
									$data = array("logged" => false,'message' => $error,'fieldname'=>'fnameerrormsg');
									$this->response->setJsonContent($data);
								}
								
							}else{
								$error= "Select an image for upload";
								$data = array("logged" => false,'message' => $error,'fieldname'=>'fnameerrormsg');
								$this->response->setJsonContent($data);
							}
							//Everything is ok, so we can upload the image.
							if (strlen($error)==0){
								
								if (!empty($_FILES['profilepic']['name'])){
									//this file could now has an unknown file extension (we hope it's one of the ones set above!)	
									
									$large_image_location = $large_image_location;
									$thumb_image_location = $thumb_image_location;
									//echo $thumb_image_location; exit;
									$this->session->set('image_location',array('thumb_image_location' => $thumb_image_location,
									'large_image_location' => $large_image_location , 'thumb_image_getfile' => $thumb_image_name.".".$file_ext ,
									'thumb_image_getfile_with_folder' => $getdirthumb."/".$thumb_image_name.".".$file_ext 
									));
									
									$this->session->set('previousfile',array('thumb_image_location' => $thumb_image_location,
									'large_image_location' => $large_image_location ,'thumb_image_getfile' => $thumb_image_name.".".$file_ext,
									'thumb_image_getfile_with_folder' => $getdirthumb."/".$thumb_image_name.".".$file_ext 
									));
									
									
									//echo $thumb_image_location;exit;
									//put the file ext in the session so we know what file to look for once its uploaded
									
									$this->session->set('profileauths', array(
																		'random_key' => $this->session->profileauths['random_key'],
																		'user_file_ext' => ".".$file_ext)
																		);
																		
									/*Your Main large image upload herer*/
									$uploadedornot = move_uploaded_file($userfile_tmp, $large_image_location);
									chmod($large_image_location, 0777);
                                    
									/*Your Main large image upload here with Permission*/
									
									if (file_exists($large_image_location)){
										if(file_exists($thumb_image_location)){
											$thumb_photo_exists = $upload_path_thumb.$thumb_image_name.$file_ext;
										}else{
											$thumb_photo_exists = "";
										}
										$large_photo_exists = $upload_path.$large_image_name.$file_ext;
										$this->session->set('photo_exists', 
										array('thumb_photo_exists' => $thumb_photo_exists,
										'large_photo_exists' => $large_photo_exists));
									} else {
										$this->session->set('photo_exists', array('thumb_photo_exists' => "",'large_photo_exists' => ""));
									}
									
									
									
									//echo $uploadedornot;exit;
									$width =  $this->validationcommon->getWidth($large_image_location);
									$height = $this->validationcommon->getHeight($large_image_location);
									//Scale the image if it is greater than the width set above
									if ($width > $max_width){
										$scale = $max_width/$width;
										$uploaded = $this->validationcommon->resizeImage($large_image_location,$width,$height,$scale);
									}else{
										$scale = 1;
										$uploaded = $this->validationcommon->resizeImage($large_image_location,$width,$height,$scale);
									}
									//Delete the thumbnail file so the user can create a new one
									if (file_exists($thumb_image_location)) {
										unlink($thumb_image_location);
									}
								}
								//Refresh the page to show the new uploaded image
								
								$current_large_image_width = $this->validationcommon->getWidth($large_image_location);
								$current_large_image_height = $this->validationcommon->getHeight($large_image_location);
								$getimgconvertonly = $large_image_name.".".$file_ext;
								
								$error = "File Upload Successfully";
											//echo $error;exit;
											$data = array(
											"logged" => true,'message' => $error,'fieldname'=>'fnameerrormsg',
											'imagepathcp' => $upload_path.$large_image_name.$this->session->profileauths['user_file_ext'],
											'thumb_width' => $thumb_width,'thumb_height' => $thumb_height,
											'current_large_image_width'=>$current_large_image_width,
											'current_large_image_height'=>$current_large_image_height,
											'imagename' => $large_image_name.$this->session->profileauths['user_file_ext'],
											);
											$this->response->setJsonContent($data);
								
							}
					}
					
					
		        $this->response->send();
				$connection->close();
			}
			else
			{
				exit('No direct script access allowed -to this area');
				$connection->close();
			}
        }
		else
		{
			return $this->response->redirect('errors/show404');
			exit('No direct script access allowed');
		}
	}

}
