<?php
class IncorporationController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Incorporation']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $this->view->matched_categories = $this->incorporationcommon->fetchMatchedCategories();
        //echo '<pre>'; print_r($this->view->matched_categories); exit;
    }

    public function generateformspageAction()
    {       
        $this->view->disable();
        $get_id= $this->request->getPost('get_id');
        //echo $get_id; exit;
        
        if($get_id != '')
        {
            $incsession = $this->session->set('incses',$get_id);
            $data = array("logged" => true,'message' => 'Found!!!');
            $this->response->setJsonContent($data);
        }
        else
        {
            $data = array("logged" => false,'message' => 'No Result Found !!!');
            $this->response->setJsonContent($data);
        }
        $this->response->send();
        
       /* if($get_id != ''){
             $setincses = $this->session->set('getid',$get_id);
        }*/
    }
    
    public function generateformsAction(){ 
        $this->view->getsesid = $this->session->incses;
        //echo $getsesid; exit;
        $this->view->getincele = $this->incorporationcommon->getincorpelement($this->view->getsesid);
        //echo '<pre>'; print_r($this->view->getincele); exit;
    }

    public function incorpblockdetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                $getsearchkywo = $this->request->getPost('getsearchwo');
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "trim");
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "string");

                $categoryid = $this->request->getPost('catid');
                $categoryid = $this->filter->sanitize($categoryid, "trim");
                //echo $categoryid; exit;

                if(preg_match("/[A-Za-z]+/", $getsearchkywo)){
                $getsearchkywo = $getsearchkywo;
                $limit = 12;
                $mainarray = $this->incorporationcommon->yourserviceexe($getsearchkywo,$limit, $categoryid);
                $getcount = $this->incorporationcommon->yourservicecount($getsearchkywo,$limit, $categoryid);

                    if(($getcount)>0)
                    {
                        foreach($mainarray as $getarray){

                                    $responsearray[] = array(
                                    'id' => $getarray['id'],
                                    'name' => $getarray['name']

                            );
                        }

                        $data = array("logged" => true,'message' => 'Found!!!' ,'data'=> $responsearray,'count'=> $getcount);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'No Result Found !!!');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'No result Found!!!');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function fetchincorpdetailsAction()
    {
          
        $this->view->disable();
        $connection = $this->db;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $incid= $this->request->getPost('incorpid');
                $incname= $this->request->getPost('incorpname'); 
                //echo $incid; exit;

                $getstatus = $this->incorporationcommon->incorpdetailsform($incid);
                //print_r($getstatus); exit;
                if($getstatus == true){
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "Input Fields For This Service Not Found !");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }


    public function updateincorpblockAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $table ='';
                $incorp_id = $this->request->getPost('incorpblockid','trim');              
                $no_of_dir =  $this->request->getPost('no_of_dir','trim');                
                $titititl =  $this->request->getPost('titititl','trim');
                
                //echo $incorp_id.'*'.$no_of_dir.'*'.$titititl; exit;               
                
                if($titititl == 'MoA'){
                     if($no_of_dir != ''){
                           $i = 1001;
                    for($j = 1; $j <= $no_of_dir; $j++){
                        $i++;
                        $table .= '<tr>';
                        $table .= '<td width="32">';
                        $table .= '<p>'.$j.'.</p>';
                        $table .= '</td>';
                        $table .= '<td width="258">';
                        $table .= '<p><strong><u>Name:-</u></strong></p>';
                        $table .= '<p><font class="editcontentdivmid'.$i.'name_of_dir datainfo"> <font class="name_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'name_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'name_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        
                        $table .= '<p><strong><u>S/O:</u></strong></p>';
                       $table .= '<p><font class="editcontentdivmid'.$i.'so_of_dir datainfo"> <font class="S/O_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'so_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'so_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        
                        $table .= '<p><strong><u>Address:</u></strong></p>';
                        $table .= '<p><font class="editcontentdivmid'.$i.'Address_of_dir datainfo"> <font class="Address_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'Address_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'Address_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        
                        $table .= '<p><strong><u>Occupation:</u></strong></p>';
                        
                        $table .= '<p><font class="editcontentdivmid'.$i.'Occupation_of_dir datainfo"> <font class="Occupation_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'Occupation_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'Occupation_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        
                        $table .= '</td>';
                        $table .= '<td width="96">';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>In figures</p>';
                        $table .= '<p><font class="editcontentdivmid'.$i.'figures_of_dir datainfo"> <font class="figures_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'figures_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'figures_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        $table .= '<p>And In words</p>';
                        $table .= '<p><font class="editcontentdivmid'.$i.'words_of_dir datainfo"> <font class="words_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'words_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'words_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        $table .= '</td>';
                        $table .= '<td width="138">';
                        $table .= '<p>Affix Photo</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>Signature</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '</td>';
                        $table .= '<td width="168">';
                        
                        //$table .= '<p><strong><u>&nbsp;</u></strong></p>';
                         $table .= '<p><font class="editcontentdivmid'.$i.'description_of_dir datainfo"> <font class="description_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'description_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'description_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        $table .= '</td>';

                        $table .= '</tr>';
                    }
                    
                    //echo '<pre>'; print_r($table); exit;
                }
            }
                if($titititl == 'AoA'){
                   
                     if($no_of_dir != ''){
                    $i = 1001;
                    for($j = 1; $j <= $no_of_dir; $j++){
                        
                        $i++;
                        
                        $table .= '<tr>';                        
                        $table .= '<td width="40">';    
                        $table .= '<p>'.$j.'.</p>';    
                        $table .= '</td>';    
                        $table .= '<td width="258">';    
                        $table .= '<p><strong><u>Name:-</u></strong></p>';    
                        $table .= '<p><font class="editcontentdivmid'.$i.'name_of_dir datainfo"> <font class="name_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'name_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'name_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';    
                         
                        $table .= '<p><strong><u>S/O:</u></strong></p>';    
                        $table .= '<p><font class="editcontentdivmid'.$i.'so_of_di datainfo"> <font class="S/O_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'so_of_di">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'so_of_di"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';    
                        $table .= '<p><strong><u>Address:</u></strong></p>';    
                        $table .= '<p><font class="editcontentdivmid'.$i.'Address_of_dir datainfo"> <font class="Address_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'Address_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'Address_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';    
                        //$table .= '<p><strong><u>&nbsp;</u></strong></p>';    
                        //$table .= '<p><strong><u>&nbsp;</u></strong></p>';    
                        $table .= '<p><strong><u>Occupation:</u></strong></p>'; 
                        $table .= '<p><font class="editcontentdivmid'.$i.'Occupation_of_dir datainfo"> <font class="Occupation_of_dir'.$i.'Occupation_of_dir"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'Occupation_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'Occupation_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';
                        $table .= '</td>';    
                        $table .= '<td width="148">';    
                        $table .= '<p>Affix Photo</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>&nbsp;</p>';    
                        $table .= '<p>Signature</p>';
                         $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '<p>&nbsp;</p>';
                        $table .= '</td>';    
                        $table .= '<td width="258">';    
                        $table .= '<p><font class="editcontentdivmid'.$i.'description_of_dir datainfo"> <font class="description_of_dir'.$i.'"><strong><u>&nbsp;</u></strong></font>             </font>
                          <div class="editcontentdiv" data-parent="editcontentdivmid'.$i.'description_of_dir">    
                           <div class="floatright"><i class="fa fa-edit editlink" data-parent="editcontentdivmid'.$i.'description_of_dir"></i></div>
                           <div class="clearelement"></div>
                          </div></p>';    
                        $table .= '</td>'; 
                        $table .= '</tr>';
                        
                    }
                    
                    //echo '<pre>'; print_r($table); exit;
                }
                    
                }
                
               
                
                

                $getres = $this->incorporationcommon->getpdfdetails($incorp_id);
                //echo $getres; exit;
                
                /*-------------------- Create Directory For User Tracking ----------------------*/
                $getdirectoryname = $this->session->profilecommondir['createdirname'];
                $dir = $this->pdfdownloadincorpdir.'/';
                $upload_dir = $dir.$getdirectoryname;
                $upload_dir_pdf = $dir.$getdirectoryname;
               // echo $getdirectoryname; exit;

                $getcurrentyear = date("Y");
                $getcurrentmonth = date("M");
                $getcurrentdate = date("Y-m-d");

                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                
                /*-------------------- Create Directory For User Tracking END ----------------------*/
                
                if($getres)
                {
                    $data = array("logged" => true,'message' => 'Got Your data','data'=>$getres,'dir'=>$final_dir,'table'=> $table);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'File does not Exist');
                    $this->response->setJsonContent($data);
                }                

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }


    public function getincorpreformelementAction()
    {
         $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
             
                $getfullstrin = $this->request->getPost('getfullstrin','trim');
                //echo '<pre>';print_r($getfullstrin); exit;
                $incorpid =  $this->request->getPost('incorpid','trim');
               
                
                $newarray = $this->incorporationcommon->fetchfullincorporationstrin($getfullstrin);
                //echo '<pre>';print_r($newarray); exit;
                $getservalue = $this->incorporationcommon->fetchincorpvalue($incorpid);
                //echo '<pre>';print_r($getservalue); exit;
               
             
                //echo '<pre>';print_r($getservalue);
                
                //echo sizeof($newarray);echo sizeof($getservalue).'<br>';
                if(sizeof($newarray) == sizeof($getservalue))
                {
                    $commonarraymerge = array_combine($getservalue,$newarray);
                    //echo '<pre>';print_r($commonarraymerge); exit;
                    
                    /*-------------------- Update CustomerData For User Tracking ----------------------*/
                    $getre = $this->customerusercommon->updateresolutionentry($getuserid,'','config_incorp_resolution',$incorpid); 
                    
                    if($getre['logged']==true)
                    {$getnidm= $getre['idget'];}else
                    {$getnidm=''; }
                    /*-------------------- Update CustomerData For User Tracking ----------------------*/
                  
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $commonarraymerge, 'trckid'=>$getnidm);
                    $this->response->setJsonContent($data);

                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong!!! Please wait we are upgrading something.');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }


    public function incorpgeneratepdfAction()
    {
         $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];        
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
              
                $pdf_content = $this->request->getPost('htmldata');
                $gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking CustomerData
                //echo $gettrackidfor; exit;
            
                if(!empty($getuserid))
                {
                    $getpdfpath = $this->dompdfgen->getpdf($pdf_content,'incorp','incorporation','configincorp');
                   // echo $getpdfpath ; exit;
                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData
                        
                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }





}
