<?php /*if ( ! defined('APP_PATH')) exit('No direct script access allowed');*/
use \Phalcon\Paginator\Adapter\QueryBuilder as PaginacionBuilder;
use \Phalcon\Http\Request;
use \Phalcon\Filter;
class PricingController extends ControllerBase
{
    public function initialize()
    {
        $this->tag->setTitle('Pricing Calculator');
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo ':frontend user::';print_r($this->session->loginauthsuser);exit;
        parent::initialize();
    }

    public function indexAction()
    {




    }
    public function setpricingAction(){

        $service_number = $this->request->get("service_number",'trim');
        $this->view->service_number = $service_number;
          if($this->request->isGet() == true)
            {
                $getid = $this->request->get('service_number', 'trim');
                if(empty($getid)){
                     $this->view->getmainservice = $this->pricingcommon->fetchmainservice();
                }
                else{
                    //echo 'here'; exit;
                     $this->view->getsubservice = $this->pricingcommon->fetchsubservice($service_number);
                }
            }

    }
    public function retrievepricingAction(){

        $service_number = $this->request->get("service_number",'trim');
        $this->view->service_number = $service_number;
          if($this->request->isGet() == true)
            {
                $getid = $this->request->get('service_number', 'trim');
                if(empty($getid)){
                     $this->view->getmainservice = $this->pricingcommon->fetchmainservice();
                }
                else{
                    //echo 'here'; exit;
                     $this->view->getsubservice = $this->pricingcommon->fetchsubservice($service_number);
                }
            }

    }
    
   
    
    public function getservicepricesAction(){
        
        //echo 'here'; exit;
        $this->view->disable();
        $connection = $this->db;
        //$getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                 $service_number = $this->request->getPost("id",'trim');
                 $getuserid = $this->session->loginauthspuserfront['id'];
                
                if($getuserid){
                    $getserviceprice = $this->pricingcommon->fetchmainserviceprice($service_number, $getuserid);
                    //echo '<pre>'; print_r($getserviceprice); exit;
                    if($getserviceprice){
                         $data = array("logged" => true,'message' => 'Found' ,'data'=> $getserviceprice, 'servicenumber'=>$service_number);
                        $this->response->setJsonContent($data);
                    }
                    else{
                         $data = array("logged" => true,'message' => 'Not Found' ,'data'=> 'Not Found', 'servicenumber'=>$service_number);
                        $this->response->setJsonContent($data);
                    }
                }
                else{
                    
                }


                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function insertservicepricesAction(){
        //echo 'here'; exit;
        $this->view->disable();
        $connection = $this->db;
        //$getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                 $service_number = $this->request->getPost("service_number",'trim');
                $director_fees = $this->request->getPost("director_fees",'trim');
                $base_price = $this->request->getPost("base_price",'trim');
                 $getuserid = $this->session->loginauthspuserfront['id'];
                
                if($getuserid){
                    $insertserviceprice = $this->pricingcommon->insertmainserviceprice($director_fees, $base_price, $service_number, $getuserid);
                    //echo '<pre>'; print_r($insertserviceprice); exit;
                    if($insertserviceprice){
                         $data = array("logged" => true,'message' => 'true' );
                        $this->response->setJsonContent($data);
                    }
                    else{
                         $data = array("logged" => false,'message' => 'false');
                        $this->response->setJsonContent($data);
                    }
                }
                else{
                    
                }


                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function updateservicepricesAction(){
        
         //echo 'here'; exit;
        $this->view->disable();
        $connection = $this->db;
        //$getuserid = $this->session->loginauths['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                 $service_number = $this->request->getPost("service_number",'trim');
                $director_fees = $this->request->getPost("director_fees",'trim');
                $base_price = $this->request->getPost("base_price",'trim');
                 $getuserid = $this->session->loginauthspuserfront['id'];
                
                if($getuserid){
                    $updateserviceprice = $this->pricingcommon->updatemainserviceprice($director_fees, $base_price, $service_number, $getuserid);
                    //echo '<pre>'; print_r($insertserviceprice); exit;
                    if($updateserviceprice){
                         $data = array("logged" => true,'message' => 'true' );
                        $this->response->setJsonContent($data);
                    }
                    else{
                         $data = array("logged" => false,'message' => 'false');
                        $this->response->setJsonContent($data);
                    }
                }
                else{
                    
                }


                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }

}
