<?php
class SecreterialpracticeController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Secreterial Audit']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $cin = $this->session->memberdoccin;
        //echo $cin; exit;
       /* $this->view->getservicefields = $this->secreterialauditcommon->secauditFetchhtmlservices();*/
        //echo $getservicefields;exit;
    }
    
    public function secreterialauditAction(){
        //echo 'here'; exit;
        $cin = $this->session->memberdoccin;
        //echo $cin; exit;
        if($cin){
            $this->view->cin = $this->secreterialpracticecommon->getcompname($cin);
            //echo '<pre>'; print_r($this->view->cin); exit;
        }
           $this->view->getservicefields = $this->secreterialpracticecommon->secauditFetchhtmlservices();
            //echo $getservicefields;exit;
    }
        
    public function secreterialauditajaxAction(){
         $this->view->disable();
         
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getservicefields = $this->secreterialpracticecommon->secauditFetchhtmlservices();
                $getservicefields = trim($getservicefields);
                if($getservicefields != ''){
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getservicefields);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Sub Questions!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        } 
    }
    
    public function fetchsubservicequestionsAction()
    {
        $this->view->disable();
        $connection = $this->db;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $questionid= $this->request->getPost('questionid');
                //echo $questionid; exit;

                $getstatus = $this->secreterialpracticecommon->getSubServiceQuestions($questionid);
                //print_r($getstatus); exit;
                if($getstatus == true){
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Sub Questions!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }        
    }
    
    
    public function secreterialauditblockAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getDate = '';
                $cur_year = strtotime(date('Y').'-04-01');
                $nxt_year = strtotime((date('Y') + 1).'-03-31');
                $cur_date = strtotime(date("d-m-Y")); 
                //echo $cur_date; exit;
                if( $cur_date > $cur_year && $cur_date < $nxt_year ){
                    //echo 'here'; exit;
                    $getDate = 'March 31st, '.date('Y',$cur_year );
                }
                //echo $getDate; exit;
              
                
                $mnget_parent = $this->request->getPost('mnget_parent');
                 $mnget_parent1 = $this->request->getPost('mnget_parent1');
                
                $mnget_child = $this->request->getPost('mnget_child');
                //echo '<pre>'; print_r($mnget_child); exit;
                $par_chld_text = $this->request->getPost('par_chld_text');
                //echo '<pre>'; print_r($par_chld_text); exit;
                $par_chld_text_comb = array_combine($mnget_parent, $par_chld_text);
               
                    //echo '<pre>'; print_r($par_chld_text_comb); exit;
                $par_chld_comb = array_combine($mnget_parent1, $mnget_child);
                 //echo '<pre>'; print_r($par_chld_comb); exit;
                $merge_array = array_merge($par_chld_text_comb, $par_chld_comb);
                  //echo '<pre>'; print_r($merge_array); exit;
                
                $getres = $this->secreterialpracticecommon->getpdfcontent();
                //echo $getres; exit;
                
                /*-------------------- Create Directory For User Tracking ----------------------*/
                $getdirectoryname = $this->session->profilecommondir['createdirname'];
                $dir = $this->pdfdownloadsecauditdir.'/';
                $upload_dir = $dir.$getdirectoryname;
                $upload_dir_pdf = $dir.$getdirectoryname;
               // echo $getdirectoryname; exit;

                $getcurrentyear = date("Y");
                $getcurrentmonth = date("M");
                $getcurrentdate = date("Y-m-d");

                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}                
                /*-------------------- Create Directory For User Tracking END ----------------------*/
                
                /*-------------------- Update CustomerData For User Tracking ----------------------*/
                $getre = $this->customerusercommon->updateresolutionentry($getuserid,'','config_secaudit_resolution','0'); 

                if($getre['logged']==true)
                {$getnidm= $getre['idget'];}else
                {$getnidm=''; }
                /*-------------------- Update CustomerData For User Tracking ----------------------*/
                
                
                if($getres)
                {
                    $data = array("logged" => true,'message' => 'Got Your data','data'=>$getres,'combdata'=>$merge_array, 'yr_ended_on'=>$getDate,'trckid'=>$getnidm);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'File does not Exist');
                    $this->response->setJsonContent($data);
                }                

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }
    
    
    public function inputformelementsAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {                
                $ito_ward_number = $this->request->getPost('ito_ward_number','trim');
                if($ito_ward_number=='yes')
                {
                    $que1 = $this->request->getPost('1que1','trim');
                    $que2 = $this->request->getPost('1que2','trim');
                    $que3 = $this->request->getPost('1que3','trim');
                }
                echo $ito_ward_number; exit;
                
                $getfullstrin = $this->request->getPost('getfullstrin','trim');
                //echo '<pre>';print_r($getfullstrin); exit;
                $deptlid =  $this->request->getPost('deptlid','trim');

            $newarray = $this->departmentletterscommon->fetchfulldeptlstrin($getfullstrin);
                //echo '<pre>';print_r($newarray); exit;
            $getservalue = $this->departmentletterscommon->fetchdeptlvalue($deptlid);
                //echo '<pre>';print_r($getservalue); exit;
               
             
                //echo '<pre>';print_r($getservalue);
                
                //echo sizeof($newarray);echo sizeof($getservalue).'<br>';
                if(sizeof($newarray) == sizeof($getservalue))
                {
                    $commonarraymerge = array_combine($getservalue,$newarray);
                    //echo '<pre>';print_r($commonarraymerge); exit;
                  
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $commonarraymerge);
                    $this->response->setJsonContent($data);

                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong!!! Please wait we are upgrading something.');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }
    
    
      public function generatepdfAction()
    {
        //echo 'here'; exit;
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {               
                $pdf_content = $this->request->getPost('htmldata');
                //echo '<pre>'; print_r($pdf_content); exit;
                $gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking CustomerData
                //echo $gettrackidfor; exit;                
                
                if(!empty($pdf_content))
                {
                    $getpdfpath = $this->dompdfgen->getpdf($pdf_content,'','','configsecaudit');
                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData
                        
                        $data = array("logged" => true,'message' => 'You can Download pdf of Secretarial Audit','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function getcompaddrAction()
    {
          //echo 'here'; exit;
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {               
                $comp_cin = $this->request->getPost('comp_cin');
                //echo '<pre>'; print_r($pdf_content); exit;             
                if(!empty($comp_cin))
                {
                     $getcompaddrs = $this->secreterialpracticecommon->getcompaddr($comp_cin);
                    if(!empty($getcompaddrs) || $getcompaddrs)
                    {
                        $data = array("logged" => true,'message' => 'Found!!!','data'=>$getcompaddrs);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Not FOund');
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
     public function secretarialstandardsAction()
    {
         
        $this->view->cin = $this->session->memberdoccin;
        
            
        $this->view->getdoctypetree = $this->secreterialpracticecommon->fetchdoctypestree(); 
      
    }
    
    public function getsubsecstdAction()
    {
        
           //echo 'here'; exit;
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {               
                $id = $this->request->getPost('id');
                //echo '<pre>'; print_r($pdf_content); exit;             
                if(!empty($id))
                {
                     $getcompaddrs = $this->secreterialpracticecommon->getsubstd($id);
                    //echo '<pre>'; print_r($getcompaddrs); exit;
                    if(!empty($getcompaddrs) || $getcompaddrs)
                    {
                        $data = array("logged" => true,'message' => 'Found!!!','data'=>$getcompaddrs);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Not FOund');
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    
    

}
