<?php
class BillingplansController extends ControllerBase
{
    public function initialize()
    {
        $this->tag->setTitle('Billing Plans');
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $this->view->gotresult = $this->billingplanscommon->getcategoryname();
    }

    public function upgradeplanAction()
    {
        /*$this->view->disable();*/
        // Check if request has made with POST
        if($this->request->isPost() == true)
        {
            //assign post  data to variables
            $plans = $this->request->getPost('plan', 'trim');

            //print_r($plans);

            foreach($plans as $value => $val)
            {
              //echo $val;

            }
           // echo $val; exit;
            $this->view->upgradeplan = $this->billingplanscommon->subplantypes($val);


        }
    }

    public function checkoutAction()
    {
        $this->view->userid     = $this->session->loginauthspuserfront['id'];
        $this->view->userfname  = $this->session->loginauthspuserfront['firstname'];
        $this->view->userlname  = $this->session->loginauthspuserfront['lastname'];
        $this->view->useremail  = $this->session->loginauthspuserfront['email'];
        $this->view->country    = $this->searchcommon->getcountry();
        $this->view->pgoptions  = $this->searchcommon->getpgoptions();
    }



    public function saveformonedataAction()
    {
        $this->view->disable();
        $devicedetect   =   $this->devicedetect;
        $getdevice      =   $devicedetect->getdeviceinfo();
        $devicetype     =   $getdevice['devicetype'];
        $useragent      =   $getdevice['useragent'];
        $ip             =   $this->request->getClientAddress();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getlength      = 10;
                $userid         = $this->request->getPost('uid', 'trim');
                $firstname      = $this->request->getPost('firstname', array('striptags', 'trim'));
                $lastname       = $this->request->getPost('lastname', array('striptags', 'trim'));
                $firstnamecheck = $this->elements->allownumalphahyphen($firstname);
                $lastnamecheck  = $this->elements->allownumalphahyphen($lastname);
                $email          = strtolower($this->request->getPost('emailidget', 'trim'));
                $emailcheck     = $this->validationcommon->emailvalidate($email);
                $mobile         = $this->request->getPost('mobile');
                $name           = $firstname.' '.$lastname;

                $rid            = $this->request->getPost('steponerid', 'trim');
                //print_r($rid);exit;
                if($emailcheck==false)
                {
                    $data = array("logged" => false,'message' => 'Your Email is not valid','fieldname'=>'emailrrormsg','actualvalue'=>$email);
                    $this->response->setJsonContent($data);
                    $this->response->send();
                }
                else{
                    $getstatus = $this->billingplanscommon->insertformonedata($name, $email,$mobile,$userid,$devicetype,$useragent,$ip);

                    if($getstatus['logged']==true){
                        $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                        $this->response->setJsonContent($data);

                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                $this->response->send();
            }
        }
    }

    public function saveformtwodataAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $addrone        = $this->request->getPost('addrone', 'trim');
                $addrtwo        = $this->request->getPost('addrtwo', 'trim');
                $country        = $this->request->getPost('country', 'trim');
                $state          = $this->request->getPost('state', 'trim');
                $city           = $this->request->getPost('city', 'trim');
                $pin            = $this->request->getPost('pin', 'trim');
                $rid            = $this->request->getPost('rid');


                    $getstatus = $this->billingplanscommon->insertformtwodata($addrone,$addrtwo,$city,$country,$state,$pin,$rid);
                    if($getstatus['logged']==true){
                        $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                        $this->response->setJsonContent($data);

                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted','fieldname'=>'form one data','returnval' => '');
                        $this->response->setJsonContent($data);
                    }



             $this->response->send();
            }
        }
    }

    public function getformthreedataAction()
    {
        //print_r($this->request->getPost());exit;
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $rid    = $this->request->getPost('rid', 'trim');
                $cid    = $this->request->getPost('countryid', 'trim');
                $sid    = $this->request->getPost('stateid', 'trim');
                if ($rid) {
                    $getstatus = $this->billingplanscommon->getformthree($rid,$cid,$sid);
                    if($getstatus){
                        $data = array("logged" => true,'message' => 'Data inserted','fieldname'=>'form one data','returnval' => $getstatus);
                        $this->response->setJsonContent($data);

                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted','fieldname'=>'form one data','returnval' => '');
                        $this->response->setJsonContent($data);

                    }
                }
                else{
                        $data = array("logged" => false,'message' => 'something wrong','fieldname'=>'form three data','returnval' => '');
                        $this->response->setJsonContent($data);

                    }
                $this->response->send();
            }
        }
    }
    public function redirectAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $amt    = $this->request->getPost('getvalue', 'trim');
                $amtnw = $this->session->set('checkoutsession',array('amount' => trim($amt)));
                if($amtnw)
                {
                    //return $this->response->redirect('billingplans/checkout');
                }
            }

        }
    }

    public function payonlineAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid; exit;
        $this->view->userpkg = $this->billingplanscommon->fetchUserPackageDetails($getuserid);
        //echo '<prev>'; print_r($this->view->userpkg); exit;
    }
}
