<?php
class CompliancematrixController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Compliance Responsibility Matrix']);

        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $date=date('Y-m-d');
        //echo $date; exit;

        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        
        // --------------------- Calendar&Events Count ---------------------
        if($user_group_id!=7)
        {
            $getcalcount = $this->compliancematrixcommon->dbeventsfetching($getuserid,$cin);        
            $getcalcount = count($getcalcount);
            $this->view->getcalcount = $getcalcount;            
        }
        else if($user_group_id==7) //For SubUsers
        {
            $getcalcount = $this->compliancematrixextcommon->fetchsubuserevents($getuserid,$cin,$user_group_id);        
            $getcalcount = count($getcalcount);
            $this->view->getcalcount = $getcalcount;
        }
        
        // --------------------- ComplianceResponsibilityMatrix Count ---------------------
        $getematrixcount = $this->compliancematrixcommon->getmatrixuser($getuserid,$cin);
        $getematrixcount = count($getematrixcount);
        $this->view->getematrixcount = $getematrixcount;
        
        // --------------------- PlanYourMeetings Count ---------------------
        $getemeetingcount = $this->compliancematrixcommon->dbplannerfetching($getuserid,$cin);
        $getemeetingcount = count($getemeetingcount);
        $this->view->getemeetingcount = $getemeetingcount;
        
        // --------------------- CUVActs Count ---------------------
        $getecuvactcount = $this->compliancematrixextcommon->fetchcuvactsdbdata();
        //echo '<pre>';print_r($getecuvactcount);exit;
        $getecuvactcount = count($getecuvactcount);
        $this->view->getecuvactcount= $getecuvactcount;
    }

    public function crmplanmeetingAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        $dbvalues = $this->compliancematrixcommon->dbplannerfetching($getuserid,$cin);
        $this->view->dbvalues = $dbvalues;
        //echo '<pre>'; print_r($dbvalues); exit;
        
        $this->view->mtypes = $this->compliancematrixcommon->fetchMeetingtypes();
        //echo '<pre>'; print_r($this->view->mtypes); exit;
        
        $this->view->gotdepts =  $this->compliancematrixcommon->fetchDepartments();
        //echo '<pre>'; print_r($this->view->gotdepts); exit;
    }

    public function crmeventsAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        $this->view->dbvalues = $this->compliancematrixcommon->dbeventsfetching($getuserid,$cin);
        //echo '<pre>'; print_r($this->view->dbvalues); exit;

        $this->view->lodrevents =  $this->compliancematrixcommon->fetchlodrevents();
        //echo '<pre>'; print_r($this->view->lodrevents); exit;

        $this->view->gotdepts =  $this->compliancematrixcommon->fetchDepartments();
        //echo '<pre>'; print_r($this->view->gotdepts); exit;
    }

    public function crmmatrixAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        $this->view->gotdepts =  $this->compliancematrixcommon->fetchDepartments();
        //echo '<pre>'; print_r($this->view->gotdepts); exit;
        $this->view->gotlevel =  $this->compliancematrixcommon->fetchLevels();
        //echo '<pre>'; print_r($this->view->gotlevel); exit;
        
        $this->view->usercompanies = $this->administratorcommon->allotedAdminUserCompanies($getuserid,$cin);
        //echo '<pre>'; print_r($this->view->usercompanies); exit;
        //$this->view->gotdesig =  $this->companymasterdatacommon->fetchDesignation();
        $this->view->usersections = $this->administratorcommon->allotedAdminUserSections($getuserid,$cin);
        //echo '<pre>'; print_r($this->view->usersections); exit;
    }

    public function crmcalendarAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        //$this->view->emdata = $this->importantduedatescommon->fetch_EMdetails($getuserid);
    }

    public function crmcuvactsAction()
    {
        $getuserid = $this->session->loginauthspuserfront['id'];
        //$this->view->emdata = $this->importantduedatescommon->fetch_EMdetails($getuserid);
    }
    
    /* ########################### Plan Meetings Section1 START ########################### */
    public function saveplannercalendarAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id']; 
        //echo $cin; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $plantype    = $this->request->getPost('plantype', array('striptags', 'trim'));
                $plandesc    = $this->request->getPost('plandesc', array('striptags', 'trim'));
                $plandate    = $this->request->getPost('plandate', array('striptags', 'trim'));
                $deptid      = $this->request->getPost('department', array('striptags', 'trim'));
                $calendarentry    = $this->request->getPost('calendarentry', array('striptags', 'trim'));
                //echo "<pre>"; print_r($plantype);exit;
                //echo $calendarentry; exit;
                
                //Important
                $check = $this->compliancematrixcommon->checkMatrixDataExist($getuserid,$cin,$user_group_id,$deptid); 
                if($check)
                {
                    $getstatus = $this->compliancematrixcommon->saveplannercalendar($getuserid,$cin,$plantype,$plandesc,$plandate,$deptid,$calendarentry);
                    //print_r($getstatus);exit;
                    
                    if($getstatus)
                    {
                        $data = array("logged" => true,'message' => 'Plans Saved Successfully');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Problem in Saving Plans');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Escalation Matrix Not Updated');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function fetchplannerdetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $plannerid = $this->request->getPost('plannerid');
                $commonid = $this->request->getPost('commonid');
                //echo $plannerid.'*'.$commonid; exit;

                $getstatus = $this->compliancematrixcommon->fetchplannerdetails($getuserid,$plannerid,$commonid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function updateplannercalendarAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $plannerid    = $this->request->getPost('plannerid', array('striptags', 'trim'));
                $commonid    = $this->request->getPost('commonid', array('striptags', 'trim'));
                $plantype    = $this->request->getPost('plantype', array('striptags', 'trim'));
                $plandesc    = $this->request->getPost('plandesc', array('striptags', 'trim'));
                $plandate    = $this->request->getPost('plandate', array('striptags', 'trim'));
                $deptid      = $this->request->getPost('department', array('striptags', 'trim'));
                $calendarentry    = $this->request->getPost('calendarentry', array('striptags', 'trim'));
                //echo $deptid; exit;

                //Important
                $check = $this->compliancematrixcommon->checkMatrixDataExist($getuserid,$cin,$user_group_id,$deptid); 
                if($check)
                {
                    $getstatus = $this->compliancematrixcommon->updateplannercalendar($getuserid,$cin,$plannerid,$commonid,$plantype,$plandesc,$plandate,$deptid,$calendarentry);
                    //print_r($getstatus);exit;

                    if($getstatus)
                    {
                        $data = array("logged" => true,'message' => 'Plan Updated Successfully');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Problem in Updating Plan');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Escalation Matrix Not Updated');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function deleteplannercalendarentryAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $plannerid    = $this->request->getPost('plannerid', array('striptags', 'trim'));
                $commonid   = $this->request->getPost('commonid', array('striptags', 'trim'));
                //echo $plannerid.'*'.$commonid;   exit;

                $getstatus = $this->compliancematrixcommon->deleteplannercalendarentry($getuserid,$cin,$plannerid,$commonid);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Plan Deleted Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Deleting Plan');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    /* ########################### Plan Meetings Section1 END ########################### */



    /* ########################### PlanYourEvents Section2 START ########################### */
    public function fetchclickediddetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $clickedid = $this->request->getPost('clickedid');
                //echo $clickedid; exit;

                $getstatus = $this->compliancematrixcommon->fetchclickediddetails($clickedid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function calculateclickeddateAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        /*$pkgvalidity = date('Y-m-d', strtotime($userpackagedetails['pkgstartdate']. '+'.$userpackagedetails['pkgduration'].' days'));*/
        //echo $pkgvalidity; exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $clickeddate = $this->request->getPost('clickeddate');
                $duedays = $this->request->getPost('duedays');
                $lodreventsid = $this->request->getPost('lodreventsid');
                //echo $clickeddate.'*'.$lodreventsid; exit;

                $tempdt = date('Y-m-d', strtotime($clickeddate. $duedays.' days'));
                
                $getstatus = $this->compliancematrixcommon->fetchclickediddetails($lodreventsid);
                //print_r($getstatus); exit;
                
                if($getstatus['holidaylogic']=='0')
                {                    
                    $trigger_date = $tempdt;
                    //echo $trigger_date; exit;
                }
                else
                {
                    //echo $tempdt; exit;
                    
                    // -------------------- HolidaySaturdaySunday Logic START --------------------
                    $hsslogictotal = $this->compliancematrixcommon->logicHolidaysSaturdaysSundays($clickeddate,$tempdt);
                    
                    if($getstatus['holidaylogic']=='-1')
                    {
                        $trigger_date = date('Y-m-d', strtotime($tempdt. '-'.$hsslogictotal.' days'));
                        //echo $trigger_date; exit;
                    }
                    else if($getstatus['holidaylogic']=='+1')
                    {                    
                        $trigger_date = date('Y-m-d', strtotime($tempdt. '+'.$hsslogictotal.' days'));
                        //echo $trigger_date; exit;
                    }
                    // -------------------- HolidaySaturdaySunday Logic END --------------------
                }

                if(!empty($trigger_date))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $trigger_date);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function inserteventscalendarAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $eventname    = $this->request->getPost('lodreventname', array('striptags', 'trim'));
                $eventid      = $this->request->getPost('eventname', array('striptags', 'trim'));
                $eventdate    = $this->request->getPost('eventdate', array('striptags', 'trim'));
                $compliancename   = $this->request->getPost('compliancename', array('striptags', 'trim'));
                $regulator_act    = $this->request->getPost('regulator_act', array('striptags', 'trim'));
                $law              = $this->request->getPost('law', array('striptags', 'trim'));
                $triggerdate      = $this->request->getPost('triggerdate', array('striptags', 'trim'));
                $department       = $this->request->getPost('department', array('striptags', 'trim'));
                $calendarentry    = 1;
                //echo $eventdate.'*'.$triggerdate; exit;

                //Important
                $check = $this->compliancematrixcommon->checkMatrixDataExist($getuserid,$cin,$user_group_id,$department);  
                if($check)
                {
                    $getstatus = $this->compliancematrixcommon->inserteventscalendar($getuserid,$cin,$eventname,$eventdate,$compliancename,$regulator_act,$law,$triggerdate,$department,$calendarentry);
                    //print_r($getstatus);exit;

                    if($getstatus)
                    {

                        //echo '<pre>';print_r($getvaluech);exit;
                        /*if($getvaluech['logged']==true)
                        {*/
                            $data = array("logged" => true,'message' => 'Record Saved Successfully');
                            $this->response->setJsonContent($data);
                        /*}*/
                        /*else
                        {
                            $data = array("logged" => false,'message' => 'Could not found users for department');
                            $this->response->setJsonContent($data);
                        }*/

                    }
                    else{
                        $data = array("logged" => false,'message' => 'Event Already Exists');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Escalation Matrix Not Updated');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function deleteeventscalendarentryAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $eventsid    = $this->request->getPost('eventsid', array('striptags', 'trim'));
                $commonid   = $this->request->getPost('commonid', array('striptags', 'trim'));
                //echo $eventsid.'*'.$commonid;   exit;

                $getstatus = $this->compliancematrixcommon->deleteeventscalendarentry($getuserid,$cin,$eventsid,$commonid);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Plan Deleted Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Deleting Plan');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    
    public function inserteventsviaexcelAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        //echo '<pre>';print_r($this->session->loginauthspuserfront);exit;
        $devicedetect = $this->devicedetect;
        $timeago = time();
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $deptmntid = $this->request->getPost('deptmntname', 'trim');
                //echo $deptmntid; exit;
                
                $userfile_name = $_FILES['eventsexcelfile']['name'];
                //echo $userfile_name;exit;
                $userfile_tmp = $_FILES['eventsexcelfile']['tmp_name'];
                $userfile_size = $_FILES['eventsexcelfile']['size'];
                $userfile_type = $_FILES['eventsexcelfile']['type'];
                $filename = basename($_FILES['eventsexcelfile']['name']);
                //echo $filename;exit;
                
                //Important
                $check = $this->compliancematrixcommon->checkMatrixDataExist($getuserid,$cin,$user_group_id,$deptmntid); 
                if($check)
                {
                    $file_ext = $this->validationcommon->getfileext($filename);
                    $upload_path = $this->compliancematrixfileuploaddir."/";	
                    $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid;               
                    //echo $large_imp_name."*".$file_ext;exit;
                    $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
                    $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);
                    //echo $uploadedornot; exit; 

                    $getresponse = $this->phpimportexpogen->inserteventsviaexcel($getuserid,$cin,$large_impfile_location,$deptmntid);
                    //echo $getresponse; exit;

                    if($getresponse)
                    {
                        $data = array("logged" => true,'message' => 'Events Added Successfully !!','data'=>$getresponse);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Some Events Already Exists So Skipped !!');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Escalation Matrix Not Updated');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();            
            }
            else
            {
                exit('No direct script access allowed isAjax');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    /* ########################### PlanYourEvents Section2 START ########################### */



    /* ########################### Escalation Matrix Section3 START ########################### */
    public function fetchesclnmtxdetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $departmentid = $this->request->getPost('departmentid');
                //echo $departmentid; exit;

                $getstatus = $this->compliancematrixcommon->fetchesclnmtxdetails($getuserid,$cin,$departmentid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertemdataAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $deptid           = $this->request->getPost('dptmntid','trim');
                //echo $deptid; exit;
                $emname           = $this->request->getPost('emname', array('striptags', 'trim'));
                $emdesignation    = $this->request->getPost('emdesignation', array('striptags', 'trim'));
                $ememail          = $this->request->getPost('ememail', array('striptags', 'trim'));
                $emlevel          = $this->request->getPost('emlevel', array('striptags', 'trim'));
                $emdays           = $this->request->getPost('emdays', array('striptags', 'trim'));
                //echo "<pre>"; print_r($emname);exit;

                if(empty($deptid))
                {
                    $data = array("logged" => false,'message' => 'Please Select Department Before Submiting');
                    $this->response->setJsonContent($data);
                }
                else if(empty($emname))
                {
                    $data = array("logged" => false,'message' => 'Please Enter Name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($emdesignation))
                {
                    $data = array("logged" => false,'message' => 'Please Enter Designation');
                    $this->response->setJsonContent($data);
                }
                else if(empty($ememail))
                {
                    $data = array("logged" => false,'message' => 'Please Enter Email');
                    $this->response->setJsonContent($data);
                }
                else if(empty($emlevel))
                {
                    $data = array("logged" => false,'message' => 'Please Select Level');
                    $this->response->setJsonContent($data);
                }
                else if(empty($emdays))
                {
                    $data = array("logged" => false,'message' => 'Please Enter Days');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $getstatus = $this->compliancematrixcommon->insertemdata($getuserid,$cin,$deptid,$emname,$emdesignation,$ememail,$emlevel,$emdays);
                    //print_r($getstatus);exit;

                    if($getstatus)
                    {
                        $data = array("logged" => true,'message' => 'User Added Successfully');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'User Already Exists');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function fetchemiddetailsAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $emid = $this->request->getPost('emid');
                //echo $emid; exit;

                $getstatus = $this->compliancematrixcommon->fetchemiddetails($getuserid,$cin,$emid);
                //print_r($getstatus); exit;

                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => "No Data Found!!!");
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function updateemiddataAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $emid             = $this->request->getPost('emid', array('striptags', 'trim'));
                $emname           = $this->request->getPost('emname', array('striptags', 'trim'));
                $emdesignation    = $this->request->getPost('emdesignation', array('striptags', 'trim'));
                $ememail          = $this->request->getPost('ememail', array('striptags', 'trim'));
                $emlevel          = $this->request->getPost('emlevel', array('striptags', 'trim'));
                $emdays          = $this->request->getPost('emdays', array('striptags', 'trim'));
                //echo $emid;exit;

                $getstatus = $this->compliancematrixcommon->updateemiddata($getuserid,$cin,$emid,$emname,$emdesignation,$ememail,$emlevel,$emdays);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Record Updated Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Updating Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function deleteemidentryAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $emid    = $this->request->getPost('emid', array('striptags', 'trim'));
                //echo $emid;   exit;

                $getstatus = $this->compliancematrixcommon->deleteemidentry($getuserid,$cin,$emid);
                //print_r($getstatus);exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Record Deleted Successfully');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Problem in Deleting Record');
                    $this->response->setJsonContent($data);
                }

                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    public function insertemusersviaexcelAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        //echo '<pre>';print_r($this->session->loginauthspuserfront);exit;
        $devicedetect = $this->devicedetect;
        $timeago = time();
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $emdeptid = $this->request->getPost('exlemdept', 'trim');
                $emlevel = $this->request->getPost('exlemlevel', 'trim');
                //echo $emdeptid; exit;
                
                $userfile_name = $_FILES['emexcelfile']['name'];
                //echo $userfile_name;exit;
                $userfile_tmp = $_FILES['emexcelfile']['tmp_name'];
                $userfile_size = $_FILES['emexcelfile']['size'];
                $userfile_type = $_FILES['emexcelfile']['type'];
                $filename = basename($_FILES['emexcelfile']['name']);
                //echo $filename;exit;
                
                
                $file_ext = $this->validationcommon->getfileext($filename);
                $upload_path = $this->compliancematrixfileuploaddir."/";	
                $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid;               
                //echo $large_imp_name."*".$file_ext;exit;
                $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
                $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);
                //echo $uploadedornot; exit; 

                $getresponse = $this->phpimportexpogen->insertemusersviaexcel($getuserid,$cin,$large_impfile_location,$emdeptid,$emlevel);
                //echo $getresponse; exit;

                if($getresponse)
                {
                    $data = array("logged" => true,'message' => 'Users Added Successfully !!','data'=>$getresponse);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Some Users Already Exists So Not Added !!');
                    $this->response->setJsonContent($data);
                }                
                
                $this->response->send();            
            }
            else
            {
                exit('No direct script access allowed isAjax');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }        
    }
    /* ########################### Escalation Matrix Section3 END ########################### */
    
    


}
