<?php
class DashboardcomplianceController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['websitetitle']);
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo ':frontend user::';print_r($this->session->loginauthsuser);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $getuser_grpid = $this->session->loginauthspuserfront['user_group_id'];
        
        $this->view->dashboardvalues = $this->dashboardcompliancecommon->lodrdashboardfetching();
        //echo '<pre>'; print_r($dashboardvalues); exit;
        
        //$duedays = $this->dashboardcompliancecommon->duedayscalculation('2016-11-21','21','11','21');
    }
    
    
    public function complianceAction()
    {
        
    }
    
    
    public function duedayscalculationAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                
                $fulldate   = $this->request->getPost('fulldate', 'trim'); 
                $day        = $this->request->getPost('day', 'trim');
                $month      = $this->request->getPost('month', 'trim'); 
                $year       = $this->request->getPost('year', 'trim');
                
                //echo $fulldate."*".$day."-".$month."-".$year; exit;
                
                $duedaysarray = $this->dashboardcompliancecommon->duedayscalculation($fulldate,$day,$month,$year);
                //echo $duedaysarray; exit;
                //echo '<prev>'; print_r($duedaysarray); exit;

                if(!empty($duedaysarray))
                {
                    //echo 'in if'; exit;
                    $data = array("logged" => true,'message' => 'DueDays Calculation Done', 'data'=> $duedaysarray);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'DueDays Calculation Not Done');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    
    
    /* ########################### LODR Notification Reminder SECTION Start ########################### */
    public function reminder_configLODRAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {  
                $lodrdate = $this->request->getPost('lodrdate');
                //echo $lodrdate; exit;
                                
                $today = date('Y-m-d');
                //echo $today; exit;
                
                if(empty($lodrdate))
                {
                    $data = array("logged" => false,'message' => 'Please select Date to SET Reminder.');
                    $this->response->setJsonContent($data);
                }
                else if($lodrdate<$today)
                {
                    $data = array("logged" => false,'message' => 'Date cannot be selected in Past');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    //---------------------get LODR days minus---------------------- 
                    $duedaysarray = $this->dashboardcompliancecommon->duedayscalculation($lodrdate,'','','');
                    //echo '<prev>'; print_r($duedaysarray); exit;
                    //---------------------get LODR days minus---------------------- 

                    $getstatus = $this->dashboardcompliancecommon->reminder_configLODR($getuserid,$lodrdate,$duedaysarray);
                    //echo '<pre>'; print_r($getstatus);exit;                

                    if($getstatus)
                    {
                        $data = array("logged" => true,'message' => 'Reminder has been SET');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Problem in setting Reminder');
                        $this->response->setJsonContent($data);
                    }
                }                                

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    /* ########################### LODR Notification Reminder SECTION End ########################### */
    

}
