<?php
class ExistingclientsController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Existing Clients']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        
    }

    public function createcontactAction()
    {
        
    }

    public function insertcontactAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];

       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {

                $firstname= $this->request->getPost('firstname', 'trim'); 
                $lastname= $this->request->getPost('lastname', 'trim');
                $email = strtolower($this->request->getPost('email', 'trim'));
                $mobile= $this->request->getPost('mobile', 'trim');
                $officephone= $this->request->getPost('officephone', 'trim');
                $description= $this->request->getPost('description', 'trim');
                $street= $this->request->getPost('street', 'trim');
                $city= $this->request->getPost('city', 'trim');
                $postalcode= $this->request->getPost('postalcode', 'trim');
                $state= $this->request->getPost('state', 'trim'); 

                //perform validations on values
                $firstnamecheck =  $this->elements->allownumalphahyphen($firstname);
                $lastnamecheck =  $this->elements->allownumalphahyphen($lastname);
                $email_check = $this->validationcommon->emailvalidate($email);

                //Return message for empty post values
                if(empty($firstname))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Your First Name','fieldname'=>'firstnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if(empty($lastname))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Your Last Name','fieldname'=>'lastnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if($firstnamecheck==true)
                {
                    $data = array("logged" => false,'message' => 'Your Firstname Contains Special Character','fieldname'=>'firstnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if($lastnamecheck==true)
                {
                    $data = array("logged" => false,'message' => 'Your Lastname Contains Special Character','fieldname'=>'lastnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if($email_check==false)
                {
                    $data = array("logged" => false,'message' => 'Your Email is not valid','fieldname'=>'emailerrormsg','actualvalue'=>$email);
                    $this->response->setJsonContent($data);
                }
                else
                {   
                    $getstatus = $this->existingclientscommon->createcontact($getuserid, $firstname, $lastname, $email, $mobile, $officephone, $description, $street, $city, $postalcode, $state);

                    if($getstatus == true)
                    {
                        $data = array("logged" => true,'message' => 'Got Your data');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Data not received');
                        $this->response->setJsonContent($data);
                    }
                    
                }
                $this->response->send();
                $connection->close();

            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
                $connection->close();
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }

    }

    public function viewcontactAction()
    {
        //$connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        $this->view->contactscreated =  $this->existingclientscommon->fetchCreatedContacts($getuserid);
        //echo '<pre>'; print_r($this->view->contactscreated); exit;

        //$connection->close(); 
    }




    public function createaccountAction()
    {
        $this->view->gotcontact =  $this->existingclientscommon->fetchContacts();
        //echo '<pre>'; print_r($this->view->gotcontact); exit; 
    }

    public function insertaccountAction()
    {
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        $this->view->disable();
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {

                $company= $this->request->getPost('company', 'trim'); 
                $tempid= $this->request->getPost('contactid', 'trim');
                $contactid = explode(",", $tempid);
                //print_r($contactid); exit;

                $street= $this->request->getPost('street', 'trim');
                $city= $this->request->getPost('city', 'trim');
                $state= $this->request->getPost('state', 'trim');
                $postalcode= $this->request->getPost('postalcode', 'trim');
                $pan= $this->request->getPost('pan', 'trim'); 
                $tan= $this->request->getPost('tan', 'trim');
                $vat= $this->request->getPost('vat', 'trim');
                $stax= $this->request->getPost('stax', 'trim');
                $ptax= $this->request->getPost('ptax', 'trim');
                $emp= $this->request->getPost('emp', 'trim');
                
                //echo '<pre>'; print_r($contactid); exit;
                /*foreach($contactid as $key => $value)
                { 
                    echo $value;
                } 
                exit;*/
                
                //Return message for empty post values
                if(empty($company))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Company Name','fieldname'=>'companynameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if(empty($contactid))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Contact Name','fieldname'=>'contactnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else
                {   
                    $getstatus = $this->existingclientscommon->createaccount($getuserid, $company, $contactid, $street, $city, $state, $postalcode, $pan, $tan, $vat, $stax, $ptax, $emp);

                    if($getstatus == true)
                    {
                        $data = array("logged" => true,'message' => 'Got Your data');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Data not received');
                        $this->response->setJsonContent($data);
                    }
                    
                }
                $this->response->send();
                $connection->close();

            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
                $connection->close();
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }

    }


    public function viewaccountAction()
    {
        //$connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        $this->view->accountscreated =  $this->existingclientscommon->fetchCreatedAccounts($getuserid);
        //echo '<pre>'; print_r($this->view->accountscreated); exit;

       // $connection->close(); 
    }


    /*----------------------Search Contact name (create account form)--------------------*/
    public function resultAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauths['id'];
        
        if($this->request->isPost() == true) 
        {
            //si es una petición ajax
            if($this->request->isAjax() == true) 
            {
                $getsearchkywo = $this->request->getPost('getsearchwo');
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "trim");
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "string");
                
                if(preg_match("/[A-Za-z]+/", $getsearchkywo))
                { 
                    $getsearchkywo = $getsearchkywo;
                    $limit = 10;
                    $mainarray = $this->existingclientscommon->yoursearchexe($getsearchkywo,$limit);
                    $getcount = $this->existingclientscommon->yoursearchcount($getsearchkywo,$limit);   
                    
                    if(($getcount)>0)
                    {
                        foreach($mainarray as $getarray){
                                    
                                    $responsearray[] = array(
                                    'contactname' => $getarray['firstname']." ".$getarray['lastname'],
                                    'contactid'=>$getarray['contactid']  
                                        
                            );
                        }
                            
                        $data = array("logged" => true,'message' => 'Found!!!' ,'data'=> $responsearray,'count'=> $getcount);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'No Result Found !!!');
                        $this->response->setJsonContent($data);
                    }   
                }
                else
                {
                    $data = array("logged" => false,'message' => 'No result Found!!!');
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
            
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }



}
