<?php
class FasttrackexitController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Fast Track Exit']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        //$this->view->matched_categories = $this->fasttrackexitcommon->fetchMatchedCategories();
    }

    public function generateformsAction()
    {
        
    }

    public function fteblocksAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getsearchkywo = $this->request->getPost('getsearchwo');
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "trim");
                $getsearchkywo = $this->filter->sanitize($getsearchkywo, "string");
                //echo $getsearchkywo; exit;

                if(preg_match("/[A-Za-z]+/", $getsearchkywo)){
                $getsearchkywo = $getsearchkywo;
                $limit = 12;
                $mainarray = $this->fasttrackexitcommon->yourserviceexe($getsearchkywo,$limit);
                $getcount = $this->fasttrackexitcommon->yourservicecount($getsearchkywo,$limit);

                    if(($getcount)>0)
                    {
                        foreach($mainarray as $getarray){
                                    $responsearray[] = array(
                                    'id' => $getarray['id'],
                                    'name' => $getarray['name']
                            );
                        }

                        $data = array("logged" => true,'message' => 'Found!!!' ,'data'=> $responsearray,'count'=> $getcount);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'No Result Found !!!');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'No result Found!!!');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    public function fteblockdetailsAction()
    {          
        $this->view->disable();
        $connection = $this->db;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $fteblockid   = $this->request->getPost('fteblockid');
                $fteblockname = $this->request->getPost('fteblockname'); 
                //echo $fteblockid; exit;

                $getstatus = $this->fasttrackexitcommon->fteblockfields($fteblockid);
                //print_r($getstatus); exit;
                if($getstatus == true){
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "Input Fields For This Service Not Found !");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }        
    }


    public function ftegenerateresolutionAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $fteid = $this->request->getPost('fteid','trim'); 
                //echo $fteid; exit;               
                
                $getres = $this->fasttrackexitcommon->fteloadhtml($fteid);
                //echo $getres; exit;
                
                /*-------------------- Create Directory For User Tracking ----------------------*/
                $getdirectoryname = $this->session->profilecommondir['createdirname'];
                $dir = $this->pdfdownloadftedir.'/';
                $upload_dir = $dir.$getdirectoryname;
                $upload_dir_pdf = $dir.$getdirectoryname;
               // echo $getdirectoryname; exit;

                $getcurrentyear = date("Y");
                $getcurrentmonth = date("M");
                $getcurrentdate = date("Y-m-d");

                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                $upload_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                $final_dir = $upload_dir_pdf."/".$getcurrentyear."/".$getcurrentmonth;
                if(!is_dir($upload_dir)){mkdir($upload_dir, 0777);chmod($upload_dir, 0777);}
                
                /*-------------------- Create Directory For User Tracking END ----------------------*/
                
                if($getres)
                {
                    $data = array("logged" => true,'message' => 'Got Your data','data'=>$getres,'dir'=>$final_dir);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'File does not Exist');
                    $this->response->setJsonContent($data);
                }                

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }


    public function getftereformelementAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
             
                $getfullstrin = $this->request->getPost('getfullstrin','trim');
                //echo '<pre>';print_r($getfullstrin); exit;
                $fteid =  $this->request->getPost('fteid','trim');
               
                
                $newarray = $this->fasttrackexitcommon->fetchfullftestrin($getfullstrin);
                //echo '<pre>';print_r($newarray); exit;
                $getservalue = $this->fasttrackexitcommon->fetchftevalue($fteid);
                //echo '<pre>';print_r($getservalue); exit;
                
                //echo sizeof($newarray);echo sizeof($getservalue).'<br>';
                if(sizeof($newarray) == sizeof($getservalue))
                {
                    $commonarraymerge = array_combine($getservalue,$newarray);
                    //echo '<pre>';print_r($commonarraymerge); exit;
                    
                    /*-------------------- Update CustomerData For User Tracking ----------------------*/
                    $getre = $this->customerusercommon->updateresolutionentry($getuserid,'','config_fte_resolution',$fteid); 
                    
                    if($getre['logged']==true)
                    {$getnidm= $getre['idget'];}else
                    {$getnidm=''; }
                    /*-------------------- Update CustomerData For User Tracking ----------------------*/
                  
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $commonarraymerge, 'trckid'=>$getnidm);
                    $this->response->setJsonContent($data);

                }
                else
                {
                    $data = array("logged" => false,'message' => 'Something went wrong!!! Please wait we are upgrading something.');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }


    public function ftepdfgenerationAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];        
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {              
                $pdf_content = $this->request->getPost('htmldata');
                $gettrackidfor = $this->request->getPost('gettrackidfor','trim'); //for User Tracking CustomerData
                //echo $gettrackidfor; exit;
            
                if(!empty($getuserid))
                {
                    $getpdfpath = $this->dompdfgen->getpdf($pdf_content,'fte','fasttrackexit','configfte');
                    //echo $getpdfpath; exit;
                    if(!empty($getpdfpath) || $getpdfpath)
                    {
                        $this->customerusercommon->updateresolutiongen($getuserid,$gettrackidfor); //for User Tracking CustomerData
                        
                        $data = array("logged" => true,'message' => 'You can Download pdf of Resolution','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Something went wrong please contact','pdfpath'=>$getpdfpath);
                        $this->response->setJsonContent($data);
                    }

                }
                else
                {
                    $data = array("logged" => false,'message' => 'You are cheating with console.');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }

    }





}
