<?php
class ImportantduedatesController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['Important Due Dates']);
        
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthspuserfront);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $date=date('Y-m-d');
        //echo $date; exit;
        
        $getuserid = $this->session->loginauthspuserfront['id'];
        //$this->view->emdata = $this->importantduedatescommon->fetch_EMdetails($getuserid);
    }
    
    public function createeventformAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {

                $eventname   = $this->request->getPost('eventname', 'trim'); 
                $description = $this->request->getPost('description', 'trim');
                $startdate   = $this->request->getPost('startdate', 'trim');
                $enddate     = $this->request->getPost('enddate', 'trim');
                //echo $enddate; exit;
                
                //--------------SPLIT Date-------------------
                    list($startyear,$startmonth,$day)=explode("-", $startdate);
                    //echo $startyear; exit;                
                    list($endyear,$endmonth,$eday)=explode("-", $enddate);
                    //echo $endyear; exit;
                //--------------SPLIT Date End------------------
                
                
                //--------------JOIN yearmonth-------------------
                $start_yearmonth = $startyear."-".$startmonth;
                $end_yearmonth = $endyear."-".$endmonth;
                //--------------JOIN yearmonth END-------------------
                
                
                //Return message for empty post values
                if(empty($eventname))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Event Name','fieldname'=>'Eventnameerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if(empty($description))
                {
                    $data = array("logged" => false,'message' => 'Please Provide Description','fieldname'=>'Descriptionerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if(empty($startdate))
                {
                    $data = array("logged" => false,'message' => 'Please Start Date for Event','fieldname'=>'StartDateerrormsg');
                    $this->response->setJsonContent($data);
                }
                else if(empty($enddate))
                {
                    $data = array("logged" => false,'message' => 'Please End Date for Event','fieldname'=>'EndDateerrormsg');
                    $this->response->setJsonContent($data);
                }
                else
                {   
                    $getstatus = $this->importantduedatescommon->CreateEvent($getuserid, $eventname, $description, $startdate, $enddate, $startyear, $endyear, $startmonth, $endmonth, $day, $start_yearmonth, $end_yearmonth);
                    
                    //echo $getstatus; exit;

                    if($getstatus == true)
                    {
                        $data = array("logged" => true,'message' => 'Got Your data');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Data not received');
                        $this->response->setJsonContent($data);
                    }
                    
                }
                $this->response->send();
                $connection->close();

            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
                $connection->close();
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }

    }
    

    
    public function fetchEventDetailsAction()
    {
          
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $year= $this->request->getPost('year');
                $month= $this->request->getPost('month'); 
                //echo $year,$month; exit;

                $getstatus = $this->importantduedatescommon->getEventDetails($getuserid,$year,$month);
                //print_r($getstatus); exit;
                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Event Found!!!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
        
        
    public function fetchAllEventDetailsAction()
    {
          
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {

                $date= $this->request->getPost('date');
                $day = $this->request->getPost('day');
                //echo $date; exit;

                $getstatus = $this->importantduedatescommon->getAllEventDetails($getuserid,$date,$day);
                //print_r($getstatus); exit;
                
                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Event Found!!!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    
    public function deleteEventFieldAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {

                $eventid = $this->request->getPost('eventid', 'trim');
                //echo $eventname; exit;
                
                //Return message for empty post values
                if(empty($eventid))
                {
                    $data = array("logged" => false,'message' => 'Event ID not Found','fieldname'=>'Eventiderrormsg');
                    $this->response->setJsonContent($data);
                }
                else
                {   
                    $getstatus = $this->importantduedatescommon->DeleteEvent($eventid);
                    
                    if($getstatus == true)
                    {
                        $data = array("logged" => true,'message' => 'Event Deleted');
                        $this->response->setJsonContent($data);
                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Cannot Delete Event');
                        $this->response->setJsonContent($data);
                    }                    
                }
                $this->response->send();
                $connection->close();

            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
                $connection->close();
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    
    
    public function compliancecalendarAction()
    {
        
    }
    
    public function sectorspecificAction()
    {
        
    }
    
    
    public function fetchComplianceEventsAction()
    {
          
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $fulldate = $this->request->getPost('fulldate');
                $day      = $this->request->getPost('day');
                $month    = $this->request->getPost('month');
                $year    = $this->request->getPost('year');
                $type     = $this->request->getPost('type');
                //echo $fulldate.'--'.$day.'--'.$month.'--'.$year.'--'.$type; exit;

                $getstatus = $this->importantduedatescommon->getComplianceEvents($getuserid,$month,$type);
                //print_r($getstatus); exit;
                $countget = count($getstatus);
                //echo '<pre>';print_r($getstatus);exit;
                if($countget !=0)
                {
                    $data = array("logged" => true,'message' => 'Compliance Event Found' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Compliance Event Found!!!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    
    
    public function fetchComplianceEventDetailsAction()
    {          
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;

        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $date  = $this->request->getPost('date');
                $day   = $this->request->getPost('day');
                $month = $this->request->getPost('month');
                $type = $this->request->getPost('type');
                //echo $date.'--'.$day.'--'.$month.'--'.$type; exit;

                $getstatus = $this->importantduedatescommon->getComplianceEventDetails($getuserid,$date,$day,$month,$type);
                //print_r($getstatus); exit;
                
                if(!empty($getstatus))
                {
                    $data = array("logged" => true,'message' => 'Got Your data' , 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => "No Event Found!!!");
                    $this->response->setJsonContent($data);
                }
                
                $this->response->send();
                $connection->close();
            }
            else
            {
                exit('No direct script access allowed');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }        
    }
    
    
    public function fetchEMdataAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                $getstatus = $this->importantduedatescommon->fetch_EMdetails($getuserid);
                //echo $getstatus; exit;
                //echo '<prev>'; print_r($getstatus); exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Escalation Matrix Data Received', 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Not Received Escalation Matrix Data');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    
    public function escalationmatrixformAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {
                $lone_name   = $this->request->getPost('lone_name', 'trim'); 
                $lone_email  = $this->request->getPost('lone_email', 'trim');
                $ltwo_name   = $this->request->getPost('ltwo_name', 'trim'); 
                $ltwo_email  = $this->request->getPost('ltwo_email', 'trim');
                $lthree_name = $this->request->getPost('lthree_name', 'trim'); 
                $lthree_email= $this->request->getPost('lthree_email', 'trim');
                $lfour_name  = $this->request->getPost('lfour_name', 'trim'); 
                $lfour_email = $this->request->getPost('lfour_email', 'trim');
                
                //echo $lone_name."-".$lone_email."-".$ltwo_name."-".$ltwo_email."-".$lthree_name."-".$lthree_email."-".$lfour_name."-".$lfour_email; exit;                
                   
                $getstatus = $this->importantduedatescommon->EscalationMatrixForm($getuserid, $lone_name, $lone_email, $ltwo_name, $ltwo_email, $lthree_name, $lthree_email, $lfour_name, $lfour_email);

                //echo $getstatus; exit;

                if($getstatus)
                {
                    $data = array("logged" => true,'message' => 'Escalation Matrix Data Received');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Not Received Escalation Matrix Data');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
                $connection->close();
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    
    /*------------------------------ (rushi) NOTIFICATIONS on day Section START ---------------------------*/
    public function fetchnotificationsAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                $fulldate   = $this->request->getPost('fulldate', 'trim'); 
                $day        = $this->request->getPost('day', 'trim');
                $month      = $this->request->getPost('month', 'trim'); 
                $year       = $this->request->getPost('year', 'trim');
                //echo $fulldate."*".$day."-".$month."-".$year; exit;
                
                $notifications = $this->importantduedatescommon->triggerNotifications($getuserid,$fulldate,$day,$month,$year);
                //echo $notifications; exit;
                //echo '<prev>'; print_r($notifications); exit;

                if(!empty($notifications))
                {
                    //$user_emdetails = $this->importantduedatescommon->fetchuser_emdetails($getuserid);
                    //echo '<prev>'; print_r($user_emdetails); exit;
                    
                    $data = array("logged" => true,'message' => 'Notifications PRESENT', 'data'=> $notifications);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'There are NO Notifications');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    public function emailnotificationsAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                $fulldate   = $this->request->getPost('fulldate', 'trim'); 
                $day        = $this->request->getPost('day', 'trim');
                $month      = $this->request->getPost('month', 'trim'); 
                $year       = $this->request->getPost('year', 'trim');
                //echo $fulldate."*".$day."-".$month."-".$year; exit;
                
                $notifications = $this->importantduedatescommon->emailNotifications($getuserid,$fulldate,$day,$month,$year);
                //echo '<prev>'; print_r($notifications); exit;
                                
                $user_emdetails = $this->importantduedatescommon->fetchuser_emdetails($getuserid);
                //echo '<prev>'; print_r($user_emdetails); exit;
                
                $arrlen_noti = sizeof($notifications);
                //echo $arrlen_noti; exit;
                $arrlen_uemd = sizeof($user_emdetails);
                //echo $arrlen_uemd; exit;
                
                
                if(!empty($notifications))
                {
                    $snoozemax = 0;
                    foreach($notifications as $tempobj)
                    {   
                        //echo $tempobj['snoozecount'];
                        if($tempobj['snoozecount'] > $snoozemax)
                        {
                            $snoozemax = $tempobj['snoozecount'];
                        }
                    }
                    //echo $snoozemax; exit;
                    
                    
                    for($rs=0; $rs<$arrlen_uemd; $rs++)    //NOTE: sometimes $arrlen_uemd can be lesser than $snoozemax
                    {                        
                        $name = $user_emdetails[$rs]['name'];
                        $email = $user_emdetails[$rs]['email'];
                        //echo $email;
                        
                        if($rs < $snoozemax)   
                        {
                            //--------------------------- Emailer Send --------------------------------------
                            $getactualemail    = trim(strtolower($email));
                            $mssg = 'Dear '.$name.', There are some Transactions which require your attention. Please open the panel and confirm whether things have been done or not.';
                            //echo $mssg; exit;
                            $getbody = 'Hello this is HTML Page';

                            $Mail = $this->emailer;                    
                            $emailsent = '';
                            $getg = $Mail->notificationsendmail($getactualemail,$name,$mssg,$getbody);

                            if($getg['logged']==true)
                            {$emailsent='1';}else{$emailsent='0';}

                            $timeago = time();
                            $randomcodeemail =  $this->validationcommon->randomcodegen_alphanum(20);
                            $emailverify = ("INSERT INTO `web_notification_emailsent` (`user_id`,`email`, `status`, `verfiycode`,`date_added`,`date_modified`,timeago) VALUES ('".$getuserid."','".$getactualemail."','".$emailsent."', '".$randomcodeemail."',NOW(),NOW(),'".$timeago."')");
                            $connection->execute($emailverify);
                            $get = array('logged'=>true,'message'=>'inserted');                            
                            //--------------------------- Emailer Send ---------------------------------------
                        }
                    }                    
                }
                //print_r($get['logged']); exit;
                
                
                if($get['logged'] == true )
                {   
                    //echo 'In IF'; exit;
                    $data = array("logged" => true,'message' => 'Notification Email Sent', 'data'=> $notifications);
                    $this->response->setJsonContent($data);
                }
                else
                {   
                    //echo 'In Else'; exit;
                    $data = array("logged" => false,'message' => 'Notification Email Not Sent');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    
    
    public function snoozenotificationAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                $notification_id   = $this->request->getPost('notification_id', 'trim'); 
                $duedate            = $this->request->getPost('duedate', 'trim');
                $trigger_date      = $this->request->getPost('trigger_date', 'trim');
                $snoozecount       = $this->request->getPost('snoozecount', 'trim');
                //echo $notification_id."*".$duedate."*".$trigger_date."*".$snoozecount; exit;
                
                if($snoozecount<=3)
                {
                    $newsnoozecount = $snoozecount+1;
                    $newtrigger = date('Y-m-d', strtotime($trigger_date. '+7 days'));
                }
                else
                {
                    $newsnoozecount = $snoozecount;
                    $newtrigger = date('Y-m-d', strtotime($trigger_date. '+7 days'));
                }                
                //echo $newstatus."*".$newtrigger; exit;
                
                $getstatus = $this->importantduedatescommon->snoozenotification($getuserid,$notification_id,$newsnoozecount,$newtrigger);
                //echo $getstatus; exit;
                //echo '<prev>'; print_r($getstatus); exit;

                if($getstatus == true)
                {
                    $data = array("logged" => true,'message' => 'Notification SNOOZED', 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Problem in Notification SNOOZING');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
        
    
    public function doneproofuploadAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        $timeago = time();
        //echo '<pre>';print_r($this->session->loginauthspuserfront);exit;
        $devicedetect = $this->devicedetect;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $notification_id = $this->request->getPost('notification_id');
                $duedate = $this->request->getPost('duedate');
                $trigger_date = $this->request->getPost('trigger_date');
                $snoozecount = $this->request->getPost('snoozecount');
                //echo $snoozecount;exit;
                
                $userfile_name = $_FILES['fileproof']['name'];
                //echo $userfile_name;exit;
                $userfile_tmp = $_FILES['fileproof']['tmp_name'];
                $userfile_size = $_FILES['fileproof']['size'];
                $userfile_type = $_FILES['fileproof']['type'];
                $filename = basename($_FILES['fileproof']['name']);
                //echo $filename;exit;
                $file_ext = $this->validationcommon->getfileext($filename);
                
                //$upload_path = "img/category/services/notificationfiles/";
                $upload_path = $this->notificationuploaddir."/";
                //echo $upload_path; exit;
                $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid.'_timeago-'.$timeago;
                $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
                $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);
                
                if($uploadedornot)
                {
                    $data = array("logged" => true,'message' => 'File Uploaded','path'=>$large_impfile_location, 'notification_id'=>$notification_id, 'duedate'=>$duedate, 'trigger_date'=>$trigger_date, 'snoozecount'=>$snoozecount);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'File not Uploaded');
                    $this->response->setJsonContent($data);
                }                

                $this->response->send();            
            }
            else
            {
                exit('No direct script access allowed isAjax');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }        
    }
    
    
    public function donenotificationAction()
    {
        $connection = $this->db;
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo $getuserid;exit;
       
        if($this->request->isPost() == true) 
        {
            if($this->request->isAjax() == true) 
            {   
                $notification_id   = $this->request->getPost('notification_id', 'trim'); 
                $duedate            = $this->request->getPost('duedate', 'trim');
                $trigger_date      = $this->request->getPost('trigger_date', 'trim');
                $snoozecount       = $this->request->getPost('snoozecount', 'trim');
                //echo $notification_id."*".$duedate."*".$trigger_date."*".$snoozecount; exit;
                                
                $getstatus = $this->importantduedatescommon->donenotification($getuserid,$notification_id);
                //echo $getstatus; exit;
                
                $user_emdetails = $this->importantduedatescommon->fetchuser_emdetails($getuserid);                    
                //echo '<prev>'; print_r($user_emdetails); exit;
                
                
                if($getstatus == true)
                {
                    foreach($user_emdetails AS $user)
                    {
                        //--------------------------- Emailer Send -------------------------------------------------
                        $getactualemail    = trim(strtolower($user['email']));
                        $mssg = 'Dear '.$user['name'].', Your Transaction Due on = '.$duedate.' is done.';
                        //echo $mssg; exit;
                        $getbody = 'Hello this is HTML Page';

                        $Mail = $this->emailer;                    
                        $emailsent = '';
                        $getg = $Mail->notificationsendmail($getactualemail,$user['name'],$mssg,$getbody);

                        if($getg['logged']==true)
                        {$emailsent='1';}else{$emailsent='0';}

                        $timeago = time();
                        $randomcodeemail =  $this->validationcommon->randomcodegen_alphanum(20);
                        $emailverify = ("INSERT INTO `web_notification_emailsent` (`user_id`,`email`, `status`, `verfiycode`,`date_added`,`date_modified`,timeago) VALUES ('".$getuserid."','".$getactualemail."','".$emailsent."', '".$randomcodeemail."',NOW(),NOW(),'".$timeago."')");
                        $connection->execute($emailverify);
                        $get = array('logged'=>true,'message'=>'inserted','email'=>$getg['message']);
                        
                        //--------------------------- Emailer Send /-------------------------------------------------
                    }
                    
                    
                    $data = array("logged" => true,'message' => 'Successfully Closed Notification', 'data'=> $getstatus);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Problem in Closing Notification');
                    $this->response->setJsonContent($data);
                }
                $this->response->send();
            }
            else
            {
                //echo ("<script>location.href='adminpanel/newleadsrecord'</script>");
                exit('No direct script access allowed isAjax');
            }
        } 
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed isPost');
        }
    }
    /*------------------------------ (rushi) NOTIFICATIONS on day Section END ---------------------------*/
   
   
}
