<?php
class IncometaxController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['websitetitle']);
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //echo ':frontend user::';print_r($this->session->loginauthsuser);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $this->view->personalinfo = $this->session->personalinfo;
        //echo "<pre>";print_r($this->view->personalinfo);exit;
        $this->view->address = $this->session->useraddress;
        $this->view->additionalinfo = $this->session->addinfo;
        $this->view->otherdetails = $this->session->othrdet;
        $yeararr = array();
        $cur_yearend  = date('Y',strtotime("-8 year"));
        for ($i=1; $i<=8; $i++) {
            $yeararr[] = $cur_yearend++.'-'.substr(date($cur_yearend,strtotime("+1 year")), -2);
        }
        $this->view->countrydetails = $this->incometaxcommon->getcountries();
        $this->view->statelist      = $this->incometaxcommon->getstatelist();
        //$this->view->getgeostates   = $this->incometdscommon->getgeostates();
        //$this->view->gettdsgovttype = $this->incometdscommon->gettdsgovttype();
        $this->view->frmsixsections = $this->incometaxcommon->getfrmsixsections();
        $this->view->frmotherssections = $this->incometaxcommon->getfrmotherssections();
        $this->view->getyeararr     = $yeararr;
    }

    //This is step two actions start here
    public function incometaxsteptwoAction()
    {
            //echo "<pre>";print_r($this->session->otherincomefour);exit;
            $this->session->set('steptwo',
                array('salone' => $this->session->salinfoone,
                'saltwo' => $this->session->salinfotwo,
                'oione' => $this->session->otherincomeone,
                'oitwo' => $this->session->otherincometwo,
                'oithree' => $this->session->otherincomethree,
                'oifour' => $this->session->otherincomefour,
                'oifive' => $this->session->otherincomefive,
                'oisix' => $this->session->otherincomesix,
                'hpfrmone' => $this->session->hpfrmone,
                'hpfrmtwo' => $this->session->hpfrmtwo,
                'hpfrmthree' => $this->session->hpfrmthree,
                'hpfrmfour' => $this->session->hpfrmfour
            ));
        //echo "<pre>";print_r($this->session->addinfo);exit;
        $sessarr = $this->session->steptwo;
        //echo "<pre>";print_r($sessarr).'<br>';exit;
        $this->view->statelist = $this->incometaxcommon->getstatelist();
        $this->view->frmotherssections = $this->incometaxcommon->getfrmotherssections();
        $this->view->countrydetails = $this->incometaxcommon->getcountries();
        $this->view->sessarr = $sessarr;
        //echo "<pre>";print_r($this->session->salinfotwo).'<br>';exit;
    }

    public function incometaxstepthreeAction()
    {
        $this->view->statelist = $this->incometaxcommon->getstatelist();
        $this->view->frmsixsections = $this->incometaxcommon->getfrmsixsections();
        $yeararr = array();
        $cur_yearend  = date('Y',strtotime("-8 year"));
        for ($i=1; $i<=8; $i++) {
            $yeararr[] = $cur_yearend++.'-'.substr(date($cur_yearend,strtotime("+1 year")), -2);
        }
        $this->view->getyeararr = $yeararr;
        //echo "<pre>";print_r($this->session->tdsfrmtwo);exit;
        $this->view->egonefrm = $this->session->egonefrm['egonefrm']; 
        //print_r($this->view->egonefrm);
        $this->view->egtwofrm = $this->session->egtwofrm['egtwofrm'];
        $this->view->egthreefrm = $this->session->egthreefrm['egthreefrm'];
        $this->view->egfourfrm = $this->session->egfourfrm['egfourfrm'];
        $this->view->sixafrm = $this->session->sixafrm['saf']; 
        $this->view->cflfrm = $this->session->cflfrm['cffrm']; 
        $this->view->tdsfrmone = $this->session->tdsfrmone['tdsfrmone'];
        $this->view->tdsfrmtwo = $this->session->tdsfrmtwo['tdsfrmtwo'];
        $this->view->tcsfrm = $this->session->tcsfrm['tcsf'];
        $this->view->spifrmone = $this->session->spifrmone['spifrmone'];
        $this->view->spifrmtwo = $this->session->spifrmtwo['spifrmtwo'];
        $this->view->eifrm = $this->session->eifrm['eiform'];
        $this->view->ipfrm = $this->session->ipfrm['ipform'];
        $this->view->itfrm = $this->session->itfrm['itform'];
    }

    public function incometaxstepfourAction()
    {
        //echo "<pre>";print_r($this->session->personalinfo);exit;
        $this->view->ptifrm = $this->session->ptifrm['ptiform'];
        //print_r($this->view->ptifrm);
        $this->view->alfrm = $this->session->alfrm['alform'];
        $this->view->schfrm = $this->session->schfrm['schform']; 
    }

    public function incometaxstepfiveAction()
    {
        //echo "<pre>";print_r($this->session->personalinfo);exit;
    }

    public function getyearAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $yeararr = array();
                $cur_yearend  = date('Y',strtotime("-8 year"));
                for ($i=1; $i<=8; $i++) {
                    $yeararr[] = $cur_yearend++.'-'.substr(date($cur_yearend,strtotime("+1 year")), -2);
                }
                if(!empty($yeararr)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$yeararr);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getfrmotherssectionsAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $getdata = $this->incometaxcommon->getfrmotherssections();
                if(!empty($getdata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$getdata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getfrmsixsectionssAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                ////echo "<pre>";print_r($this->request->getPost());exit;
                $status = $this->request->getPost('nristatus');
                $getdata = $this->incometaxcommon->getfrmsixsectionsdyna($status);
                if(!empty($getdata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$getdata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getspclrateAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $id = $this->request->getPost('id');
                $getdata = $this->incometaxcommon->getspclrate($id);
                if(!empty($getdata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$getdata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getfrmsixsectionsAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $getdata = $this->incometaxcommon->getfrmsixsections();
                //echo "<pre>";print_r($getdata);exit;
                if(!empty($getdata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$getdata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getfinyearAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $yeararr = array();
                $cur_yearend  = date('Y',strtotime("-15 year"));
                for ($i=1; $i<=15; $i++) { $cur_yearend++;$yeararr[] = $cur_yearend;}
                    //print_r($yeararr);exit;
                if(!empty($yeararr)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$yeararr);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getcountrysectionAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $resdata = array();
                $countrydata = $this->incometaxcommon->getcountries();
                $sectiondata = $this->incometaxcommon->getfrmotherssections();
                $resdata['country'][] = $countrydata;
                $resdata['sections'][] = $sectiondata;
                //echo "<pre>";print_r($resdata);exit;
                if(!empty($countrydata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$resdata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getstateAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $countrydata = $this->incometaxcommon->getstatelist();
                if(!empty($countrydata)){
                    $data = array("logged" => true,'message' => 'Order Data init','data'=>$countrydata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getstateonchangeAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $id = $this->request->getPost('countryid');
                $countrydata = $this->incometaxcommon->getstatelistonchange($id);
                //print_r($countrydata);exit;
                if($countrydata != 'notfound'){
                    $data = array("logged" => true,'message' => 'Sending data','data'=>$countrydata);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not rec');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function userinfoAction()
    {
        $this->view->disable();
        $devicedetect   =   $this->devicedetect;
        $getdevice      =   $devicedetect->getdeviceinfo();
        $devicetype     =   $getdevice['devicetype'];
        $useragent      =   $getdevice['useragent'];
        $ip             =   $this->request->getClientAddress();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $status         = $this->request->getPost('steponestatus', array('striptags', 'trim'));
                $firstname      = $this->request->getPost('steponefirstname', array('striptags', 'trim'));
                $lastname       = $this->request->getPost('steponelastname', array('striptags', 'trim'));
                $middlename     = $this->request->getPost('steponemiddlename', array('striptags', 'trim'));
                $firstnamecheck = $this->elements->allownumalphahyphen($firstname);
                $lastnamecheck  = $this->elements->allownumalphahyphen($lastname);
                $midnamecheck   = $this->elements->allownumalphahyphen($middlename);
                $pannum         = $this->request->getPost('steponepan', array('striptags', 'trim'));
                if ($status === 'I') {
                    $gender         = $this->request->getPost('steponegender', array('striptags', 'trim'));
                }else{
                    $gender         = 'H';
                }
                $dateofbirth    = $this->request->getPost('steponedob', array('striptags', 'trim'));
                
                //$email          = strtolower($this->request->getPost('emailidget', 'trim'));
                //$emailcheck     = $this->validationcommon->emailvalidate($email);
                /*$mobile         = $this->request->getPost('mobile');
                $name           = $firstname.' '.$lastname;*/
                //print_r($id);exit;
                if(empty($pannum) || $pannum=='')
                {
                    $data = array("logged" => false,'name' => 'steponepan','message' => 'Pan should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if (!preg_match("/^([a-zA-Z]){5}([0-9]){4}([a-zA-Z]){1}?$/", $pannum)) {
                    $data = array("logged" => false,'name' => 'steponepan','message' => 'Invalid Pan Number');
                    $this->response->setJsonContent($data);
                }
                else if(empty($status) || $status=='')
                {
                    $data = array("logged" => false,'name' => 'steponestatus','message' => 'Status should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if (!empty($status) && $status=='H') {
                    if(empty($lastname) || $lastname=='')
                    {
                        $data = array("logged" => false,'name' => 'steponelastname','message' => 'Last name should not be empty');
                        $this->response->setJsonContent($data);
                    }else{
                        $arr = array(
                            'status'        => $status,
                            'firstname'     => $firstname,
                            'lastname'      => $lastname,
                            'middlename'    => $middlename,
                            'gender'        => $gender,
                            'dateofbirth'   => $dateofbirth,
                            'pannum'        => $pannum,
                            'devicetype'    => $devicetype,
                            'useragent'     => $useragent,
                            'ip'            => $ip
                        );

                        $getstatus = $this->incometaxcommon->insertformonedata($arr);
                        //print_r($getstatus);exit;
                        if($getstatus){
                            $setsession = $this->session->set('personalinfo',array('pi' => $arr,'id' => $getstatus));
                            $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus);
                            $this->response->setJsonContent($data);
                        }
                        else{
                            $data = array("logged" => false,'message' => 'Data not inserted');
                            $this->response->setJsonContent($data);
                        }
                    }
                }
                else if(empty($firstname) || $firstname=='')
                {
                    $data = array("logged" => false,'name' => 'steponefirstname','message'=>'First name should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($middlename) || $middlename=='')
                {
                    $data = array("logged" => false,'name' => 'steponemiddlename','message' => 'Middle name should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($lastname) || $lastname=='')
                {
                    $data = array("logged" => false,'name' => 'steponelastname','message' => 'Last name should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($gender) || $gender=='')
                {
                    $data = array("logged" => false,'name' => 'steponegender','message' => 'Gender should be selected');
                    $this->response->setJsonContent($data);
                }
                else if(empty($dateofbirth) || $dateofbirth=='')
                {
                    $data = array("logged" => false,'name' => 'steponedob','message' => 'Date of birth should not be empty');
                    $this->response->setJsonContent($data);
                }
                else{
                    $arr = array(
                        'status'        => $status,
                        'firstname'     => $firstname,
                        'lastname'      => $lastname,
                        'middlename'    => $middlename,
                        'gender'        => $gender,
                        'dateofbirth'   => $dateofbirth,
                        'pannum'        => $pannum,
                        'devicetype'    => $devicetype,
                        'useragent'     => $useragent,
                        'ip'            => $ip
                    );

                    $getstatus = $this->incometaxcommon->insertformonedata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('personalinfo',array('pi' => $arr,'id' => $getstatus));
                        $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus);
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function userinfotwoAction()
    {
        $this->view->disable();
        $devicedetect   =   $this->devicedetect;
        $getdevice      =   $devicedetect->getdeviceinfo();
        $devicetype     =   $getdevice['devicetype'];
        $useragent      =   $getdevice['useragent'];
        $ip             =   $this->request->getClientAddress();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $blockno  = $this->request->getPost('steponeblockno', array('striptags', 'trim'));
                $road     = $this->request->getPost('steponeroad', array('striptags', 'trim'));
                $area     = $this->request->getPost('steponearea', array('striptags', 'trim'));
                $town     = $this->request->getPost('steponetown', array('striptags', 'trim'));
                $country  = $this->request->getPost('steponecountry', array('striptags', 'trim'));
                $state    = $this->request->getPost('steponestate', array('striptags', 'trim'));
                $pin      = $this->request->getPost('steponepin', array('striptags', 'trim'));
                $mob      = $this->request->getPost('steponemob', array('striptags', 'trim'));
                $email    = $this->request->getPost('steponemail', array('striptags', 'trim'));
                $id       = $this->session->personalinfo['id'];
                $emailcheck = $this->validationcommon->emailvalidate($email);
                //echo strlen($pin);exit;
                if(empty($blockno) || $blockno=='')
                {
                    $data = array("logged" => false,'name' => 'steponeblockno','message' => 'Block should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($road) || $road=='')
                {
                    $data = array("logged" => false,'name' => 'steponeroad','message' => 'Road should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($area) || $area=='')
                {
                    $data = array("logged" => false,'name' => 'steponearea','message'=>'Area should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($town) || $town=='')
                {
                    $data = array("logged" => false,'name' => 'steponetown','message' => 'Town should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($country) || $country=='')
                {
                    $data = array("logged" => false,'name' => 'steponecountry','message' => 'Country should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if(empty($state) || $state=='')
                {
                    $data = array("logged" => false,'name' => 'steponestate','message' => 'State should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if((empty($pin) || $pin=='') || strlen($pin) != 6)
                {
                    $data = array("logged" => false,'name' => 'steponepin','message' => 'Please Enter valid pin');
                    $this->response->setJsonContent($data);
                }
                else if(empty($mob) || $mob=='')
                {
                    $data = array("logged" => false,'name' => 'steponemob','message' => 'Mobile No should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if($mob=='' || (strlen($mob) < 10))
                {
                    $data = array("logged" => false,'name' => 'steponemob','message' => 'Enter Valid Mobile No');
                    $this->response->setJsonContent($data);
                }
                else if(empty($email) || $email=='')
                {
                    $data = array("logged" => false,'name' => 'steponemail','message' => 'Email should not be empty');
                    $this->response->setJsonContent($data);
                }
                else if($emailcheck==false)
                {
                    $data = array("logged" => false,'name' => 'steponemail','message' => 'Your Email is not valid');
                    $this->response->setJsonContent($data);
                }
                else{
                    $arr = array(
                        'id'            => $id,
                        'blockno'       => $blockno,
                        'road'          => $road,
                        'area'          => $area,
                        'town'          => $town,
                        'country'       => $country,
                        'state'         => $state,
                        'pin'           => $pin,
                        'mob'           => $mob,
                        'email'         => $email,
                        'devicetype'    => $devicetype,
                        'useragent'     => $useragent,
                        'ip'            => $ip
                    );
                    $getstatus = $this->incometaxcommon->insertformtwodata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('useraddress',array('ua' => $arr,'id' => $getstatus));
                        $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                        $this->response->setJsonContent($data);

                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function userinfothreeAction()
    {
        $this->view->disable();
        $devicedetect   =   $this->devicedetect;
        $getdevice      =   $devicedetect->getdeviceinfo();
        $devicetype     =   $getdevice['devicetype'];
        $useragent      =   $getdevice['useragent'];
        $ip             =   $this->request->getClientAddress();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $cat      = $this->request->getPost('steponeempcat', array('striptags', 'trim'));
                $retf     = $this->request->getPost('steponerfus', array('striptags', 'trim'));
                $pcc      = $this->request->getPost('steponegbpcc', array('striptags', 'trim'));
                $orr      = $this->request->getPost('steponeorr', array('striptags', 'trim'));
                $ress     = $this->request->getPost('steponeress', array('striptags', 'trim'));
                $id       = $this->session->personalinfo['id'];

                if(empty($cat) || $cat=='')
                {
                    $data = array("logged" => false,'name' => 'steponeempcat','message' => 'Please select employee category');
                    $this->response->setJsonContent($data);
                }
                else if(empty($retf) || $retf=='')
                {
                    $data = array("logged" => false,'name' => 'steponerfus','message' => 'Please select return filed');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pcc) || $pcc=='')
                {
                    $data = array("logged" => false,'name' => 'steponegbpcc','message'=>'Please select option for above');
                    $this->response->setJsonContent($data);
                }
                else if(empty($orr) || $orr=='')
                {
                    $data = array("logged" => false,'name' => 'steponeorr','message' => 'Please select whether orignial or revised return');
                    $this->response->setJsonContent($data);
                }
                else if(empty($ress) || $ress=='')
                {
                    $data = array("logged" => false,'name' => 'steponeress','message' => 'Please select residential status');
                    $this->response->setJsonContent($data);
                }
                else{
                    $arr = array(
                        'id'         => $id,
                        'cat'        => $cat,
                        'retf'       => $retf,
                        'pcc'        => $pcc,
                        'orr'        => $orr,
                        'ress'       => $ress,
                        'devicetype' => $devicetype,
                        'useragent'  => $useragent,
                        'ip'         => $ip
                    );
                    $getstatus = $this->incometaxcommon->insertformthreedata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('addinfo',array('addinfo' => $arr,'id' => $getstatus));
                        $data = array("logged" => true,'message' => 'Order Data init');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function insertsalinfoAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $sal      = $this->request->getPost('steptwoics', array('striptags', 'trim'));
                $concess  = $this->request->getPost('steptwotcar', array('striptags', 'trim'));
                $tax      = $this->request->getPost('steptwotpbe', array('striptags', 'trim'));
                $atme     = $this->request->getPost('steptwoatme', array('striptags', 'trim'));
                $oa       = $this->request->getPost('steptwooa', array('striptags', 'trim'));
                $ane      = $this->request->getPost('steptwoane', array('striptags', 'trim'));
                $vop      = $this->request->getPost('steptwovop', array('striptags', 'trim'));
                $pils     = $this->request->getPost('steptwopils', array('striptags', 'trim'));
                $dus      = $this->request->getPost('steptwodus', array('striptags', 'trim'));
                $trus     = $this->request->getPost('steptwotrus', array('striptags', 'trim'));
                $tot      = $this->request->getPost('steptwotot', array('striptags', 'trim'));
                $empyername  = $this->request->getPost('steptwonoe', array('striptags', 'trim'));
                $empyeraddr  = $this->request->getPost('steptwoaddline', array('striptags', 'trim'));
                $empyercity  = $this->request->getPost('steptwotc', array('striptags', 'trim'));
                $empyerstate = $this->request->getPost('steptwostate', array('striptags', 'trim'));
                $empyerpin   = $this->request->getPost('steptwopin', array('striptags', 'trim'));
                $id       = $this->session->personalinfo['id'];

                if($sal=='')
                {
                    $data = array("logged" => false,'name' => 'steptwoics','message' => 'Enter Salary');
                    $this->response->setJsonContent($data);
                }
                else if($concess=='')
                {
                    $data = array("logged" => false,'name' => 'steptwotcar','message' => 'Enter travel concession');
                    $this->response->setJsonContent($data);
                }
                else if($tax=='')
                {
                    $data = array("logged" => false,'name' => 'steptwotpbe','message'=>'Enter tax paid');
                    $this->response->setJsonContent($data);
                }
                else if($atme=='')
                {
                    $data = array("logged" => false,'name' => 'steptwoatme','message' => 'Enter expenditure incurred');
                    $this->response->setJsonContent($data);
                }
                else if($oa=='')
                {
                    $data = array("logged" => false,'name' => 'steptwooa','message' => 'Enter other allowances');
                    $this->response->setJsonContent($data);
                }
                else if($ane=='')
                {
                    $data = array("logged" => false,'name' => 'steptwoane','message' => 'Enter allowances not exempt');
                    $this->response->setJsonContent($data);
                }
                else if($vop=='')
                {
                    $data = array("logged" => false,'name' => 'steptwovop','message' => 'Enter value of perquisites');
                    $this->response->setJsonContent($data);
                }
                else if($pils=='')
                {
                    $data = array("logged" => false,'name' => 'steptwopils','message' => 'Enter profits');
                    $this->response->setJsonContent($data);
                }
                else if($dus=='')
                {
                    $data = array("logged" => false,'name' => 'steptwodus','message' => 'Enter deductions');
                    $this->response->setJsonContent($data);
                }
                else if($trus=='')
                {
                    $data = array("logged" => false,'name' => 'steptwotrus','message' => 'Enter tax relief');
                    $this->response->setJsonContent($data);
                }
                else if(empty($empyername) || $empyername=='')
                {
                    $data = array("logged" => false,'name' => 'steptwonoe','message' => 'Enter name of employer');
                    $this->response->setJsonContent($data);
                }
                else if(empty($empyeraddr) || $empyeraddr=='')
                {
                    $data = array("logged" => false,'name' => 'steptwoaddline','message' => 'Enter address line');
                    $this->response->setJsonContent($data);
                }
                else if(empty($empyercity) || $empyercity=='')
                {
                    $data = array("logged" => false,'name' => 'steptwotc','message'=>'Enter city');
                    $this->response->setJsonContent($data);
                }
                else if(empty($empyerstate) || $empyerstate=='')
                {
                    $data = array("logged" => false,'name' => 'steptwostate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if((empty($empyerpin) || $empyerpin=='') || strlen($empyerpin) != 6)
                {
                    $data = array("logged" => false,'name' => 'steptwopin','message' => 'Enter valid pin code');
                    $this->response->setJsonContent($data);
                }

                else{
                    $arr = array(
                        'id'      => $id,
                        'sal'     => $sal,
                        'concess' => $concess,
                        'tax'     => $tax,
                        'atme'    => $atme,
                        'oa'      => $oa,
                        'ane'     => $ane,
                        'vop'     => $vop,
                        'pils'    => $pils,
                        'dus'     => $dus,
                        'trus'    => $trus,
                        'tot'     => $tot
                    );

                    $getstatusone = $this->incometaxcommon->insertformsaldata($arr);
                    
                    $arrtwo = array(
                        'id'        => $id,
                        'name'      => $empyername,
                        'address'   => $empyeraddr,
                        'city'      => $empyercity,
                        'state'     => $empyerstate,
                        'pin'       => $empyerpin,
                        'lastid'    => $getstatusone
                    );

                    $getstatustwo = $this->incometaxcommon->insertformsaltwodata($arrtwo);
                    //print_r($getstatus);exit;
                    if($getstatusone && $getstatustwo){
                        $setsession = $this->session->set('salinfoone',array('salinfoone' => $arr));
                        $setsession = $this->session->set('salinfotwo',array('salinfotwo' => $arrtwo));
                        $data = array("logged" => true,'message' => 'Order Data init');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmoneAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $dividend  = $this->request->getPost('steptwooidg', array('striptags', 'trim'));
                $integros  = $this->request->getPost('steptwooiig', array('striptags', 'trim'));
                $rental    = $this->request->getPost('steptwooiri', array('striptags', 'trim'));
                $tot       = $this->request->getPost('steptwooigtot', array('striptags', 'trim'));
                $totone    = $this->request->getPost('steptwooiidgr', array('striptags', 'trim'));
                $id        = $this->session->personalinfo['id'];
                $arr = array(
                    'id'        => $id,
                    'dividend'  => $dividend,
                    'integros'  => $integros,
                    'rental'    => $rental,
                    'tot'       => $tot,
                    'totone'    => $totone
                );
                $getstatus = $this->incometaxcommon->insertformoionedata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincomeone',array('oincone' => $arr));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmtwoAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $receipts  = $this->request->getPost('steptwooir', array('striptags', 'trim'));
                $dusfs     = $this->request->getPost('steptwooidus', array('striptags', 'trim'));
                $id        = $this->session->personalinfo['id'];
                $tottwo    = $this->request->getPost('steptwooirdtot', array('striptags', 'trim'));
                
                $arr = array(
                    'id'        => $id,
                    'receipts'  => $receipts,
                    'dusfs'     => $dusfs,
                    'tottwo'    => $tottwo,
                );
                $getstatus = $this->incometaxcommon->insertformoitwodata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincometwo',array('oinctwo' => $arr));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmthreeAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $winnings  = $this->request->getPost('steptwooiwflr', array('striptags', 'trim'));
                //$incme     = $this->request->getPost('steptwooiiuxa', array('striptags', 'trim'));
                $cntry     = $this->request->getPost('steptwooicntry', array('striptags', 'trim'));
                $adtaa     = $this->request->getPost('steptwooiadtaa', array('striptags', 'trim'));
                $rdtaa     = $this->request->getPost('steptwooirotudtaa', array('striptags', 'trim'));
                $trc       = $this->request->getPost('steptwooitrc', array('striptags', 'trim'));
                $soapr     = $this->request->getPost('steptwooisoapr', array('striptags', 'trim'));
                $iamt      = $this->request->getPost('steptwooiaoi', array('striptags', 'trim'));
                $id        = $this->session->personalinfo['id'];
                $totthr    = $this->request->getPost('steptwooispcltottwo', array('striptags', 'trim'));
                $subtot    = $this->request->getPost('steptwooispcltot', array('striptags', 'trim'));
                $arr = array(
                    'id'        => $id,
                    'winnings'  => $winnings,
                    //'incme'     => $incme,
                    'cntry'     => $cntry,
                    'adtaa'     => $adtaa,
                    'rdtaa'     => $rdtaa,
                    'trc'       => $trc,
                    'soapr'     => $soapr,
                    'iamt'      => $iamt,
                    'totthr'    => $totthr
                );
                foreach($cntry as $key=> $valcm)
                {
                    $mnarrm[] = array('cntry'=> $cntry[$key],
                    'adtaa'=> $adtaa[$key],'rdtaa'=> $rdtaa[$key],'trc'=> $trc[$key],
                    'soapr'=> $soapr[$key],'iamt'=> $iamt[$key],'totthr'=> $totthr,'subtot'=> $subtot,'winnings' => $winnings);
                }

                //echo "<pre>";print_r($mnarrm);exit;
                 
                $getstatus = $this->incometaxcommon->insertformoithreedata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincomethree',array('oincthree' => $mnarrm));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmfourAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $src    = $this->request->getPost('steptworhsource', array('striptags', 'trim'));
                $inc    = $this->request->getPost('steptworhincome', array('striptags', 'trim'));
                $id     = $this->session->personalinfo['id'];
                $subtot = $this->request->getPost('steptwooieirhtot', array('striptags', 'trim'));
                $totfou = $this->request->getPost('steptwooieirhtottwo', array('striptags', 'trim'));
                $rate  = $this->request->getPost('spclratecal', array('striptags', 'trim'));
                
                $arr = array(
                    'id'        => $id,
                    'src'       => $src,
                    'inc'       => $inc,
                    'rate'      => $rate,
                    'totfou'    => $totfou
                );

                foreach($src as $key=> $valcm)
                {
                    $incsalfour[] = array('src'=> $src[$key],
                    'inc'=> $inc[$key],'rate'=> $rate[$key],'subtot' => $subtot,'totfou'=> $totfou);
                }
                //print_r($incsalfour);exit;
                $getstatus = $this->incometaxcommon->insertformoifourdata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincomefour',array('oincfour' => $incsalfour));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmfiveAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $exp     = $this->request->getPost('steptwooiexp', array('striptags', 'trim'));
                $depre   = $this->request->getPost('steptwooidepre', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                $totfve    = $this->request->getPost('steptwooied', array('striptags', 'trim'));
                $arr = array(
                    'id'     => $id,
                    'depre'  => $depre,
                    'exp'    => $exp,
                    'totfve' => $totfve
                );
                $getstatus = $this->incometaxcommon->insertformoifivedata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincomefive',array('oincfive' => $arr));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function incomeothersalfrmsixAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $gtot     = $this->request->getPost('steptwooigtot', array('striptags', 'trim'));
                $id       = $this->session->personalinfo['id'];
                $arr = array(
                    'id'    => $id,
                    'gtot'  => $gtot
                );
                $getstatus = $this->incometaxcommon->insertformoisixdata($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('otherincomesix',array('oincsix' => $arr));
                    $data = array("logged" => true,'message' => 'Order Data init','getid'=>$getstatus['orderid']);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
        }
    }

    public function insertsixadataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $sec      = $this->request->getPost('frmsixasec', array('striptags', 'trim'));
                $amt      = $this->request->getPost('frmsixaamt', array('striptags', 'trim'));
                $tot      = $this->request->getPost('frmsixatotamt', array('striptags', 'trim'));
                $id       = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($sec[0]) || $sec=='')
                {
                    $data = array("logged" => false,'name' => 'frmsixasec','message' => 'Enter section');
                    $this->response->setJsonContent($data);
                }
                else if($amt=='')
                {
                    $data = array("logged" => false,'name' => 'frmsixaamt','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'    => $id,
                        'sec'   => $sec,
                        'amt'   => $amt,
                        'tot'   => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformsixadata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('sixafrm',array('saf' => $arr,'id' => $id));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertcflfrmdataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $assyear    = $this->request->getPost('assyear', array('striptags', 'trim'));
                $dateoffil  = $this->request->getPost('dateoffil', array('striptags', 'trim'));
                $houseloss  = $this->request->getPost('houseproploss', array('striptags', 'trim'));
                $losshorse  = $this->request->getPost('losshorse', array('striptags', 'trim'));
                $losshoutot = $this->request->getPost('frmcflhoutotamt', array('striptags', 'trim'));
                $losshortot = $this->request->getPost('frmcflhortotamt', array('striptags', 'trim'));
                $id        = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($assyear[0]) || $assyear=='')
                {
                    $data = array("logged" => false,'name' => 'assyear','message' => 'Enter assessment year');
                    $this->response->setJsonContent($data);
                }
                else if(empty($dateoffil[0]) || $dateoffil=='')
                {
                    $data = array("logged" => false,'name' => 'dateoffil','message' => 'Enter date of filing');
                    $this->response->setJsonContent($data);
                }
                else if($houseloss=='')
                {
                    $data = array("logged" => false,'name' => 'houseproploss','message' => 'Enter house property loss');
                    $this->response->setJsonContent($data);
                }
                else if($losshorse=='')
                {
                    $data = array("logged" => false,'name' => 'losshorse','message' => 'Enter loss from owning horses');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'assyear'   => $assyear,
                        'dateoffil' => $dateoffil,
                        'houseloss' => $houseloss,
                        'losshorse' => $losshorse,
                        'losshoutot'=> $losshoutot,
                        'losshortot'=> $losshortot
                    );
                    $getstatus = $this->incometaxcommon->insertformcfldata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('cflfrm',array('cffrm' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmtdsonedataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $tan   = $this->request->getPost('frmtdstandedone', array('striptags', 'trim'));
                $name  = $this->request->getPost('frmtdsnameofemp', array('striptags', 'trim'));
                $icus  = $this->request->getPost('frmtdsincmcus', array('striptags', 'trim'));
                $ttd   = $this->request->getPost('frmtdstottaxded', array('striptags', 'trim'));
                $tot   = $this->request->getPost('stepthreetdsonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($tan[0]) || $tan=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstandedone','message' => 'Enter tan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdsnameofemp','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if($icus=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdsincmcus','message' => 'Enter income chargable');
                    $this->response->setJsonContent($data);
                }
                else if($ttd=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstottaxded','message' => 'Enter tax deducted');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'    => $id,
                        'tan'   => $tan,
                        'name'  => $name,
                        'icus'  => $icus,
                        'ttd'   => $ttd,
                        'tot'   => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformtdsonedata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('tdsfrmone',array('tdsfrmone' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmtdstwodataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $tan   = $this->request->getPost('frmtdstwotanded', array('striptags', 'trim'));
                $name  = $this->request->getPost('frmtdstwonameded', array('striptags', 'trim'));
                $utcn  = $this->request->getPost('frmtdstwotdscnded', array('striptags', 'trim'));
                $fy    = $this->request->getPost('frmtdstwofinyear', array('striptags', 'trim'));
                $amt   = $this->request->getPost('frmtdstwoamount', array('striptags', 'trim'));
                $cfy   = $this->request->getPost('frmtdstwotdscy', array('striptags', 'trim'));
                $oh    = $this->request->getPost('frmtdstwoown', array('striptags', 'trim'));
                $sh    = $this->request->getPost('frmtdstwospouse', array('striptags', 'trim'));
                $acf   = $this->request->getPost('frmtdstwoamtcf', array('striptags', 'trim'));
                $tot   = $this->request->getPost('stepthreetdstwotot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($tan[0]) || $tan=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwotanded','message' => 'Enter tan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwonameded','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($utcn[0]) || $utcn=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwotdscnded','message' => 'Enter certificate no');
                    $this->response->setJsonContent($data);
                }
                else if(empty($fy[0]) || $fy=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwofinyear','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else if($amt=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwoamount','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else if($cfy=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwotdscy','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else if($oh=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwoown','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else if($sh=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwospouse','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else if($acf=='')
                {
                    $data = array("logged" => false,'name' => 'frmtdstwoamtcf','message' => 'Please Enter');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'    => $id,
                        'tan'   => $tan,
                        'name'  => $name,
                        'utcn'  => $utcn,
                        'fy'    => $fy,
                        'amt'   => $amt,
                        'cfy'   => $cfy,
                        'oh'    => $oh,
                        'sh'    => $sh,
                        'acf'   => $acf,
                        'tot'   => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformtdstwodata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('tdsfrmtwo',array('tdsfrmtwo' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmthreetcsdataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $nocol    = $this->request->getPost('stepthreenoofcol', array('striptags', 'trim'));
                $namecol  = $this->request->getPost('stepthreenameofcol', array('striptags', 'trim'));
                $taxcol   = $this->request->getPost('stepthreetaxcol', array('striptags', 'trim'));
                $amtcla   = $this->request->getPost('stepthreeamtcla', array('striptags', 'trim'));
                $amtclaspo   = $this->request->getPost('stepthreeamtclaspo', array('striptags', 'trim'));
                $tot   = $this->request->getPost('stepthreetcsonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($nocol[0]) || $nocol=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreenoofcol','message' => 'Enter acc no of collector');
                    $this->response->setJsonContent($data);
                }
                else if(empty($namecol[0]) || $namecol=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreenameofcol','message' => 'Enter name of collector');
                    $this->response->setJsonContent($data);
                }
                else if($taxcol=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreetaxcol','message' => 'Enter tax collected');
                    $this->response->setJsonContent($data);
                }
                else if($amtcla=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeamtcla','message' => 'Enter amount claimed');
                    $this->response->setJsonContent($data);
                }
                else if($amtclaspo=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeamtclaspo','message' => 'Enter amount claimed by spouse');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'nocol'     => $nocol,
                        'namecol'   => $namecol,
                        'taxcol'    => $taxcol,
                        'amtcla'    => $amtcla,
                        'amtclaspo' => $amtclaspo,
                        'tot'       => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformtcsdata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('tcsfrm',array('tcsf' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepthreespidataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $name  = $this->request->getPost('stepthreespifrmonenop', array('striptags', 'trim'));
                $pan   = $this->request->getPost('stepthreespifrmonepop', array('striptags', 'trim'));
                $reln  = $this->request->getPost('stepthreespifrmonerel', array('striptags', 'trim'));
                $noi   = $this->request->getPost('stepthreespifrmonenoi', array('striptags', 'trim'));
                $amt   = $this->request->getPost('stepthreespifrmoneamt', array('striptags', 'trim'));
                $tot   = $this->request->getPost('stepthreefrmspitotal', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreespifrmonenop','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pan[0]) || $pan=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreespifrmonepop','message' => 'Enter pan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($reln[0]) || $reln=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreespifrmonerel','message' => 'Enter relation');
                    $this->response->setJsonContent($data);
                }
                else if(empty($noi[0]) || $noi=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreespifrmonenoi','message' => 'Enter nature');
                    $this->response->setJsonContent($data);
                }
                else if($amt=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreespifrmoneamt','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'name'      => $name,
                        'pan'       => $pan,
                        'reln'      => $reln,
                        'noi'       => $noi,
                        'amt'       => $amt,
                        'tot'       => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformspidata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('spifrmone',array('spifrmone' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepthreespitwodataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $incone  = $this->request->getPost('stepthreefrmspiinc', array('striptags', 'trim'));
                $taxone   = $this->request->getPost('stepthreefrmspitaxamt', array('striptags', 'trim'));
                $inctwo  = $this->request->getPost('stepthreefrmspicdrinc', array('striptags', 'trim'));
                $taxtwo  = $this->request->getPost('stepthreefrmspicdrtaxamt', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if($incone=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreefrmspiinc','message' => 'Enter income');
                    $this->response->setJsonContent($data);
                }
                else if($taxone=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreefrmspitaxamt','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else if($inctwo=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreefrmspicdrinc','message' => 'Enter income');
                    $this->response->setJsonContent($data);
                }
                else if($taxtwo=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreefrmspicdrtaxamt','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'incone'    => $incone,
                        'taxone'    => $taxone,
                        'inctwo'    => $inctwo,
                        'taxtwo'    => $taxtwo
                    );
                    $getstatus = $this->incometaxcommon->insertformspitwodata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('spifrmtwo',array('spifrmtwo' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepthreefrmeiAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $intrst   = $this->request->getPost('stepthreeeiiinc', array('striptags', 'trim'));
                $dividnd  = $this->request->getPost('stepthreeeidinc', array('striptags', 'trim'));
                $ltcgt    = $this->request->getPost('stepthreeeiltcg', array('striptags', 'trim'));
                $groagri  = $this->request->getPost('stepthreeeigar', array('striptags', 'trim'));
                $expagri  = $this->request->getPost('stepthreeeieioa', array('striptags', 'trim'));
                $unabagri = $this->request->getPost('stepthreeeieiunal', array('striptags', 'trim'));
                $child    = $this->request->getPost('stepthreeeioiei', array('striptags', 'trim'));
                $tot      = $this->request->getPost('stepthreeeitot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if($intrst=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeiiinc','message' => 'Enter interest');
                    $this->response->setJsonContent($data);
                }
                else if($dividnd=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeidinc','message' => 'Enter Dividend');
                    $this->response->setJsonContent($data);
                }
                else if($ltcgt=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeiltcg','message' => 'Enter Long-term capital gains');
                    $this->response->setJsonContent($data);
                }
                else if($groagri=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeigar','message' => 'Enter Gross receipts');
                    $this->response->setJsonContent($data);
                }
                else if($expagri=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeieioa','message' => 'Enter Expenditure');
                    $this->response->setJsonContent($data);
                }
                else if($unabagri=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeieiunal','message' => 'Enter Unabsorbed agricultural loss');
                    $this->response->setJsonContent($data);
                }
                else if($child=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeeioiei','message' => 'Enter exempt income of minor child');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'intrst'    => $intrst,
                        'dividnd'   => $dividnd,
                        'ltcgt'     => $ltcgt,
                        'groagri'   => $groagri,
                        'expagri'   => $expagri,
                        'unabagri'  => $unabagri,
                        'child'     => $child,
                        'tot'       => $tot
                    );
                    $getstatus = $this->incometaxcommon->insertformeidata($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('eifrm',array('eiform' => $arr,'id' => $id));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmthreeegoneAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $name    = $this->request->getPost('stepthreeegfrmonename', array('striptags', 'trim'));
                $addr    = $this->request->getPost('stepthreeegfrmoneaddr', array('striptags', 'trim'));
                $city    = $this->request->getPost('stepthreeegfrmonecity', array('striptags', 'trim'));
                $state   = $this->request->getPost('stepthreeegfrmonestate', array('striptags', 'trim'));
                $pin     = $this->request->getPost('stepthreeegfrmonepin', array('striptags', 'trim'));
                $pan     = $this->request->getPost('stepthreeegfrmonepan', array('striptags', 'trim'));
                $aod     = $this->request->getPost('stepthreeegoneaod', array('striptags', 'trim'));
                $eaod    = $this->request->getPost('stepthreeegoneeaod', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepthreeegonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                $arr = array(
                    'id'        => $id,
                    'name'      => $name,
                    'addr'      => $addr,
                    'city'      => $city,
                    'state'     => $state,
                    'pin'       => $pin,
                    'pan'       => $pan,
                    'aod'       => $aod,
                    'eaod'      => $eaod,
                    'tot'       => $tot
                );

                $getstatus = $this->incometaxcommon->insertfrmthreeegone($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('egonefrm',array('egonefrm' => $arr));
                    $data = array("logged" => true,'message' => 'Data inserted');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmthreeegtwoAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $name    = $this->request->getPost('stepthreeegfrmonename', array('striptags', 'trim'));
                $addr    = $this->request->getPost('stepthreeegfrmoneaddr', array('striptags', 'trim'));
                $city    = $this->request->getPost('stepthreeegfrmonecity', array('striptags', 'trim'));
                $state   = $this->request->getPost('stepthreeegfrmonestate', array('striptags', 'trim'));
                $pin     = $this->request->getPost('stepthreeegfrmonepin', array('striptags', 'trim'));
                $pan     = $this->request->getPost('stepthreeegfrmonepan', array('striptags', 'trim'));
                $aod     = $this->request->getPost('stepthreeegoneaod', array('striptags', 'trim'));
                $eaod    = $this->request->getPost('stepthreeegoneeaod', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepthreeegonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                /*if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonename','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($addr[0]) || $addr=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmoneaddr','message' => 'Enter address');
                    $this->response->setJsonContent($data);
                }
                else if(empty($city[0]) || $city=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonecity','message' => 'Enter city');
                    $this->response->setJsonContent($data);
                }
                else if(empty($state[0]) || $state=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonestate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pin[0]) || $pin=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepin','message' => 'Enter pin');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pan[0]) || $pan=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepan','message' => 'Enter pan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($aod[0]) || $aod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else if(empty($eaod[0]) || $eaod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneeaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {*/
                $arr = array(
                    'id'        => $id,
                    'name'      => $name,
                    'addr'      => $addr,
                    'city'      => $city,
                    'state'     => $state,
                    'pin'       => $pin,
                    'pan'       => $pan,
                    'aod'       => $aod,
                    'eaod'      => $eaod,
                    'tot'       => $tot
                );

                $getstatus = $this->incometaxcommon->insertfrmthreeegtwo($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('egtwofrm',array('egtwofrm' => $arr));
                    $data = array("logged" => true,'message' => 'Data inserted');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //}
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmthreeegthreeAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $name    = $this->request->getPost('stepthreeegfrmonename', array('striptags', 'trim'));
                $addr    = $this->request->getPost('stepthreeegfrmoneaddr', array('striptags', 'trim'));
                $city    = $this->request->getPost('stepthreeegfrmonecity', array('striptags', 'trim'));
                $state   = $this->request->getPost('stepthreeegfrmonestate', array('striptags', 'trim'));
                $pin     = $this->request->getPost('stepthreeegfrmonepin', array('striptags', 'trim'));
                $pan     = $this->request->getPost('stepthreeegfrmonepan', array('striptags', 'trim'));
                $aod     = $this->request->getPost('stepthreeegoneaod', array('striptags', 'trim'));
                $eaod    = $this->request->getPost('stepthreeegoneeaod', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepthreeegonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonename','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($addr[0]) || $addr=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmoneaddr','message' => 'Enter address');
                    $this->response->setJsonContent($data);
                }
                else if(empty($city[0]) || $city=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonecity','message' => 'Enter city');
                    $this->response->setJsonContent($data);
                }
                else if(empty($state[0]) || $state=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonestate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pin[0]) || $pin=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepin','message' => 'Enter pin');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pan[0]) || $pan=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepan','message' => 'Enter pan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($aod[0]) || $aod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else if(empty($eaod[0]) || $eaod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneeaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'name'      => $name,
                        'addr'      => $addr,
                        'city'      => $city,
                        'state'     => $state,
                        'pin'       => $pin,
                        'pan'       => $pan,
                        'aod'       => $aod,
                        'eaod'      => $eaod,
                        'tot'       => $tot
                    );

                    $getstatus = $this->incometaxcommon->insertfrmthreeegthree($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('egthreefrm',array('egthreefrm' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmthreeegfourAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $name    = $this->request->getPost('stepthreeegfrmonename', array('striptags', 'trim'));
                $addr    = $this->request->getPost('stepthreeegfrmoneaddr', array('striptags', 'trim'));
                $city    = $this->request->getPost('stepthreeegfrmonecity', array('striptags', 'trim'));
                $state   = $this->request->getPost('stepthreeegfrmonestate', array('striptags', 'trim'));
                $pin     = $this->request->getPost('stepthreeegfrmonepin', array('striptags', 'trim'));
                $pan     = $this->request->getPost('stepthreeegfrmonepan', array('striptags', 'trim'));
                $aod     = $this->request->getPost('stepthreeegoneaod', array('striptags', 'trim'));
                $eaod    = $this->request->getPost('stepthreeegoneeaod', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepthreeegonetot', array('striptags', 'trim'));
                $id    = $this->session->personalinfo['id'];
                //print_r($sec);exit;
                /*foreach($name as $n)
                {
                    if(empty($n) || $n=='')
                    {
                        $data = array("logged" => false,'name' => 'stepthreeegfrmonename','message' => 'Enter name please check one of -> '.$n);
                        $this->response->setJsonContent($data);
                        $this->response->send();
                        exit;
                    }
                }*/
                if(empty($name[0]) || $name=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonename','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if(empty($addr[0]) || $addr=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmoneaddr','message' => 'Enter address');
                    $this->response->setJsonContent($data);
                }
                else if(empty($city[0]) || $city=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonecity','message' => 'Enter city');
                    $this->response->setJsonContent($data);
                }
                else if(empty($state[0]) || $state=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonestate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pin[0]) || $pin=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepin','message' => 'Enter pin');
                    $this->response->setJsonContent($data);
                }
                else if(empty($pan[0]) || $pan=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegfrmonepan','message' => 'Enter pan');
                    $this->response->setJsonContent($data);
                }
                else if(empty($aod[0]) || $aod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else if(empty($eaod[0]) || $eaod=='')
                {
                    $data = array("logged" => false,'name' => 'stepthreeegoneeaod','message' => 'Enter amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'name'      => $name,
                        'addr'      => $addr,
                        'city'      => $city,
                        'state'     => $state,
                        'pin'       => $pin,
                        'pan'       => $pan,
                        'aod'       => $aod,
                        'eaod'      => $eaod,
                        'tot'       => $tot
                    );

                    $getstatus = $this->incometaxcommon->insertfrmthreeegfour($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('egfourfrm',array('egfourfrm' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function inserthousepropfrmoneAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $annual  = $this->request->getPost('steptwochpalvr', array('striptags', 'trim'));
                $amtrent = $this->request->getPost('steptwocarr', array('striptags', 'trim'));
                $taxloc  = $this->request->getPost('steptwocla', array('striptags', 'trim'));
                $intrst  = $this->request->getPost('steptwoipbc', array('striptags', 'trim'));
                $tohp    = $this->request->getPost('steptwofycoc', array('striptags', 'trim'));
                $not     = $this->request->getPost('steptwohpnot', array('striptags', 'trim'));
                $pot     = $this->request->getPost('steptwohppot', array('striptags', 'trim'));
                $addr    = $this->request->getPost('steptwofrmthreehaal', array('striptags', 'trim'));
                $twn     = $this->request->getPost('steptwofrmthreehatc', array('striptags', 'trim'));
                $state   = $this->request->getPost('steptwofrmthreehastate', array('striptags', 'trim'));
                $pin     = $this->request->getPost('steptwofrmthreehapin', array('striptags', 'trim'));
                $propco  = $this->request->getPost('stepthreehppco', array('striptags', 'trim'));
                $posop   = $this->request->getPost('stepthreehposop', array('striptags', 'trim'));
                $nocop   = $this->request->getPost('stepthreehpnoco', array('striptags', 'trim'));
                $pocop   = $this->request->getPost('stepthreehppoco', array('striptags', 'trim'));
                $psocop  = $this->request->getPost('steptwopsocop', array('striptags', 'trim'));
                $arears  = $this->request->getPost('steptwoarears', array('striptags', 'trim'));
                $hptot   = $this->request->getPost('steptwohptot', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($annual=='')
                {
                    $data = array("logged" => false,'name' => 'steptwochpalvr','message' => 'Enter nnual letable value');
                    $this->response->setJsonContent($data);
                }
                else if($amtrent=='')
                {
                    $data = array("logged" => false,'name' => 'steptwocarr','message' => 'Enter address');
                    $this->response->setJsonContent($data);
                }
                else if($taxloc=='')
                {
                    $data = array("logged" => false,'name' => 'steptwocla','message' => 'Enter city');
                    $this->response->setJsonContent($data);
                }
                else if($intrst=='')
                {
                    $data = array("logged" => false,'name' => 'steptwoipbc','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if($tohp=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofycoc','message' => 'Select House Property');
                    $this->response->setJsonContent($data);
                }
                else if($tohp=='letout'){
                    if($not=='')
                    {
                        $data = array("logged" => false,'name' => 'steptwohpnot','message' => 'Enter name');
                        $this->response->setJsonContent($data);
                    }
                    else if($pot=='')
                    {
                        $data = array("logged" => false,'name' => 'steptwohppot','message' => 'Enter pan');
                        $this->response->setJsonContent($data);
                    }
                }
                else if($addr=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehaal','message' => 'Select address');
                    $this->response->setJsonContent($data);
                }
                else if($twn=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehatc','message' => 'Enter town');
                    $this->response->setJsonContent($data);
                }
                else if($state=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehastate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if($pin=='' || strlen($pin) != 6)
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehapin','message' => 'Enter valid pin');
                    $this->response->setJsonContent($data);
                }
                else if($propco == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreehppco','message' => 'Select option');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    foreach($not as $key=> $valcm)
                    {
                        $mnarrm[] = array('not'=> $not[$key],
                        'pot'=> $pot[$key],'tohp'=> $tohp);
                    }

                    $arr = array(
                        'id'        => $id,
                        'annual'    => $annual,
                        'amtrent'   => $amtrent,
                        'taxloc'    => $taxloc,
                        'intrst'    => $intrst,
                        'tohp'      => $tohp,
                        'not'       => $not,
                        'pot'       => $pot,
                        'addr'      => $addr,
                        'twn'       => $twn,
                        'state'     => $state,
                        'pin'       => $pin,
                        'posop'     => $posop,
                        'propco'    => $propco,
                        'nocop'     => $nocop,
                        'pocop'     => $pocop,
                        'psocop'    => $psocop,
                        'arears'    => $arears,
                        'hptot'     => $hptot,
                        'sessarr'   => $mnarrm
                    );
                    //echo "this is arr array <br>";echo "<pre>";print_r($arr);exit;
                    $getstatus = $this->incometaxcommon->inserthpfrmone($arr);
                    // print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('hpfrmone',array('hpfrmone' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function inserthousepropfrmtwoAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $tohp    = $this->request->getPost('steptwofycoc', array('striptags', 'trim'));
                $not     = $this->request->getPost('steptwohpnot', array('striptags', 'trim'));
                $pot     = $this->request->getPost('steptwohppot', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($tohp=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofycoc','message' => 'Select House Property');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    if($tohp=='letout'){
                        if($not=='')
                        {
                            $data = array("logged" => false,'name' => 'steptwohpnot','message' => 'Enter name');
                            $this->response->setJsonContent($data);
                        }
                        else if($pot=='')
                        {
                            $data = array("logged" => false,'name' => 'steptwohppot','message' => 'Enter pan');
                            $this->response->setJsonContent($data);
                        }
                    }
                    $arr = array(
                        'id'     => $id,
                        'tohp'   => $tohp,
                        'not'    => $not,
                        'pot'    => $pot
                    );

                    foreach($not as $key=> $valcm)
                    {
                        $mnarrm[] = array('not'=> $not[$key],
                        'pot'=> $pot[$key],'tohp'=> $tohp);
                    }

                    $getstatus = $this->incometaxcommon->inserthpfrmtwo($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('hpfrmtwo',array('hpfrmtwo' => $mnarrm));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function inserthousepropfrmthreeAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $addr      = $this->request->getPost('steptwofrmthreehaal', array('striptags', 'trim'));
                $twn       = $this->request->getPost('steptwofrmthreehatc', array('striptags', 'trim'));
                $state     = $this->request->getPost('steptwofrmthreehastate', array('striptags', 'trim'));
                $pin       = $this->request->getPost('steptwofrmthreehapin', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($addr=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehaal','message' => 'Select address');
                    $this->response->setJsonContent($data);
                }
                else if($twn=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehatc','message' => 'Enter town');
                    $this->response->setJsonContent($data);
                }
                else if($state=='')
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehastate','message' => 'Enter state');
                    $this->response->setJsonContent($data);
                }
                else if($pin=='' || strlen($pin) != 6)
                {
                    $data = array("logged" => false,'name' => 'steptwofrmthreehapin','message' => 'Enter valid pin');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'     => $id,
                        'addr'   => $addr,
                        'twn'    => $twn,
                        'state'  => $state,
                        'pin'    => $pin
                    );

                    $getstatus = $this->incometaxcommon->inserthpfrmthree($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('hpfrmthree',array('hpfrmthree' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function inserthousepropfrmfourAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $propco  = $this->request->getPost('stepthreehppco', array('striptags', 'trim'));
                $posop   = $this->request->getPost('stepthreehposop', array('striptags', 'trim'));
                $nocop   = $this->request->getPost('stepthreehpnoco', array('striptags', 'trim'));
                $pocop   = $this->request->getPost('stepthreehppoco', array('striptags', 'trim'));
                $psocop  = $this->request->getPost('steptwopsocop', array('striptags', 'trim'));
                $arears  = $this->request->getPost('steptwoarears', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                $hptot   = $this->request->getPost('steptwohptot', array('striptags', 'trim'));
                //print_r($annual);exit;
                if($propco == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreehppco','message' => 'Select option');
                    $this->response->setJsonContent($data);
                }
                /*else if($nocop == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreehpnoco','message' => 'Enter name');
                    $this->response->setJsonContent($data);
                }
                else if($pocop == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreehppoco','message' => 'Enter pan');
                    $this->response->setJsonContent($data);
                }
                else if($psocop == '')
                {
                    $data = array("logged" => false,'name' => 'steptwopsocop','message' => 'Enter percentage');
                    $this->response->setJsonContent($data);
                }*/
                else
                {
                    $arr = array(
                        'id'      => $id,
                        'posop'   => $posop,
                        'propco'  => $propco,
                        'nocop'   => $nocop,
                        'pocop'   => $pocop,
                        'psocop'  => $psocop,
                        'arears'  => $arears,
                        'hptot'   => $hptot
                    );

                    $getstatus = $this->incometaxcommon->inserthpfrmfour($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('hpfrmfour',array('hpfrmfour' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepthreefrmipAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $fr      = $this->request->getPost('stepthreeipfr', array('striptags', 'trim'));
                $poat    = $this->request->getPost('stepthreeippoat', array('striptags', 'trim'));
                $doat    = $this->request->getPost('stepthreeipdoat', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepthreeiptot', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($fr == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreeipfr','message' => 'Enter furnishing returns');
                    $this->response->setJsonContent($data);
                }
                else if($poat == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreeippoat','message' => 'Enter Payment Of Advanced Tax');
                    $this->response->setJsonContent($data);
                }
                else if($doat == '')
                {
                    $data = array("logged" => false,'name' => 'stepthreeipdoat','message' => 'Enter Defernent Of Advanced Tax');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'   => $id,
                        'fr'   => $fr,
                        'poat' => $poat,
                        'doat' => $doat,
                        'tot'  => $tot
                    );

                    $getstatus = $this->incometaxcommon->insertipfrm($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('ipfrm',array('ipform' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }

else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmsevenitdataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $code    = $this->request->getPost('bsrcode', array('striptags', 'trim'));
                $date    = $this->request->getPost('datedep', array('striptags', 'trim'));
                $chall   = $this->request->getPost('challanno', array('striptags', 'trim'));
                $tax     = $this->request->getPost('typeoftax', array('striptags', 'trim'));
                $amt     = $this->request->getPost('itamt', array('striptags', 'trim'));
                $tot     = $this->request->getPost('itfrmtot', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($code == '')
                {
                    $data = array("logged" => false,'name' => 'bsrcode','message' => 'Enter Code');
                    $this->response->setJsonContent($data);
                }
                else if($date == '')
                {
                    $data = array("logged" => false,'name' => 'datedep','message' => 'Enter Date');
                    $this->response->setJsonContent($data);
                }
                else if($chall == '')
                {
                    $data = array("logged" => false,'name' => 'challanno','message' => 'Enter Challan');
                    $this->response->setJsonContent($data);
                }
                else if($tax == '')
                {
                    $data = array("logged" => false,'name' => 'typeoftax','message' => 'Enter Tax');
                    $this->response->setJsonContent($data);
                }
                else if($amt == '')
                {
                    $data = array("logged" => false,'name' => 'itamt','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'    => $id,
                        'code'  => $code,
                        'date'  => $date,
                        'chall' => $chall,
                        'tax'   => $tax,
                        'amt'   => $amt,
                        'tot'   => $tot
                    );

                    $getstatus = $this->incometaxcommon->insertitfrm($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('itfrm',array('itform' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepfourfrmalAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $land    = $this->request->getPost('stepfourall', array('striptags', 'trim'));
                $bldg    = $this->request->getPost('stepfouralb', array('striptags', 'trim'));
                $caih    = $this->request->getPost('stepfouralcih', array('striptags', 'trim'));
                $jbetc   = $this->request->getPost('stepfouraljb', array('striptags', 'trim'));
                $vyba    = $this->request->getPost('stepfouralvyba', array('striptags', 'trim'));
                $tot     = $this->request->getPost('stepfouraltot', array('striptags', 'trim'));
                $lira    = $this->request->getPost('stepfourallra', array('striptags', 'trim'));
                $id      = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($land == '')
                {
                    $data = array("logged" => false,'name' => 'stepfourall','message' => 'Enter Code');
                    $this->response->setJsonContent($data);
                }
                else if($bldg == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralb','message' => 'Enter Date');
                    $this->response->setJsonContent($data);
                }
                else if($caih == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralcih','message' => 'Enter Challan');
                    $this->response->setJsonContent($data);
                }
                else if($jbetc == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouraljb','message' => 'Enter Tax');
                    $this->response->setJsonContent($data);
                }
                else if($vyba == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralvyba','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else if($lira == '')
                {
                    $data = array("logged" => false,'name' => 'stepfourallra','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $arr = array(
                        'id'    => $id,
                        'land'  => $land,
                        'bldg'  => $bldg,
                        'caih'  => $caih,
                        'jbetc' => $jbetc,
                        'vyba'  => $vyba,
                        'tot'   => $tot,
                        'lira'  => $lira
                    );

                    $getstatus = $this->incometaxcommon->insertalfrm($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('alfrm',array('alform' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertstepfourfrmptiAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $nob            = $this->request->getPost('frmschnob', array('striptags', 'trim'));
                $pob            = $this->request->getPost('frmschpob', array('striptags', 'trim'));
                $hpaoi          = $this->request->getPost('frmptihpaoi', array('striptags', 'trim'));
                $hptds          = $this->request->getPost('frmptihptds', array('striptags', 'trim'));
                $staoi          = $this->request->getPost('frmptistaoi', array('striptags', 'trim'));
                $sttds          = $this->request->getPost('frmptisttds', array('striptags', 'trim'));
                $ltaoi          = $this->request->getPost('frmptiltaoi', array('striptags', 'trim'));
                $lttds          = $this->request->getPost('frmptilttds', array('striptags', 'trim'));
                $osaoi          = $this->request->getPost('frmptiosaoi', array('striptags', 'trim'));
                $ostds          = $this->request->getPost('frmptiostds', array('striptags', 'trim'));
                $ictbe          = $this->request->getPost('frmptiictbe', array('striptags', 'trim'));
                $ictbeaoi       = $this->request->getPost('frmptiictbeaoi', array('striptags', 'trim'));
                $ictbetds       = $this->request->getPost('frmptiictbetds', array('striptags', 'trim'));
                $ictbetwo       = $this->request->getPost('frmptiictbetwo', array('striptags', 'trim'));
                $ictbetwoaoi    = $this->request->getPost('frmptiictbetwoaoi', array('striptags', 'trim'));
                $ictbetwotds    = $this->request->getPost('frmptiictbetwotds', array('striptags', 'trim'));
                $ictbethree     = $this->request->getPost('frmptiictbethree', array('striptags', 'trim'));
                $ictbethreeaoi  = $this->request->getPost('frmptiictbethreeaoi', array('striptags', 'trim'));
                $ictbethreetds  = $this->request->getPost('frmptiictbethreetds', array('striptags', 'trim'));
                $id             = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                $arr = array(
                    'id'            => $id,
                    'nob'            => $nob,
                    'pob'            => $pob,
                    'hpaoi'         => $hpaoi,
                    'hptds'         => $hptds,
                    'staoi'         => $staoi,
                    'sttds'         => $sttds,
                    'ltaoi'         => $ltaoi,
                    'lttds'         => $lttds,
                    'osaoi'         => $osaoi,
                    'ostds'         => $ostds,
                    'ictbe'         => $ictbe,
                    'ictbeaoi'      => $ictbeaoi,
                    'ictbetds'      => $ictbetds,
                    'ictbetwo'      => $ictbetwo,
                    'ictbetwoaoi'   => $ictbetwoaoi,
                    'ictbetwotds'   => $ictbetwotds,
                    'ictbethree'    => $ictbethree,
                    'ictbethreeaoi' => $ictbethreeaoi,
                    'ictbethreetds' => $ictbethreetds
                );

                $getstatus = $this->incometaxcommon->insertptifrm($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('ptifrm',array('ptiform' => $arr));
                    $data = array("logged" => true,'message' => 'Data inserted');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function insertfrmschdataAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $nos        = $this->request->getPost('frmschnos', array('striptags', 'trim'));
                $pos        = $this->request->getPost('frmschpos', array('striptags', 'trim'));
                $hpir       = $this->request->getPost('frmschhpir', array('striptags', 'trim'));
                $hpaas      = $this->request->getPost('frmschhpaas', array('striptags', 'trim'));
                $atdsd      = $this->request->getPost('frmschatdsd', array('striptags', 'trim'));
                $tdsas      = $this->request->getPost('frmschtdsas', array('striptags', 'trim'));
                $osir       = $this->request->getPost('frmschosir', array('striptags', 'trim'));
                $osaahos    = $this->request->getPost('frmschosaahos', array('striptags', 'trim'));
                $osaotd     = $this->request->getPost('frmschosaotd', array('striptags', 'trim'));
                $osthos     = $this->request->getPost('frmschosthos', array('striptags', 'trim'));
                $irtot      = $this->request->getPost('frmschirtot', array('striptags', 'trim'));
                $aahos      = $this->request->getPost('frmschaahos', array('striptags', 'trim'));
                $atdoi      = $this->request->getPost('frmschatdoi', array('striptags', 'trim'));
                $tahos      = $this->request->getPost('frmschtahos', array('striptags', 'trim'));
                $id         = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                /*if($land == '')
                {
                    $data = array("logged" => false,'name' => 'stepfourall','message' => 'Enter Code');
                    $this->response->setJsonContent($data);
                }
                else if($bldg == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralb','message' => 'Enter Date');
                    $this->response->setJsonContent($data);
                }
                else if($caih == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralcih','message' => 'Enter Challan');
                    $this->response->setJsonContent($data);
                }
                else if($jbetc == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouraljb','message' => 'Enter Tax');
                    $this->response->setJsonContent($data);
                }
                else if($vyba == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralvyba','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else if($lira == '')
                {
                    $data = array("logged" => false,'name' => 'stepfourallra','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else
                {*/
                $arr = array(
                    'id'        => $id,
                    'nos'       => $nos,
                    'pos'       => $pos,
                    'hpir'      => $hpir,
                    'hpaas'     => $hpaas,
                    'atdsd'     => $atdsd,
                    'tdsas'     => $tdsas,
                    'osir'      => $osir,
                    'osaahos'   => $osaahos,
                    'osaotd'    => $osaotd,
                    'osthos'    => $osthos,
                    'irtot'     => $irtot,
                    'aahos'     => $aahos,
                    'atdoi'     => $atdoi,
                    'tahos'     => $tahos
                );

                $getstatus = $this->incometaxcommon->insertschfrm($arr);
                //print_r($getstatus);exit;
                if($getstatus){
                    $setsession = $this->session->set('schfrm',array('schform' => $arr));
                    $data = array("logged" => true,'message' => 'Data inserted');
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //}
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function userbankinfoAction()
    {
        $this->view->disable();
        //print_r($ip);exit;
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $sdo        = $this->request->getPost('steponebankfrmsdo', array('striptags', 'trim'));
                $plc        = $this->request->getPost('steponebankfrmplc', array('striptags', 'trim'));
                $tns        = $this->request->getPost('steponebankfrmts', array('striptags', 'trim'));
                $ifsc       = $this->request->getPost('steponebankfrmtbloneifsc', array('striptags', 'trim'));
                $nob        = $this->request->getPost('steponebankfrmtblonenob', array('striptags', 'trim'));
                $accno      = $this->request->getPost('steponebankfrmtbloneaccno', array('striptags', 'trim'));
                $toa        = $this->request->getPost('steponebankfrmtblonetoa', array('striptags', 'trim'));
                $ifsctwo    = $this->request->getPost('steponebankfrmtbltwoifsc', array('striptags', 'trim'));
                $nobtwo     = $this->request->getPost('steponebankfrmtbltwonob', array('striptags', 'trim'));
                $accnot     = $this->request->getPost('steponebankfrmtbltwoaccno', array('striptags', 'trim'));
                $toatwo     = $this->request->getPost('steponebankfrmtbltwotoa', array('striptags', 'trim'));
                $id         = $this->session->personalinfo['id'];
                //print_r($annual);exit;
                if($sdo == '')
                {
                    $data = array("logged" => false,'name' => 'steponebankfrmsdo','message' => 'Enter your parent name');
                    $this->response->setJsonContent($data);
                }
                else if($plc == '')
                {
                    $data = array("logged" => false,'name' => 'steponebankfrmplc','message' => 'Enter Place');
                    $this->response->setJsonContent($data);
                }
                else if($tns == '')
                {
                    $data = array("logged" => false,'name' => 'steponebankfrmts','message' => 'Enter total');
                    $this->response->setJsonContent($data);
                }
                /*else if($jbetc == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouraljb','message' => 'Enter Tax');
                    $this->response->setJsonContent($data);
                }
                else if($vyba == '')
                {
                    $data = array("logged" => false,'name' => 'stepfouralvyba','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }
                else if($lira == '')
                {
                    $data = array("logged" => false,'name' => 'stepfourallra','message' => 'Enter Amount');
                    $this->response->setJsonContent($data);
                }*/
                else
                {
                    $arr = array(
                        'id'        => $id,
                        'sdo'       => $sdo,
                        'plc'       => $plc,
                        'tns'       => $tns,
                        'ifsc'      => $ifsc,
                        'nob'       => $nob,
                        'accno'     => $accno,
                        'toa'       => $toa,
                        'ifsctwo'   => $ifsctwo,
                        'nobtwo'    => $nobtwo,
                        'accnot'    => $accnot,
                        'toatwo'    => $toatwo
                    );

                    $getstatus = $this->incometaxcommon->insertbankfrm($arr);
                    //print_r($getstatus);exit;
                    if($getstatus){
                        $setsession = $this->session->set('othrdet',array('od' => $arr));
                        $data = array("logged" => true,'message' => 'Data inserted');
                        $this->response->setJsonContent($data);
                    }
                    else{
                        $data = array("logged" => false,'message' => 'Data not inserted');
                        $this->response->setJsonContent($data);
                    }
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }

    public function getbanknameAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                //echo "<pre>";print_r($this->request->getPost());exit;
                $ifcs = $this->request->getPost('getval');
                $bankname = $this->incometaxcommon->getbankname($ifcs);
                if($bankname){
                    $data = array("logged" => true,'message' => 'Got Bank Name','data'=>$bankname);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Data not inserted');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }


    /*------------------------- Financial Year Session START (rushi)-----------------------------*/ 
    public function itrfinancialyearsessionAction()
    {
        $this->view->disable();
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $itrfinancialyear = $this->request->getPost('itrfinancialyear');
                //echo $itrfinancialyear; exit;
                
                $this->session->set('itrfy',array('itrfinancialyear'=>$itrfinancialyear));
                $itrfy = $this->session->itrfy['itrfinancialyear'];                
                //echo $itrfy; exit;
                
                if(!empty($itrfy)){
                    $data = array("logged" => true,'message' => 'Financial Year now in session','data'=>$itrfy);
                    $this->response->setJsonContent($data);
                }
                else{
                    $data = array("logged" => false,'message' => 'Failed to put Financial Year in session');
                    $this->response->setJsonContent($data);
                }
                //echo "<pre>";print_r($data);exit;
                $this->response->send();
            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    /*------------------------- Financial Year Session END (rushi)-----------------------------*/ 
    
    /*-------------------------SUMMARY TAX START (rushi)-----------------------------*/
    public function fetchdetailsofdataidAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid = $this->session->loginauthspuserfront['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                $dataid = $this->request->getPost('dataid');
                //echo $dataid; exit;

                $dataidresult = $this->incometaxcalculationcommon->detailsofdataid($getuserid,$dataid);
                //echo "<pre>";print_r($dataidresult);exit;

                if($dataidresult)
                {
                    /*foreach($dataidresult as $getarray)
                    {
                        $responsearray[] = array(
                                'id' => $getarray['id'],
                                'name' => $getarray['name']
                        );
                    }*/

                    $data = array("logged" => true,'message' => 'Got Dataid results!!!' ,'data'=> $dataidresult);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Dataid results not Found !!!');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    
    
    public function finalsummarytaxformAction()
    {
        $this->view->disable();
        $connection = $this->db;
        $getuserid  = $this->session->loginauthspuserfront['id'];

        if($this->request->isPost() == true)
        {
            //si es una petición ajax
            if($this->request->isAjax() == true)
            {
                $saveid = $this->request->getPost('saveid','trim');
                //echo $saveid; exit;
                $saltotal = $this->request->getPost('saltotal','trim');
                $hptotal = $this->request->getPost('hptotal','trim');
                $oitotal = $this->request->getPost('oitotal','trim');
                $resultfour = $this->request->getPost('resultfour','trim');
                $resultfive = $this->request->getPost('resultfive','trim');
                $resultsix = $this->request->getPost('resultsix','trim');
                $resultseven = $this->request->getPost('resultseven','trim');
                $resulteight = $this->request->getPost('resulteight','trim');
                $resultnine = $this->request->getPost('resultnine','trim');
                $resultten = $this->request->getPost('resultten','trim');
                $resulteleven = $this->request->getPost('resulteleven','trim');
                $resulttwelve = $this->request->getPost('resulttwelve','trim');
                $resultthirteen = $this->request->getPost('resultthirteen','trim');
                $resultfourteen = $this->request->getPost('resultfourteen','trim');
                $resultfifteen = $this->request->getPost('resultfifteen','trim');
                
                $taxresultone = $this->request->getPost('taxresultone','trim');
                $taxresulttwo = $this->request->getPost('taxresulttwo','trim');
                $taxresultthree = $this->request->getPost('taxresultthree','trim');
                $taxresultfour = $this->request->getPost('taxresultfour','trim');
                $taxresultfive = $this->request->getPost('taxresultfive','trim');
                $taxresultsix = $this->request->getPost('taxresultsix','trim');
                $taxresultseven = $this->request->getPost('taxresultseven','trim');
                $taxresulteight = $this->request->getPost('taxresulteight','trim');
                $taxresultnine = $this->request->getPost('taxresultnine','trim');
                $taxresultten = $this->request->getPost('taxresultten','trim');
                $taxresulteleven = $this->request->getPost('taxresulteleven','trim');
                $taxresulttwelve = $this->request->getPost('taxresulttwelve','trim');
                $taxresultthirteen = $this->request->getPost('taxresultthirteen','trim');
                
                //echo $saltotal." ".$taxresultone; exit;

                $itrfiledresult = $this->incometaxresultapicommon->finalsummarytaxresult(
                                $getuserid,$saveid,$saltotal,$hptotal,$oitotal,
                                $resultfour,$resultfive,$resultsix,$resultseven,
                                $resulteight,$resultnine,$resultten,$resulteleven,
                                $resulttwelve,$resultthirteen,$resultfourteen,$resultfifteen,
                                $taxresultone,$taxresulttwo,$taxresultthree,$taxresultfour,
                                $taxresultfive,$taxresultsix,$taxresultseven,$taxresulteight,
                                $taxresultnine,$taxresultten,$taxresulteleven,$taxresulttwelve,$taxresultthirteen);
                //echo "<pre>";print_r($itrfiledresult);exit;
                if($itrfiledresult)
                {
                    /*$itrxmlpath = $this->dompdfgen->getpdf($pdf_content,'incorp','incorporation','configincorp');
                    echo itrxmlpath; exit;*/
                    $itrxmlpath = $this->incometaxreturnxmldir;
                    //echo $itrxmlpath; exit;

                    $getreturn = $this->itrxmlgen->xmlgen($itrfiledresult,$itrxmlpath);
                    //echo $getreturn;exit;
                    if($getreturn){
                        $this->session->remove("steptwo");$this->session->remove("personalinfo");$this->session->remove("useraddress");$this->session->remove("addinfo");$this->session->remove("salinfoone");$this->session->remove("salinfotwo");$this->session->remove("otherincomeone");$this->session->remove("otherincometwo");$this->session->remove("otherincomethree");$this->session->remove("otherincomefour");$this->session->remove("otherincomefive");$this->session->remove("otherincomesix");$this->session->remove("sixafrm");$this->session->remove("cflfrm");$this->session->remove("tdsfrmone");$this->session->remove("tdsfrmtwo");$this->session->remove("tcsfrm");$this->session->remove("spifrmone");$this->session->remove("spifrmtwo");$this->session->remove("eifrm");$this->session->remove("egonefrm");$this->session->remove("egtwofrm");$this->session->remove("egthreefrm");$this->session->remove("egfourfrm");$this->session->remove("hpfrmone");$this->session->remove("hpfrmtwo");$this->session->remove("hpfrmthree");$this->session->remove("hpfrmfour");$this->session->remove("ipfrm");$this->session->remove("itfrm");$this->session->remove("alfrm");$this->session->remove("ptifrm");$this->session->remove("schfrm");$this->session->remove("othrdet");

                        $data = array("logged" => true,'message' => 'ITR Filed Successfully!!!' ,'data'=> $getreturn);
                        $this->response->setJsonContent($data);
                    }else{
                        $data = array("logged" => false,'message' => 'Problem in ITR Filing  !!!');
                        $this->response->setJsonContent($data);
                    }
                }
                else
                {
                    $data = array("logged" => false,'message' => 'Problem in ITR Filing  !!!');
                    $this->response->setJsonContent($data);
                }

                $this->response->send();
                //echo $getsearchwo;exit;
            }
            else
            {
                exit('No direct script access allowed -to this area');
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
    }
    /*-------------------------SUMMARY TAX END (rushi)------------------------------*/
    


    public function insertcompininfoAction()
    {
          //set_time_limit(200);
        $this->view->disable();
        set_time_limit(50);
        $getuserid = $this->session->loginauthspuserfront['id'];
        if($this->request->isPost() == true)
        {

            if($this->request->isAjax() == true)
            {
                $pan = $this->request->getPost('pan','trim');
                $getapipython = $this->incometaxcommon->getapipython('config_pan');
                //echo'<pre>';print_r($getapipython);exit;

                if(empty($pan))
                {
                    $data = array("logged" => false,'message' => 'No Result Found !!!');
                    $this->response->setJsonContent($data);
                }
                else
                {
                    //$getresult = $this->incometaxcommon->getpandetails($pan);
                    //echo '<pre>'; print_r($getresult); exit;
                    //$arrayget =  $getresult;
                    //echo '<pre>'; print_r($getresult); exit;
                    $arraychange = $getapipython['url']."?pan=".$pan;
                    //echo '<pre>'; print_r($arraychange); exit;

                    /*if($getresult=='notfound')
                    {*/


                    //echo '<pre>';print_r($arrayget);exit;
                    $geo = (@file_get_contents($arraychange,true));
                    //echo '<pre>';print_r($geo);exit;


                    if(!empty($geo))
                    {

                        $getarraycin = json_decode($geo, true);
                        //echo print_r($getarraycin);exit;
                        if($getarraycin['status']=='' || $getarraycin['status']==false)
                        {
                            $data = array("logged" => false,'message' => 'Please Try Again!!!');
                            $this->response->setJsonContent($data);
                        }
                            else {
                            //echo '<pre>';print_r($getarraycin);exit;
                            $getarraycin = array_change_key_case($getarraycin, CASE_LOWER);
                            //echo '<pre>';print_r($getarraycin);exit;
                            $getarraycin = $this->validationcommon->fixarraykey($getarraycin);
                            //echo '<pre>';print_r($getarraycin);exit;
                           // $getarraycin=array('aonumber'=>'tan','areacode'=>$tan);
                            //echo '<pre>';print_r($getarraycin);exit;
                            if(is_array($getarraycin))
                            {
                                $getupdate = $this->incometaxcommon->updatepan($getarraycin, $pan,$type = 'config_pan');


                                //echo $getupdate;
                                //echo '<pre>';print_r($getupdate);exit;

                                if($getupdate['status'] == 'true'){
                                    $data = array("logged" => true,'message' => 'Found!!!' ,'from' =>'api','data'=> $getarraycin,'id'=>$getupdate['id'] );
                                    $setsession = $this->session->set('pan_session',array('pan_id'=>$getupdate['id']));
                                    $this->response->setJsonContent($data);
                                }
                                else
                                {
                                    $data = array("logged" => false,'message' => 'Temporary Data could not fetch');
                                    $this->response->setJsonContent($data);
                                }
                            }
                            else
                            {
                                $data = array("logged" => false,'message' => 'Temporary Data could not fetch');
                                $this->response->setJsonContent($data);
                            }
                        }

                    }
                    else
                    {
                        $data = array("logged" => false,'message' => 'Please try again');
                        $this->response->setJsonContent($data);
                    }

                    /*}
                    else{
                        $data = array("logged" => true,'message' => 'Found!!!' ,'from'=>'db','data'=> $getresult);
                        $this->response->setJsonContent($data);
                    }*/


                }

                $this->response->send();
               // $connection->close();

            }
            else
            {
                exit('No direct script access allowed -to this area');
                $connection->close();
            }

        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }


    }

}
