<?php
class RocController extends ControllerBase
{
    public function initialize()
    {
        $getlan    = $this->elements->getTranslation();
        $this->tag->setTitle($getlan['websitetitle']);
        $this->elements->checkuserloggedin();
        $getuserid = $this->session->loginauthspuserfront['id'];
        //print_r( $this->session->loginauthsadmin);exit;
        parent::initialize();
    }

    public function indexAction()
    {
        $this->view->cin = $this->session->memberdoccin;
        $this->view->getroclist = $this->roccommon->getroclist();
        //echo '<pre>'; print_r($this->roccommon->getroclist()); exit;
    }
     public function getsearchAction()
    {
      $this->view->disable();
      if($this->request->isPost() == true)
        {
          if($this->request->isAjax() == true)
          {
              $keyword    = $this->request->getPost('getsearchwo', 'trim');
              $getsearch  = $this->roccommon->getsearch($keyword);

              if($getsearch['logged'] == true){
                  //$data = ;
                  $data = array("logged" => true,'message' => 'We got data','data'=>$getsearch['data']);
              }
              else{
                  $data = array("logged" => false,'message' => 'Problem in retrieving data','data'=>'');
              }
              $this->response->setJsonContent($data);

          }
          $this->response->send();
        }
        else
        {
          return $this->response->redirect('errors/show404');
          exit('No direct script access allowed');
        }
    }
    public function mgtxivAction(){

    }
    

    public function generaterocpdfAction()
    {
      $this->view->disable();
      $ip   = $this->request->getClientAddress();
      $devicedetect = $this->devicedetect;
      $getdevice = $devicedetect->getdeviceinfo();
      $type = 'Warning';
      $subject = 'ROC Form Expiration date Changed ';  
      $msg = 'Try to reolve Form' ; 
       // echo 'here'; exit;
      if($this->request->isPost() == true)
        {
          if($this->request->isAjax() == true)
          {
              /*$keyword    = $this->request->getPost('getsearchwo', 'trim');
              $getsearch  = $this->roccommon->getsearch($keyword);*/
              
             
              
              $hrlink           = $this->request->getPost('href_link', 'trim');
               //echo $hrlink; exit;
              $getdirectoryname = $this->session->profilecommondir['createdirname'];
                //echo $getdirectoryname; exit;
              $cin              = $this->session->memberdoccin;
                //echo $cin; exit;
              $getuserid        = $this->session->loginauthspuserfront['id'];
                //echo $getuserid; exit;
              $userdir          = $getdirectoryname;
                //echo $userdir; exit;
              
              $getrocfrm = $this->zurlfetchingcommon->getrocfrm($hrlink);
               //echo '<pre>'; print_r($getrocfrm); exit;
              $getrocfrmc = count($getrocfrm);
              //echo $getrocfrmc; exit;
              if($getrocfrmc > 0)
              {
                $dateofexp = $getrocfrm['extdate']; 
                $tdaydate = date('d-M-Y');  
                $param = 'Form Name - ' .$getrocfrm['frmname'].", "."Latest date : " .$dateofexp;
                $catname = str_replace(' ','_',$getrocfrm['frmname']);  
                
                $path = 'http://www.mca.gov.in/MCA21/dca/downloadeforms/eformTemplates/NCA/'.$catname.'.zip';
                //echo $path;exit;   
                if($tdaydate==$dateofexp || $tdaydate > $dateofexp)
                {
                    //echo $dateofexp. " " .$tdaydate;exit; 
                    $timeago = $this->timecommon->timeAgo($getrocfrm['timeago']);
                    $msg = 'Try to reolve form logic as early as possible - '.$getrocfrm['frmname'] .' , Our Last MCA databse updated about '.$timeago ;
                    $Mail = $this->emailer->companycrawler($ip,$getdevice['devicetype'],
                                                           $getdevice['useragent'],
                                                           $msg,$type,$subject,$param);
                      
                      if($Mail == true){
                          $data = array("logged" => false,'message' => 'ROC Form Changed','data'=>'Certificate Expired','path'=>$path,'frmname'=>$getrocfrm['frmname']);
                          $this->response->setJsonContent($data);
                      }
                      else
                      {
                          $data = array("logged" => false,'message' => 'Problem in sending Email','data'=>'Certificate Expired','path'=>$path,'frmname'=>$getrocfrm['frmname']);
                          $this->response->setJsonContent($data);
                      }
                }
                else
                {
                        //echo 'here'; exit;
                        $maindata = array(
                        'hrlink' => $hrlink,
                        'cin' => $cin,
                        'getuserid' => $getuserid,
                        'userdir' => $userdir,
                        );
                        $data = array("logged" => true,'message' => 'We got data','data'=>$maindata);
                        $this->response->setJsonContent($data);
                }
              }
              else
              {
                        $maindata = array(
                        'hrlink' => $hrlink,
                        'cin' => $cin,
                        'getuserid' => $getuserid,
                        'userdir' => $userdir,
                        );
                        $data = array("logged" => true,'message' => 'We got data','data'=>$maindata);
                        $this->response->setJsonContent($data);
              }
              $this->response->send();
              
          }
          
        }
        else
        {
          return $this->response->redirect('errors/show404');
          exit('No direct script access allowed');
        }
    }

    public function aocivAction()
    {
      $cin = $this->session->memberdoccin;
      $getdinpandet = $this->roccommon->getdinpandir($cin);
      //echo "<pre>";print_r($getdinpandet);exit;
      $this->view->statelist = $this->incometaxcommon->getstatelist();
      $this->view->cin = $cin;
      $this->view->dinpan = $getdinpandet;
    }

    public function getstatelistAction()
    {
      $this->view->disable();
      if($this->request->isPost() == true)
      {
        if($this->request->isAjax() == true)
        {
          $statelist = $this->incometaxcommon->getstatelist();
          $gtcnt = count($statelist);
          //echo "<pre>";print_r($getpostdata);exit;
          if($gtcnt > 0){
            $data = array("logged" => true,'message' => 'Got List','states' => $statelist);
            $this->response->setJsonContent($data);
          }
          else
          {
            $data = array("logged" => false,'message' => 'Not Got List');
            $this->response->setJsonContent($data);
          }
          $this->response->send();
        }
      }
      else
      {
        return $this->response->redirect('errors/show404');
        exit('No direct script access allowed');
      }
    }
    public function uploadexcelAction()
    {
        $this->view->disable();
        $getuserid = $this->session->loginauthspuserfront['id'];
        $cin = $this->session->memberdoccin;
        $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
        $firstname = $this->session->loginauthspuserfront['firstname'];
        $lastname = $this->session->loginauthspuserfront['lastname'];
        $timeago = time();
        //echo '<pre>';print_r($this->session->loginauthspuserfront);exit;
        $devicedetect = $this->devicedetect;
        
        if($this->request->isPost() == true)
        {
            if($this->request->isAjax() == true)
            {
                $userfile_name = $_FILES['registerexcelname']['name'];
                //echo $userfile_name;exit;
                $userfile_tmp = $_FILES['registerexcelname']['tmp_name'];
                $userfile_size = $_FILES['registerexcelname']['size'];
                $userfile_type = $_FILES['registerexcelname']['type'];
                $filename = basename($_FILES['registerexcelname']['name']);
                //echo $filename;exit;
                
                $file_ext = $this->validationcommon->getfileext($filename);
                $upload_path = $this->excelimportregisterdir."/";   
                $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid.$timeago;
                $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
                $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);

                    
                if($uploadedornot)
                {
                    $data = array("logged" => true,'message' => 'File Uploaded','return_path' => $large_impfile_location);
                    $this->response->setJsonContent($data);
                }
                else
                {
                    $data = array("logged" => false,'message' => 'File not Uploaded');
                    $this->response->setJsonContent($data);
                }                

                $this->response->send();
            
            }
            else
            {
                exit('No direct script access allowed isAjax');
            }
        }
        else
        {
            return $this->response->redirect('errors/show404');
            exit('No direct script access allowed');
        }
        
    }
    public function getaocformdataAction()
    {
      $this->view->disable();
      $ip   = $this->request->getClientAddress();
      $getuserid = $this->session->loginauthspuserfront['id'];
      $cin = $this->session->memberdoccin;
      $user_group_id = $this->session->loginauthspuserfront['user_group_id'];
      $firstname = $this->session->loginauthspuserfront['firstname'];
      $lastname = $this->session->loginauthspuserfront['lastname'];
      $timeago = time();
       // echo 'here'; exit;
      if($this->request->isPost() == true)
      {
        if($this->request->isAjax() == true)
        {
          $userfile_name = $_FILES['abhishek']['name'];
          //echo $userfile_name;exit;
          $userfile_tmp = $_FILES['abhishek']['tmp_name'];
          $userfile_size = $_FILES['abhishek']['size'];
          $userfile_type = $_FILES['abhishek']['type'];
          $filename = basename($_FILES['abhishek']['name']);
          //echo $filename;exit;
          
          $file_ext = $this->validationcommon->getfileext($filename);
          $upload_path = $this->excelimportregisterdir."/";   
          $large_imp_name = 'uploadedby-'.$firstname.'_'.$lastname.'_group_id-'.$user_group_id.'_userid-'.$getuserid.$timeago;
          $large_impfile_location = $upload_path.$large_imp_name.".".$file_ext;
          $uploadedornot = move_uploaded_file($userfile_tmp, $large_impfile_location);
          echo $large_impfile_location;exit;
          if($Mail == true){
            $data = array("logged" => true,'message' => 'ROC Form Changed');
            $this->response->setJsonContent($data);
          }
          else
          {
            $data = array("logged" => false,'message' => 'Problem in sending Email');
            $this->response->setJsonContent($data);
          }
          $this->response->send();
        }
      }
      else
      {
        return $this->response->redirect('errors/show404');
        exit('No direct script access allowed');
      }
    } 

    public function getdirectordataAction()
    {
      $this->view->disable();
      if($this->request->isPost() == true)
      {
        if($this->request->isAjax() == true)
        {
          $dinpan = $this->request->getPost('dinpan');
          $cin = $this->request->getPost('cin');
          $getdirdata = $this->roccommon->getdirectordata($dinpan,$cin);
          //echo "<pre>";print_r($getdirdata);exit;
          if($getdirdata){
            $data = array("logged" => true,'message' => 'Got Director Details','data' => $getdirdata);
            $this->response->setJsonContent($data);
          }
          else
          {
            $data = array("logged" => false,'message' => 'No Director Details');
            $this->response->setJsonContent($data);
          }
          $this->response->send();
        }
      }
      else
      {
        return $this->response->redirect('errors/show404');
        exit('No direct script access allowed');
      }
    }  

    public function getcincompdataAction()
    {
      $this->view->disable();
      if($this->request->isPost() == true)
      {
        if($this->request->isAjax() == true)
        {
          $cin = $this->request->getPost('cin');
          $getcompname = $this->roccommon->getcincompdata($cin);
          //echo "<pre>";print_r($getcompname);exit;
          if($getcompname){
            $data = array("logged" => true,'message' => 'Got Company Details','name' => $getcompname[0]['company_name']);
            $this->response->setJsonContent($data);
          }
          else
          {
            $data = array("logged" => false,'message' => 'No Company Details');
            $this->response->setJsonContent($data);
          }
          $this->response->send();
        }
      }
      else
      {
        return $this->response->redirect('errors/show404');
        exit('No direct script access allowed');
      }
    }
    // Activate Function For Excel Functionality
    /*public function saveformtogenxmlAction()
    {
      $getresponse = $this->phpimportexpogen->importfileforaoc();
    }*/

}
